/************************************************************************
 *
 * std.h
 *
 ************************************************************************
 *
 * standard main include
 *
 ************************************************************************/

#ifndef STD_H_INCLUDED
#define STD_H_INCLUDED

// ensure a valid platform is defined
#undef PLATFORM_DEFINED
#ifdef WIN32
	#define PLATFORM_DEFINED
#endif
#ifdef LINUX
	#undef LINUX
	#define LINUX
#endif
#ifdef __linux__
	#define LINUX
	#define PLATFORM_DEFINED
#endif
#ifdef MAC_BSD
	#define PLATFORM_DEFINED
#endif

#ifndef PLATFORM_DEFINED
#error No Platform Defined!!!
#endif

/*
 * includes
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <math.h>

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif

/*
 * defines
 */

#ifdef WIN32
#	define SPLOG				log_spoon
#else
#	define SPLOG(FMT,ARG...)	log_spoon(FMT,##ARG)
#endif // WIN32

#ifdef _DEBUG
#undef DEBUG
#define DEBUG
#endif

#ifdef ASSERT // conflicts in windows MFC app
#undef ASSERT
#endif

#ifdef DEBUG
#define ASSERT(x) { if(!(x)) { printf("Assert failed: %s [%d]\n",__FILE__,__LINE__); exit(1); } }
#else
#define ASSERT(x)
#endif

#define MOD(x,y) (((int32)(x)<0)?  ((y)+((int32)(x)%(y))) : ((x) % (y)))

/*
 * typedefs
 */

typedef unsigned long	uint32;
typedef unsigned short	uint16;
typedef unsigned char	uint8;
typedef unsigned char	byte;

typedef signed long	int32;
typedef signed short	int16;
typedef signed char	int8;

typedef signed long	err32;

typedef signed char	bool8;

typedef void*		phandle;

/*
 * structures/classes
 */

/*
 * globals
 */

/*
 * prototypes
 */

void log_spoon(char *fmt, ...);


#endif
