/************************************************************************
 *
 * copyup.h
 *
 ************************************************************************
 *
 * video copyup
 *
 ************************************************************************/

#ifndef COPYUP_H_INCLUDED
#define COPYUP_H_INCLUDED

/*
 * includes
 */

#include "std.h"

/*
 * defines
 */

#define CM_LINEAR			0x00
#define CM_TILEDSCALED			0x01
#define CM_TILEDSCALED_INTERLACED	0x02
#define CM_TILEDSCALED256		0x03
#define CM_TILEDSCALED256_INTERLACED	0x04
#define CM_TILED			0x05
#define CM_TILED_LOCKED			0x06

#define COL_COLOUR			0x00
#define COL_BW				0x01

/*
 * structures/classes
 */

class CAsmScreenCopyArgs
{
public:
	uint32		specAttSrc;
	uint32		specBmpSrc;
	uint32		gbaDest;
	uint32		attTable;
	uint32		bmpTable;
	uint32		colCount;
	uint32		lineCount;
};

/*
 * globals
 */

extern uint32	AsmCopyScreenLinearStart,AsmCopyScreenLinearEntry,AsmCopyScreenLinearEnd;
extern uint32	AsmCopyScreenTiledScaledStart,AsmCopyScreenTiledScaledEntry,AsmCopyScreenTiledScaledEnd;
extern uint32	AsmCopyScreenTiledStart,AsmCopyScreenTiledEntry,AsmCopyScreenTiledEnd;
extern uint32	AsmCopyScreenTiledScaled256Start,AsmCopyScreenTiledScaled256Entry,AsmCopyScreenTiledScaled256End;

extern uint32	acstssm1,acstssm2;
extern int32	copyupMode;

/*
 * prototypes
 */

extern void		CopyupInit(void);
extern void		CopyupSetMode(int32 mode);
extern void		DoCopyup(void);
extern void		DoThirdCopyup(int32 which);

#endif
