@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ copyup.s
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ ZX screen to GBA screen copyup routines
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

@class CAsmScreenCopyArgs
@{
@public:
@	uint32		specAttSrc;
@	uint32		specBmpSrc;
@	uint32		gbaDest;
@	uint32		attTable;
@	uint32		bmpTable;
@	uint32		colCount;
@	uint32		lineCount;
@};

.equ	OFFSET_SPECATTSRC,		0x00
.equ	OFFSET_SPECBMPSRC,		0x04
.equ	OFFSET_GBADEST,			0x08
.equ	OFFSET_ATTTABLE,		0x0C
.equ	OFFSET_BMPTABLE,		0x10
.equ	OFFSET_COLCOUNT,		0x14
.equ	OFFSET_LINECOUNT,		0x18

		.text
		.code 32
		.align


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ AsmCopyScreenLinear
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

		.global		AsmCopyScreenLinearStart
AsmCopyScreenLinearStart:

parms:		.space		4
retAddr:	.space		4
regBkp:		.space		32

		.global		AsmCopyScreenLinearEntry
AsmCopyScreenLinearEntry:

		@ backup registers
		str	r1,retAddr
		adr	r1,regBkp
		stmia	r1,{r8-r14}


		@ fetch parameters
		ldr	r14,parms			@ get ptr to structure
		ldr	r0,[r14,#OFFSET_SPECBMPSRC]	@ bitmap source
		ldr	r1,[r14,#OFFSET_SPECATTSRC]	@ attribute source
		ldr	r7,[r14,#OFFSET_GBADEST]	@ GBA VRAM destination
		ldr	r12,[r14,#OFFSET_BMPTABLE]	@ byte -> exploded #80's dword pair
		ldr	r11,[r14,#OFFSET_COLCOUNT]	@ column count
		ldr	r14,[r14,#OFFSET_LINECOUNT]
		
xloopx:		ldrb	r2,[r1],#1			@ get attr
		add	r13,r7,#8			@ prepare next dest (8 pels along)
		add	r8,r0,#1			@ prepare next bmp src (1 byte along)
		and	r2,r2,#0x7F			@ r2=0BPPPIII
		mov	r3,r2,lsl#8
		orr	r2,r2,r3
		mov	r3,r2,lsl#16
		orr	r2,r2,r3			@ r2=0BPPPIII:0BPPPIII:0BPPPIII:0BPPPIII

		mov	r6,r14

		tsts	r6,#1
		beq	yloopy

		@ unrolled!
		ldrb	r4,[r0],#256		@ fetch bitmap byte, advance to next row
		add	r4,r12,r4,lsl#3		@ x 8 bytes (2 dwords) + table base
		ldr	r5,[r4],#4		@ read dwords
		ldr	r4,[r4]
		orr	r5,r2,r5
		str	r5,[r7],#4
		orr	r4,r2,r4
		str	r4,[r7],#(240-4)
		subs	r6,r6,#1		@ do <n> lines
		beq	done

yloopy:		ldrb	r4,[r0],#256		@ fetch bitmap byte, advance to next row
		add	r4,r12,r4,lsl#3		@ x 8 bytes (2 dwords) + table base
		ldr	r5,[r4],#4		@ read dwords
		ldr	r4,[r4]
		orr	r5,r2,r5
		str	r5,[r7],#4
		orr	r4,r2,r4
		str	r4,[r7],#(240-4)
		ldrb	r4,[r0],#256		@ fetch bitmap byte, advance to next row
		add	r4,r12,r4,lsl#3		@ x 8 bytes (2 dwords) + table base
		ldr	r5,[r4],#4		@ read dwords
		ldr	r4,[r4]
		orr	r5,r2,r5
		str	r5,[r7],#4
		orr	r4,r2,r4
		str	r4,[r7],#(240-4)
		subs	r6,r6,#2		@ do <n> lines
		bne	yloopy

done:

		@ move up
		mov	r0,r8			@ r8=old r0+1
		mov	r7,r13			@ r7=old r7+8
		subs	r11,r11,#1		@ keep going
		bne	xloopx

return:

		adr	r1,regBkp
		ldmia	r1,{r8-r14}
		ldr	r1,retAddr
		bx	r1

		.global		AsmCopyScreenLinearEnd
AsmCopyScreenLinearEnd:

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ AsmCopyScreenTiledScaled
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

		.global		AsmCopyScreenTiledScaledStart
AsmCopyScreenTiledScaledStart:

parms2:		.space		4
retAddr2:	.space		4
regBkp2:	.space		32

		.global		AsmCopyScreenTiledScaledEntry
AsmCopyScreenTiledScaledEntry:

		.global		acstssm1
		.global		acstssm2


		@ backup registers
		str	r1,retAddr2
		adr	r1,regBkp2
		stmia	r1,{r8-r14}

		@ fetch parameters
		ldr	r14,parms2			@ get ptr to structure
		ldr	r1,[r14,#OFFSET_SPECBMPSRC]	@ bitmap source
		ldr	r2,[r14,#OFFSET_SPECATTSRC]	@ attribute source
		ldr	r3,[r14,#OFFSET_GBADEST]	@ GBA VRAM destination
		ldr	r4,[r14,#OFFSET_BMPTABLE]	@ byte -> exploded nibbles
		ldr	r6,[r14,#OFFSET_ATTTABLE]	@ attribute-> INK*8
		ldr	r5,[r14,#OFFSET_COLCOUNT]	@ column count

		add	r8,r4,#1024			@ second half of byte table is PAPER values

		@ repeat for each column
xloop:		mov	r11,#8				@ 8 character cells

		@ repeat for each cell (x8)
y_cell_lp:	ldrb	r13,[r2],#32			@ fetch attribute, advance to next row
		ldr	r12,[r6,r13,lsl#2]		@ fetch INK nibbles
		ldr	r13,[r8,r13,lsl#2]		@ fetch PAPER nibbles

		@ unrolled loop for processing one cell (7-vertical lines)
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
acstssm1:	ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
acstssm2:	ldrb	r10,[r1],#512			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr


		@ need to move spectrum byte back to correct position (move down 8 pels)
		sub	r1,r1,#(256*8)
		add	r1,r1,#32

		@ keep going?
		subs	r11,r11,#1
		bne	y_cell_lp


		@ advance to next column - need to fix up ptrs
		sub	r1,r1,#255			@ it's advanced 32*8=256, we want +1...
		sub	r2,r2,#255			@ same for attributes

		@ we can leave r3 where it is provided our tile layout is correct
		@ just repeat for each column
		subs	r5,r5,#1
		bne	xloop

		@ we're done
return2:
		adr	r1,regBkp2
		ldmia	r1,{r8-r14}
		ldr	r1,retAddr2
		bx	r1

		.global		AsmCopyScreenTiledScaledEnd
AsmCopyScreenTiledScaledEnd:

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ AsmCopyScreenTiledScaled256
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

		.global		AsmCopyScreenTiledScaled256Start
AsmCopyScreenTiledScaled256Start:

parms3:		.space		4
retAddr3:	.space		4
regBkp3:	.space		32

		.global		AsmCopyScreenTiledScaled256Entry
AsmCopyScreenTiledScaled256Entry:

		@ backup registers
		str	r1,retAddr3
		adr	r1,regBkp3
		stmia	r1,{r8-r14}

		@ fetch parameters
		ldr	r14,parms3			@ get ptr to structure
		ldr	r0,[r14,#OFFSET_SPECBMPSRC]	@ bitmap source
		ldr	r1,[r14,#OFFSET_SPECATTSRC]	@ attribute source
		ldr	r7,[r14,#OFFSET_GBADEST]	@ GBA VRAM destination
		ldr	r12,[r14,#OFFSET_BMPTABLE]	@ byte -> exploded #80's dword pair
		ldr	r11,[r14,#OFFSET_COLCOUNT]	@ column count
		ldr	r14,[r14,#OFFSET_LINECOUNT]
		
xloopx2:	
		mov	r6,r14
yloopy2:
		ldrb	r2,[r1],#32			@ get attr, move to next cell
		and	r2,r2,#0x7F			@ r2=0BPPPIII
		mov	r3,r2,lsl#8
		orr	r2,r2,r3
		mov	r3,r2,lsl#16
		orr	r2,r2,r3			@ r2=0BPPPIII:0BPPPIII:0BPPPIII:0BPPPIII

		@ unrolled! - 8 pels
		ldrb	r4,[r0],#256		@ fetch bitmap byte, advance to next row
		add	r4,r12,r4,lsl#3		@ x 8 bytes (2 dwords) + table base
		ldr	r5,[r4],#4		@ read dwords
		ldr	r4,[r4]
		orr	r5,r2,r5
		str	r5,[r7],#4
		orr	r4,r2,r4
		str	r4,[r7],#4
		ldrb	r4,[r0],#256		@ fetch bitmap byte, advance to next row
		add	r4,r12,r4,lsl#3		@ x 8 bytes (2 dwords) + table base
		ldr	r5,[r4],#4		@ read dwords
		ldr	r4,[r4]
		orr	r5,r2,r5
		str	r5,[r7],#4
		orr	r4,r2,r4
		str	r4,[r7],#4
		ldrb	r4,[r0],#256		@ fetch bitmap byte, advance to next row
		add	r4,r12,r4,lsl#3		@ x 8 bytes (2 dwords) + table base
		ldr	r5,[r4],#4		@ read dwords
		ldr	r4,[r4]
		orr	r5,r2,r5
		str	r5,[r7],#4
		orr	r4,r2,r4
		str	r4,[r7],#4
		ldrb	r4,[r0],#256		@ fetch bitmap byte, advance to next row
		add	r4,r12,r4,lsl#3		@ x 8 bytes (2 dwords) + table base
		ldr	r5,[r4],#4		@ read dwords
		ldr	r4,[r4]
		orr	r5,r2,r5
		str	r5,[r7],#4
		orr	r4,r2,r4
		str	r4,[r7],#4
		ldrb	r4,[r0],#256		@ fetch bitmap byte, advance to next row
		add	r4,r12,r4,lsl#3		@ x 8 bytes (2 dwords) + table base
		ldr	r5,[r4],#4		@ read dwords
		ldr	r4,[r4]
		orr	r5,r2,r5
		str	r5,[r7],#4
		orr	r4,r2,r4
		str	r4,[r7],#4
		ldrb	r4,[r0],#256		@ fetch bitmap byte, advance to next row
		add	r4,r12,r4,lsl#3		@ x 8 bytes (2 dwords) + table base
		ldr	r5,[r4],#4		@ read dwords
		ldr	r4,[r4]
		orr	r5,r2,r5
		str	r5,[r7],#4
		orr	r4,r2,r4
		str	r4,[r7],#4
		ldrb	r4,[r0],#256		@ fetch bitmap byte, advance to next row
		add	r4,r12,r4,lsl#3		@ x 8 bytes (2 dwords) + table base
		ldr	r5,[r4],#4		@ read dwords
		ldr	r4,[r4]
		orr	r5,r2,r5
		str	r5,[r7],#4
		orr	r4,r2,r4
		str	r4,[r7],#4
		ldrb	r4,[r0],#256		@ fetch bitmap byte, advance to next row
		add	r4,r12,r4,lsl#3		@ x 8 bytes (2 dwords) + table base
		ldr	r5,[r4],#4		@ read dwords
		ldr	r4,[r4]
		orr	r5,r2,r5
		str	r5,[r7],#4
		orr	r4,r2,r4
		str	r4,[r7],#4

		@ move on to next tile (source)
		sub	r0,r0,#2048
		add	r0,r0,#32

		@ do 8 of 'em...
		subs	r6,r6,#1
		bne	yloopy2

		@ move back
		sub	r0,r0,#255		@ subtract 256, add 1
		sub	r1,r1,#255		@ same for attributes
		subs	r11,r11,#1		@ dec x ctr
		bne	xloopx2

		@ we're done
return3:	adr	r1,regBkp3
		ldmia	r1,{r8-r14}
		ldr	r1,retAddr3
		bx	r1

		.global		AsmCopyScreenTiledScaled256End
AsmCopyScreenTiledScaled256End:

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@ AsmCopyScreenTiled
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

		.global		AsmCopyScreenTiledStart
AsmCopyScreenTiledStart:

parms4:		.space		4
retAddr4:	.space		4
regBkp4:	.space		32

		.global		AsmCopyScreenTiledEntry
AsmCopyScreenTiledEntry:

		.global		acstssm1
		.global		acstssm2


		@ backup registers
		str	r1,retAddr4
		adr	r1,regBkp4
		stmia	r1,{r8-r14}

		@ fetch parameters
		ldr	r14,parms4			@ get ptr to structure
		ldr	r1,[r14,#OFFSET_SPECBMPSRC]	@ bitmap source
		ldr	r2,[r14,#OFFSET_SPECATTSRC]	@ attribute source
		ldr	r3,[r14,#OFFSET_GBADEST]	@ GBA VRAM destination
		ldr	r4,[r14,#OFFSET_BMPTABLE]	@ byte -> exploded nibbles
		ldr	r6,[r14,#OFFSET_ATTTABLE]	@ attribute-> INK*8
		ldr	r5,[r14,#OFFSET_COLCOUNT]	@ column count

		add	r8,r4,#1024			@ second half of byte table is PAPER values

		@ repeat for each column
xloop4:		mov	r11,#8				@ 8 character cells

		@ repeat for each cell (x8)
y_cell_lp4:	ldrb	r13,[r2],#32			@ fetch attribute, advance to next row
		ldr	r12,[r6,r13,lsl#2]		@ fetch INK nibbles
		ldr	r13,[r8,r13,lsl#2]		@ fetch PAPER nibbles

		@ unrolled loop for processing one cell (7-vertical lines)
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr
		ldrb	r10,[r1],#256			@ fetch spectrum byte
		ldr	r10,[r4,r10,lsl#2]		@ convert to exploded nibbles
		mvn	r9,r10				@ copy and invert
		and	r10,r10,r12			@ generate INK data
		and	r9,r9,r13			@ generate PAPER data
		orr	r10,r10,r9			@ OR them
		str	r10,[r3],#4			@ write data, advance ptr


		@ need to move spectrum byte back to correct position (move down 8 pels)
		sub	r1,r1,#(256*8)
		add	r1,r1,#32

		@ keep going?
		subs	r11,r11,#1
		bne	y_cell_lp4


		@ advance to next column - need to fix up ptrs
		sub	r1,r1,#255			@ it's advanced 32*8=256, we want +1...
		sub	r2,r2,#255			@ same for attributes

		@ we can leave r3 where it is provided our tile layout is correct
		@ just repeat for each column
		subs	r5,r5,#1
		bne	xloop4

		@ we're done
		adr	r1,regBkp4
		ldmia	r1,{r8-r14}
		ldr	r1,retAddr4
		bx	r1

		.global		AsmCopyScreenTiledEnd
AsmCopyScreenTiledEnd:

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@
@
@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

		.end
