/***********************************************************************
 *
 * font.cpp
 *
 ***********************************************************************
 *
 * font drawing code
 *
 ***********************************************************************/

/*
 * includes
 */

#include "std.h"
#include "font.h"
#include "fontdata.h"

/*
 * defines
 */

/*
 * typedefs
 */

/*
 * structs
 */

/*
 * globals
 */

char fontLetters[]="ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789=+-.,!:;\" ";

byte crapFontData[]={
   0x30,0x78,0xcc,0xcc,0xfc,0xcc,0xcc,0x00,
   0xf8,0xcc,0xcc,0xf8,0xcc,0xcc,0xf8,0x00,
   0x78,0xcc,0xcc,0xc0,0xc0,0xcc,0x78,0x00,
   0xf0,0xd8,0xcc,0xcc,0xcc,0xd8,0xf0,0x00,
   0xfc,0xc0,0xc0,0xf8,0xc0,0xc0,0xfc,0x00,
   0xfc,0xc0,0xc0,0xf8,0xc0,0xc0,0xc0,0x00,
   0x78,0xcc,0xcc,0xc0,0xdc,0xcc,0x7c,0x00,
   0xcc,0xcc,0xcc,0xfc,0xcc,0xcc,0xcc,0x00,
   0x78,0x30,0x30,0x30,0x30,0x30,0x78,0x00,
   0x0c,0x0c,0x0c,0x0c,0x0c,0xcc,0x78,0x00,
   0xcc,0xcc,0xd8,0xf0,0xd8,0xcc,0xcc,0x00,
   0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xfc,0x00,
   0xc6,0xc6,0xee,0xd6,0xd6,0xc6,0xc6,0x00,
   0xc6,0xc6,0xe6,0xde,0xce,0xc6,0xc6,0x00,
   0x78,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,
   0xf8,0xcc,0xcc,0xf8,0xc0,0xc0,0xc0,0x00,
   0x78,0xcc,0xcc,0xcc,0xcc,0xec,0x78,0x1c,
   0xf8,0xcc,0xcc,0xf8,0xd8,0xcc,0xcc,0x00,
   0x78,0xcc,0xc0,0x30,0x18,0xcc,0x78,0x00,
   0xfc,0x30,0x30,0x30,0x30,0x30,0x30,0x00,
   0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x00,
   0xcc,0xcc,0xcc,0xcc,0xcc,0x78,0x30,0x00,
   0xc6,0xc6,0xc6,0xd6,0xd6,0x6c,0x6c,0x00,
   0xcc,0xcc,0x68,0x30,0x58,0xcc,0xcc,0x00,
   0xcc,0xcc,0xcc,0x78,0x30,0x30,0x30,0x00,
   0xfc,0x0c,0x0c,0x30,0x60,0xc0,0xfc,0x00,
   0x3c,0x66,0x6e,0x66,0x76,0x66,0x3c,0x00,
   0x18,0x38,0x18,0x18,0x18,0x18,0x18,0x00,
   0x78,0xcc,0x0c,0x18,0x60,0xc0,0xfc,0x00,
   0x78,0xcc,0x0c,0x38,0x0c,0xcc,0x78,0x00,
   0x60,0x60,0x6c,0x6c,0x7e,0x0c,0x0c,0x00,
   0xfc,0xc0,0xc0,0xf8,0x0c,0x18,0xf0,0x00,
   0x38,0x60,0xf8,0xcc,0xcc,0xcc,0x78,0x00,
   0xfc,0x0c,0x18,0x30,0x60,0x60,0x60,0x00,
   0x78,0xcc,0xec,0x78,0xcc,0xcc,0x78,0x00,
   0x78,0xcc,0xcc,0x7c,0x18,0x30,0x60,0x00,
   0x00,0x00,0x7e,0x00,0x00,0x7e,0x00,0x00,
   0x00,0x00,0x30,0xfc,0x30,0x00,0x00,0x00,
   0x00,0x00,0x00,0xfc,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x38,0x38,0x00,
   0x00,0x00,0x00,0x38,0x38,0x18,0x30,0x00,
   0x30,0x78,0x78,0x30,0x00,0x30,0x30,0x00,
   0x00,0x30,0x00,0x00,0x30,0x00,0x00,0x00,
   0x00,0x18,0x00,0x00,0x18,0x18,0x30,0x00,
   0xcc,0xcc,0x00,0x00,0x00,0x00,0x00,0x00,
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

/*
 * function prototypes
 */

void		DrawChar(byte *data,int32 x,int32 y,byte *base,uint16 col);

/*
 * code
 */


/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void DrawString(char *s,int32 x,int32 y,bool page,byte col)
{
	int32		i,j;
	byte		*base;

	base=(byte *)0x06000000 + (page?0xa000:0);

	for(i=0;s[i];i++)
	{
		j=s[i];
#if 0
		int32		k;
		if(j>='a' && j<='z')	j-=32;
		for(k=0;fontLetters[k];k++)
		{
			if(fontLetters[k]==j)
			{
				DrawChar(&crapFontData[k*8],x,y,base,col);
				break;
			}
		}
#else
		extern byte specRom[];
		DrawChar(&specRom[15616+(j-32)*8],x,y,base,col);
#endif
		x+=8;
	}
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void DrawChar(byte *data,int32 x,int32 y,byte *base,uint16 col)
{
	int32		i,j,k,l;
	uint16		*w;

	x>>=1;
	w=(uint16*)(&base[y*240+x*2]);

	for(i=0;i<8;i++)
	{
		j=*(data++);
		l=192;
		for(k=0;k<4;k++)
		{
			if(x>=0 && x<120 && y>=0 && y<160)
			{
				if((j&l)==0)
				{
//
					*(w)=0;
				}
				else if((j&l)==64)
				{
//					*(w)=((*w) & 0xFF) | (col<<8);
					*(w)=(col<<8);
				}
				else if((j&l)==128)
				{
//					*(w)=((*w) & 0xFF00) | (col);
					*(w)=(col);
				}
				else if((j&l)==192)
				{
					*(w)=(col<<8)|col;
				}
			}
			j<<=2;
			x++;
			w++;
		}
		x-=4;
		y++;
		w+=(120-4);
	}
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void IntToStr(int32 i,char *s)
{
	int32		k;

	if(i<0)
	{
		*(s++)='-';
		i=-i;
	}

	for(k=1;(i/k)>9;k=k*10);
	while(k)
	{
		*(s++)='0' + (i/k);
		i-=(i/k)*k;
		k/=10;
	}
	*s=0;
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void HexToStr(uint32 i,char *s)
{
	int32		k,l;

	for(k=7;k>=0;k--)
	{
		l=(i>>(k*4)) & 0xF;
		if(l>9) l+=7;
		l+='0';
		*(s++)=l;
	}
	*s=0;
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void DrawHex(int32 v,int32 x,int32 y,int32 pg,int32 col)
{
	char	tmp[16];
	HexToStr(v,tmp);
	DrawString(&tmp[4],x,y,(byte)pg,(byte)col);
}
void DrawHexLong(int32 v,int32 x,int32 y,int32 pg,int32 col)
{
	char	tmp[16];
	HexToStr(v,tmp);
	DrawString(tmp,x,y,(byte)pg,(byte)col);
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

int32 DrawNiceChar(char c,int32 x,int32 y,int32 pg,int32 col)
{
	int32		i,j,k;
	byte		*p,*w;
	CFontChar	*ch;
	uint16		v;
	byte		q;

	ch=&fontChars[(byte)(c-' ')];
	k=ch->sx;
	if(k&1) k++;

	y-=ch->base;

	p=(byte*)ch->data;
	w=(byte*)(0x06000000 + y*240 + x + pg*0xA000);
	for(i=0;i<ch->sy;i++)
	{
		for(j=0;j<k;j++)
		{
			q=*(p++);
			if(q)
			{
				q+=col;

				if(((uint32)w) & 1)
				{
					v=*((uint16*)(w-1));
					v&=0x00FF;
					v|=((uint16)(q))<<8;
					*((uint16*)(w-1))=v;
				}
				else
				{
					v=*((uint16*)(w));
					v&=0xFF00;
					v|=((uint16)(q));
					*((uint16*)(w))=v;
				}
			}
			w++;
		}
		w-=k;
		w+=240;
	}

	return(ch->sx+1);
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void DrawNiceString(char *s,int32 x,int32 y,int32 pg,int32 col)
{
	int32		i;

	while(*s)
	{
		i=DrawNiceChar(*s,x,y,pg?1:0,col);
		x+=i;
		s++;
	}
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

int32 GetNiceStringLen(char *s)
{
	int32		i,x;

	x=0;
	while(*s)
	{
		i=fontChars[(*s)-' '].sx;
		x+=i+1;
		s++;
	}
	return(x);
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

