/************************************************************************
 *
 * shell.cpp
 *
 ************************************************************************
 *
 * horrible, horrible menu system
 *
 ************************************************************************/

/*
 * includes
 */

#include "shell.h"
#include "emu.h"
#include "main.h"
#include "font.h"
#include "copyup.h"
#include "gba.h"
#include "mem.h"
#include "int.h"
#include "sram.h"

#include "keyboard.cpp"

/*
 * defines
 */

#define LIMIT		6

#define FLG_CANCEL	1
#define FLG_LOOP	2

#define REPT_LONG	60
#define REPT_SHORT	5

/*
 * structures/classes
 */

/*
 * globals
 */

int32	musicBuffer,musicPtr;

char	selCancelString[]="A=Select B=Cancel";

char*	mainMenuStrings[]={
	"Resume Game",
	"Reset Game",
	"Take Snapshot",
	"Restore Snapshot",
	"Take SRAM Snapshot",
	"Restore SRAM Snapshot",
	"Select New Game",
	"Video Options",
	"Emulation Options",
	"Insert Keypress",
	"Remap Controls",
	"Apply Poke",
	NULL
};

char*	okStrings[]=
{
	"Ok",
	NULL
};

char*	yesNoStrings[]=
{
	"Yes",
	"No",
	NULL
};

char*	videoOptionStrings[]=
{
	"Choose Video Mode",
	"Colour / BW",
	"Brightness",
	"Frameskip",
	NULL,
};
char*	videoModeStrings[]=
{
	"VScale (Fastest)",
	"VScale w/ Interlace",
	"VScale/HScale (Slowest)",
	"Unscaled-Scrollable",
	"Unscaled-Locked",
	NULL,
};
int32	videoModes[]={ CM_TILEDSCALED, CM_TILEDSCALED_INTERLACED, CM_TILEDSCALED256, CM_TILED, CM_TILED_LOCKED, -1 };

char*	emuStrings[]=
{
	"R-Inc",
	"Screen/Int Timing",
	"Wait-State Mode",
	NULL,
};

char*	waitStrings[]=
{
	"Slow (but safe!)",
	"Fast",
	"Even Faster",
	NULL,
};

char*	rincStrings[]=
{
	"0","1","2","3","4","5","6","7","Cycle Ct/4",NULL
};

char*	scrStrings[]=
{
	"Block 0","Block 1","Block 2","Full Screen",NULL
};

char*	colourModeStrings[]=
{
	"Colour",
	"Black and White",	NULL,
};
char*	frameSkipStrings[]=
{
	"0",
	"1",
	"2",
	NULL,
};
char*	brightnessStrings[]=
{
	"Dark",
	"Medium",
	"Bright",
	NULL,
};
char*	specKeyStrings[]=
{
	"Kempston Up","Kempston Down","Kempston Left","Kempston Right","Kempston Fire","Kempston Fire 2",
	"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
	"0","1","2","3","4","5","6","7","8","9",
	"Enter","Shift","Space","Symbol Shift",NULL
};

KeyDef		keyDefs[]=
{
	{	"KU",	{	KEY_JOY,	0x1f,		0x08,		0x00	}	},
	{	"KD",	{	KEY_JOY,	0x1f,		0x04,		0x00	}	},
	{	"KL",	{	KEY_JOY,	0x1f,		0x02,		0x00	}	},
	{	"KR",	{	KEY_JOY,	0x1f,		0x01,		0x00	}	},
	{	"KF1",	{	KEY_JOY,	0x1f,		0x10,		0x00	}	},
	{	"KF2",	{	KEY_JOY,	0x1f,		0x20,		0x00	}	},
	{	"A",	{	KEY_KBD,	0x01,		0x01,		0x00	}	},
	{	"B",	{	KEY_KBD,	0x07,		0x10,		0x00	}	},
	{	"C",	{	KEY_KBD,	0x00,		0x08,		0x00	}	},
	{	"D",	{	KEY_KBD,	0x01,		0x04,		0x00	}	},
	{	"E",	{	KEY_KBD,	0x02,		0x04,		0x00	}	},
	{	"F",	{	KEY_KBD,	0x01,		0x08,		0x00	}	},
	{	"G",	{	KEY_KBD,	0x01,		0x10,		0x00	}	},
	{	"H",	{	KEY_KBD,	0x06,		0x10,		0x00	}	},
	{	"I",	{	KEY_KBD,	0x05,		0x04,		0x00	}	},
	{	"J",	{	KEY_KBD,	0x06,		0x08,		0x00	}	},
	{	"K",	{	KEY_KBD,	0x06,		0x04,		0x00	}	},
	{	"L",	{	KEY_KBD,	0x06,		0x02,		0x00	}	},
	{	"M",	{	KEY_KBD,	0x07,		0x04,		0x00	}	},
	{	"N",	{	KEY_KBD,	0x07,		0x08,		0x00	}	},
	{	"O",	{	KEY_KBD,	0x05,		0x02,		0x00	}	},
	{	"P",	{	KEY_KBD,	0x05,		0x01,		0x00	}	},
	{	"Q",	{	KEY_KBD,	0x02,		0x01,		0x00	}	},
	{	"R",	{	KEY_KBD,	0x02,		0x08,		0x00	}	},
	{	"S",	{	KEY_KBD,	0x01,		0x02,		0x00	}	},
	{	"T",	{	KEY_KBD,	0x02,		0x10,		0x00	}	},
	{	"U",	{	KEY_KBD,	0x05,		0x08,		0x00	}	},
	{	"V",	{	KEY_KBD,	0x00,		0x10,		0x00	}	},
	{	"W",	{	KEY_KBD,	0x02,		0x02,		0x00	}	},
	{	"X",	{	KEY_KBD,	0x00,		0x04,		0x00	}	},
	{	"Y",	{	KEY_KBD,	0x05,		0x10,		0x00	}	},
	{	"Z",	{	KEY_KBD,	0x00,		0x02,		0x00	}	},
	{	"0",	{	KEY_KBD,	0x04,		0x01,		0x00	}	},
	{	"1",	{	KEY_KBD,	0x03,		0x01,		0x00	}	},
	{	"2",	{	KEY_KBD,	0x03,		0x02,		0x00	}	},
	{	"3",	{	KEY_KBD,	0x03,		0x04,		0x00	}	},
	{	"4",	{	KEY_KBD,	0x03,		0x08,		0x00	}	},
	{	"5",	{	KEY_KBD,	0x03,		0x10,		0x00	}	},
	{	"6",	{	KEY_KBD,	0x04,		0x10,		0x00	}	},
	{	"7",	{	KEY_KBD,	0x04,		0x08,		0x00	}	},
	{	"8",	{	KEY_KBD,	0x04,		0x04,		0x00	}	},
	{	"9",	{	KEY_KBD,	0x04,		0x02,		0x00	}	},
	{	"EN",	{	KEY_KBD,	0x06,		0x01,		0x00	}	},
	{	"SH",	{	KEY_KBD,	0x00,		0x01,		0x00	}	},
	{	"SP",	{	KEY_KBD,	0x07,		0x01,		0x00	}	},
	{	"SYM",	{	KEY_KBD,	0x07,		0x02,		0x00	}	},
	{	NULL,	{	0,		0,		0,		0	}	},
};

char*	gbaKeyStrings[]=
{
	"Up","Down","Left","Right","A","B","1","2","SELECT",NULL
};
int32	gbaKeyCodes[]=
{
	6,7,5,4,0,1,9,8,2
};

int32		lastShellOption;
int32		videoMode;
int32		romCt;
int32		currentRom;
int32		colourMode;
int32		brightness;
int32		frameSkip;
int32		imageRinc;
int32		imageScreenMode;
int32		waitStateMode;

int32		keyCt=(sizeof(keyDefs)/sizeof(KeyDef)-1);
int32		keyPress[sizeof(keyDefs)/sizeof(KeyDef)];
byte		injectedKey;

int32		kbdRowCoords[]=
{
	15,68,	207,68,
	26,91,	218,91,
	32,113,	222,113,
	16,136,	214,136
};

int32		joyCoords[]=
{
	36,12,
	36,32,
	26,22,
	46,22,
	24,42,
	46,42,
};

int32		lastRow,lastCol;

#define JOY_X	(196-26)
#define JOY_Y	(15-22)

int32		joyJumps[]=
{
	-3,	1,	2,	3,
	0,	4,	2,	3,
	0,	1,	3,	3,
	0,	1,	2,	2,
	1,	-2,	5,	5,
	1,	-2,	4,	4,
};

/*
 * prototypes
 */

void		Rect(int32 x,int32 y,int32 w,int32 h,int32 pg,int32 col);
int32		GetMenuChoice(char *title,char **strings,int32 def,char *cap,uint32 flg);
Header*		GetRom(int32 which);
int32		SelectImage(void);
int32		GetSpectrumKey(int32 def);
void		SetShellPalette(void);
void		MusicPoll(void);
void		MusicSilence(void);
int32		GetPoke(int32 *pad,int32 *pval,char *title,char *cap);
int32		GetKey(int32 def);

/*
 * code
 */

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void DoShell(void)
{
	int32		i,j,k,l;
	Header		*h;

	// slow down audio
	*((uint16*)(REG_BASE+0x100))=65536-(1049*2);
	*((uint16*)(REG_BASE+0x104))=65536-(AUDIO_SAMPLESPERFRAME*4);

	// initialise video mode for shell
	for(i=0;i<79360;i+=4)	*((uint32*)(VRAM+i))=0;
	*(uint16 *)REG_LCD = LCD_MODE4 | LCD_BG2_EN;
	*(uint16 *)(REG_BASE+0x020) = 0x0100;	// horiz scale
	*(uint16 *)(REG_BASE+0x026) = 0x0100;	// vert scale
	*(uint16 *)(REG_BASE+0x010) = 0x0000;	// horiz scrolling!
	*(uint16 *)(REG_BASE+0x012) = 0x0000;	// vert scrolling

	// set palette
	SetShellPalette();
	j=lastShellOption;
	while(1)
	{
		j=GetMenuChoice("FooN Pause Menu",mainMenuStrings,j,"\177 2001 Strags Research Ltd",FLG_CANCEL | FLG_LOOP);
		if(j!=-1) lastShellOption=j;
		switch(j)
		{
		case -1:
		case 0:
			goto done;
			break;
		case 1:
			i=GetMenuChoice("Are you sure?",yesNoStrings,1,"",FLG_CANCEL);
			if(i)	break;
			h=GetRom(currentRom);
			EmuLoadZ80(h,false);
			goto done;
		case 2:
			i=GetMenuChoice("Are you sure?",yesNoStrings,1,"",FLG_CANCEL);
			if(i)	break;
			EmuBackup();
			GetMenuChoice("Snapshot Taken",okStrings,0,"",FLG_CANCEL);
			break;
		case 3:
			i=GetMenuChoice("Are you sure?",yesNoStrings,1,"",FLG_CANCEL);
			if(i)	break;
			EmuRestore();
			GetMenuChoice("Snapshot Restored",okStrings,0,"",FLG_CANCEL);
			break;
		case 4:
			i=GetMenuChoice("Are you sure?",yesNoStrings,1,"",FLG_CANCEL);
			if(i)	break;
			MusicSilence();
			i=SRAMSave();
			if(!i)	GetMenuChoice("Snapshot Taken",okStrings,0,"",FLG_CANCEL);
			else	GetMenuChoice("Snapshot Failed",okStrings,0,"",FLG_CANCEL);
			break;
		case 5:
			i=GetMenuChoice("Are you sure?",yesNoStrings,1,"",FLG_CANCEL);
			if(i)	break;
			MusicSilence();
			i=SRAMLoad();
			if(!i)	GetMenuChoice("Snapshot Restored",okStrings,0,"",FLG_CANCEL);
			else	GetMenuChoice("Snapshot Restore Failed",okStrings,0,"",FLG_CANCEL);
			break;
		case 6:
			if(SelectImage())
			{
				h=GetRom(currentRom);
				EmuLoadZ80(h,true);
				goto done;
			}
			break;
		case 7:
			k=0;
			while(1)
			{
				k=GetMenuChoice("Video Options",videoOptionStrings,k,selCancelString,FLG_CANCEL | FLG_LOOP);
				if(k==-1) break;
				switch(k)
				{
				case 0:
					for(i=0;videoModes[i]!=-1;i++)	if(videoModes[i]==videoMode)	break;
					i=GetMenuChoice("Choose Video Mode",videoModeStrings,i,"",FLG_CANCEL | FLG_LOOP);
					if(i==-1)	break;
					videoMode=videoModes[i];
					break;
				case 1:
					i=GetMenuChoice("Choose Colour Settings",colourModeStrings,colourMode,"",FLG_CANCEL);
					if(i!=-1)	colourMode=i;
					break;
				case 2:
					i=GetMenuChoice("Choose Brightness",brightnessStrings,brightness,"",FLG_CANCEL);
					if(i!=-1)	brightness=i;
					break;
				case 3:
					i=GetMenuChoice("Choose Frame Skip",frameSkipStrings,frameSkip,"",FLG_CANCEL);
					if(i!=-1)	frameSkip=i;
					break;
				}
			}
			break;
		case 8:
			k=GetMenuChoice("Emulation Options",emuStrings,0,selCancelString,FLG_CANCEL | FLG_LOOP);
			if(k==-1)	break;
			if(k==0)
			{
				i=imageRinc;
				if(i>8) i=8;
				k=GetMenuChoice("R-Inc",rincStrings,i,selCancelString,FLG_CANCEL | FLG_LOOP);
				if(k==-1)	break;
				imageRinc=k;
			}
			else if(k==1)
			{
				k=GetMenuChoice("Scr/Int Timing",scrStrings,imageScreenMode,selCancelString,FLG_CANCEL | FLG_LOOP);
				if(k==-1)	break;
				imageScreenMode=k;
			}
			else if(k==2)
			{
				k=GetMenuChoice("Wait-State Mode",waitStrings,waitStateMode,selCancelString,FLG_CANCEL | FLG_LOOP);
				if(k==-1)	break;
				waitStateMode=k;

				switch(waitStateMode)
				{
				case 0:
					*((uint16*)0x04000204)=0x0000;
					break;
				case 1:
					*((uint16*)0x04000204)=0x0014;
					break;
				case 2:
					*((uint16*)0x04000204)=0x4014;
					break;
				}
			}
			break;
		case 9:
			k=GetSpectrumKey(-1);
			injectedKey=true;
			keyPress[k]=10;
			break;
		case 10:
			k=GetMenuChoice("Choose GBA Button to Remap",gbaKeyStrings,0,selCancelString,FLG_CANCEL | FLG_LOOP);
			if(k==-1)	break;
			l=15-gbaKeyCodes[k];
			for(i=0;keyDefs[i].name;i++)	if(*((uint32*)(&keyDefs[i].k)) == *((uint32*)(&keys[l]))) break;
			i=GetSpectrumKey(i);
			if(i==-1)	break;
			memcpy(&keys[l],&keyDefs[i].k,4);
			break;
		case 11:
			int32		addr,val;
			k=GetPoke(&addr,&val,"Apply Poke","UD=Change LR=Move A=Yes B=No");
			if(!k)
			{
				if(addr>=16384 && addr<65536 && val>=0 && val<256)
				{
					z80Mem[addr]=(byte)val;
					k=GetMenuChoice("Poke Applied",okStrings,0,"",FLG_CANCEL);
				}
				else
				{
					k=GetMenuChoice("Invalid Poke",okStrings,0,"",FLG_CANCEL);
				}
			}
			break;
		}
		MusicPoll();
	}
done:
//	for(i=0;i<79360;i+=4)	*((uint32*)(VRAM+i))=0;

	// wait for key release
	int32	key;
	do
	{
		key=*((volatile uint16*)REG_P1) ^ 0xFFFF;
	} while(key & 0x3FF);


	// restore videomode
	CopyupSetMode(videoMode);

	// restore audio freq and buffer size
	*((uint16*)(REG_BASE+0x100))=65536-1049;
	*((uint16*)(REG_BASE+0x104))=65536-AUDIO_SAMPLESPERFRAME;

	SRAMWriteOptions();
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void Rect(int32 x,int32 y,int32 w,int32 h,int32 pg,int32 col)
{
	int32		i,j;
	uint16		*wr;

	col|=(col<<8);

	wr=(uint16*)(VRAM+y*240+x + (pg?0xA000:0x0000));
	for(i=0;i<h;i++)
	{
		for(j=0;j<w;j+=2)
		{
			*(wr++)=col;
		}
		wr-=w/2;
		wr+=120;
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

int32 GetMenuChoice(char *title,char **strings,int32 def,char *cap,uint32 flg)
{
	int32		i,j,k,w,ww;
	int32		sel,off;
	int32		yct,y,sct;
	int32		pg;
	uint32		*wp;
	int32		key,lastKey;
	int32		reptCt,autoRept;

	if(def<0)	def=0;

	// init
	sel=def;
	off=0;
	pg=0;
	lastKey=-1;
	autoRept=0;
	reptCt=20;

	// count choices
	for(yct=0;strings[yct];yct++);
	sct=yct;
	if(sct>LIMIT)	sct=LIMIT;
	y=100-((sct*12)/2);

	// loop until selection made
	while(1)
	{
		MusicPoll();

		while(sel>=off+LIMIT)	off++;
		while(sel<off)		off--;

		// cls
		wp=(uint32*)(VRAM+pg*0xa000);
		for(i=0;i<240*160;i+=4)	*(wp++)=0x00;

		// draw title
		w=GetNiceStringLen(title);
		ww=w;
		if(ww&1)	ww++;
		ww+=12;
		Rect((240-ww)/2,30,ww,14,pg,48);
		DrawNiceString(title,(240-w)/2,30+10,pg,48);

		DrawString(cap,120-(strlen(cap)*4),150,pg,31);

		// draw menu
		k=0;
		for(i=0;i<sct;i++)
		{
			j=i+off;
			if(!strings[j])	break;
			w=GetNiceStringLen(strings[j]);

			if(j==sel)
			{
				ww=w; if(ww&1) ww++;
				ww+=12;
				Rect((240-ww)/2,i*12+y - 8,ww,11,pg,16);
			}
			DrawNiceString(strings[j],(240-w)/2,i*12+y,pg,j==sel?16:32);
		}

		*(uint16*)REG_LCD=LCD_MODE4 | LCD_BG2_EN | (pg?LCD_PAGEFLIP:0);
		pg^=1;

		if(lastKey==-1)
		{
			do
			{
				key=*((volatile uint16*)REG_P1) ^ 0xFFFF;
			} while(key & 0x3FF);
		}

		if(autoRept)	reptCt=REPT_SHORT;
		else		reptCt=REPT_LONG;

		do
		{
			i=intArgs->vbCount;
			while(intArgs->vbCount==i);

			key=*((volatile uint16*)REG_P1) ^ 0xFFFF;
			if(key!=lastKey)	autoRept=0;
			if(key && reptCt)
			{
				reptCt--;
				if(!reptCt)
				{
					autoRept=1;
					break;
				}
			}

			MusicPoll();
		} while(key==lastKey);
		lastKey=key;
		
		if(key & 1)	return(sel);
		if((key&2) && (flg&FLG_CANCEL))	return(-1);
		if(key & 128)	sel++;
		if(key & 64)	sel--;
		if(key & 32)	sel-=LIMIT-1;
		if(key & 16)	sel+=LIMIT-1;

		if(flg & FLG_LOOP)
		{
			if(sel<0)	sel=yct-1;
			if(sel>=yct)	sel=0;
		}
		else
		{
			if(sel<0)	sel=0;
			if(sel>=yct)	sel=yct-1;
		}
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void InitShell(void)
{
	uint32		ad;
	extern int32	_text_end__;
	Header		*h;
	int32		i;


	lastRow=0;
	lastCol=0;

	musicBuffer=0;
	musicPtr=0;

	// init easy parameters
	lastShellOption=0;
	currentRom=0;

	// init saveable options
	if(SRAMReadOptions())
	{
		videoMode=CM_TILEDSCALED;
		colourMode=0;
		brightness=2;
		frameSkip=0;
	}

	for(i=0;i<keyCt;i++)	keyPress[i]=0;
	
	// count roms
	romCt=0;
	ad=EmuFindImage(((int32)&_text_end__)-8);
	if(!ad)	FatalError("No ROM Images",__FILE__,__LINE__);
	while(1)
	{
		romCt++;

		h=(Header*)ad;
		ad=ad+sizeof(Header)+h->len;
		ad=(ad+7)&(~7);
		if(!EmuGotSig((int32)ad))	break;
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

Header*	GetRom(int32 which)
{
	uint32		ad;
	extern int32	_text_end__;
	Header		*h;

	ad=EmuFindImage(((int32)&_text_end__)-8);
	if(!ad)	FatalError("No ROM Images",__FILE__,__LINE__);
	h=(Header*)ad;
	while(which)
	{
		which--;
		ad=ad+sizeof(Header)+h->len;
		ad=(ad+7)&(~7);
		if(!EmuGotSig((int32)ad))	break;
		h=(Header*)ad;
	}
	return(h);
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

int32 SelectImage(void)
{
	int32		i;
	char		**strings;
	char		*strData;
	Header		*h;

	strings=(char **)MemAlloc(HEAP_EXTERNAL,(romCt+1)*4);	ASSERT(strings);
	strData=(char *)MemAlloc(HEAP_EXTERNAL,romCt*9);	ASSERT(strData);

	for(i=0;i<romCt;i++)
	{
		h=GetRom(i);
		mymemcpy(&strData[i*9],h->name,8);
		strData[i*9+8]=0;
		strings[i]=&strData[i*9];
	}
	strings[i]=NULL;		// terminate!

	i=GetMenuChoice("Select New Game",strings,currentRom,selCancelString,FLG_CANCEL | FLG_LOOP);

	MemFree(strings);
	MemFree(strData);

	if(i==-1)	return(0);

	currentRom=i;
	return(1);
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

int32 GetSpectrumKey(int32 def)
{
	int32		i;
//	i=GetMenuChoice("Select Spectrum Key",specKeyStrings,def,selCancelString,FLG_CANCEL | FLG_LOOP);
	i=GetKey(def);
	return(i);
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void DrawCenteredString(char *s,int32 y,bool pg,byte col)
{
	DrawString(s,120-strlen(s)*4,y,pg,col);
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void DoTitleScreen(void)
{
	int32		i;
	int32		key;

	*(uint16*)REG_LCD=LCD_MODE4 | LCD_BG2_EN;
	for(i=0;i<79360;i+=4)	*((uint32*)(VRAM+i))=0;
	SetShellPalette();

	DrawCenteredString("FooN",16,0,31);
	DrawCenteredString("ZX-Spectrum Emulator",32,0,28);
	DrawCenteredString(FOON_VERSION_STRING,40,0,28);
	DrawCenteredString("by",56,0,28);
	DrawCenteredString("Strags",64,0,28);

	DrawCenteredString("http://foon.pocketheaven.com",100,0,31);

	DrawCenteredString("Press A to continue...",140,0,28);

	do { key=*((volatile uint16*)REG_P1) ^ 0xFFFF; } while(!(key & 1));
	do { key=*((volatile uint16*)REG_P1) ^ 0xFFFF; } while(key & 1);

	for(i=0;i<79360;i+=4)	*((uint32*)(VRAM+i))=0;
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void SetShellPalette(void)
{
	int32		i,r,g,b;

	for(i=0;i<79360;i+=4)	*((uint32*)(VRAM+i))=0;
	((uint16*)PALETTE)[0]=0x0000;

	for(i=0;i<16;i++)
	{
		r=(i<<1);	g=(i<<1);	b=16+i;
		((uint16*)PALETTE)[i+16]=(b<<10) | (g<<5) | (r<<0);
		r=(i);		g=(i<<1);	b=(i<<1);
		((uint16*)PALETTE)[i+32]=(b<<10) | (g<<5) | (r<<0);
		r=16-i;		g=16-i;		b=31;
		((uint16*)PALETTE)[i+48]=(b<<10) | (g<<5) | (r<<0);
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void MusicPoll(void)
{
	int32		j;
	extern int	funkLen;
	extern byte	funkData[];

	if(intArgs->dmaChannel!=musicBuffer)
	{
		j=funkLen - musicPtr;
		if(j>(AUDIO_SAMPLESPERFRAME*4))	j=(AUDIO_SAMPLESPERFRAME*4);
		mymemcpy(audioBuffers[musicBuffer],&funkData[musicPtr],j);
		musicPtr+=j;
		if(musicPtr >= funkLen)
		{
			musicPtr=0;
			mymemcpy(&audioBuffers[musicBuffer][j],&funkData[musicPtr],(AUDIO_SAMPLESPERFRAME*4)-j);
			musicPtr+=(AUDIO_SAMPLESPERFRAME*4)-j;
		}
		musicBuffer=intArgs->dmaChannel;
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void MusicSilence(void)
{
	int32		i;

	for(i=0;i<AUDIO_SAMPLESPERFRAME*4;i++)
	{
		audioBuffers[0][i]=0;
		audioBuffers[1][i]=0;
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

int32 GetPoke(int32 *pad,int32 *pval,char *title,char *cap)
{
	char		ad[6];
	char		val[4];
	int32		pos;
	int32		pg;
	int32		i,j,w,ww;
	int32		reptCt,autoRept,lastKey;
	char		c[2];
	uint32		*wp;
	int32		key;
	int32		x;

	pg=0;
	pos=0;
	memcpy(ad,"00000",6);
	memcpy(val,"000",6);
	reptCt=20;
	autoRept=0;
	lastKey=-1;

	// loop until selection made
	while(1)
	{
		MusicPoll();

		// cls
		wp=(uint32*)(VRAM+pg*0xa000);
		for(i=0;i<240*160;i+=4)	*(wp++)=0x00;

		// draw title
		w=GetNiceStringLen(title);
		ww=w;
		if(ww&1)	ww++;
		ww+=12;
		Rect((240-ww)/2,30,ww,14,pg,48);
		DrawNiceString(title,(240-w)/2,30+10,pg,48);

		DrawString(cap,120-(strlen(cap)*4),150,pg,31);

		// draw address/value
		c[1]=0;
		for(i=0;i<5;i++)
		{
			c[0]=ad[i];			w=GetNiceStringLen(c);
			x=50+(i*16);
			if(i==pos)
			{
				ww=w; if(ww&1) ww++; ww+=4;
				Rect(x-2,100-10,ww,14,pg,16);
			}
			DrawNiceString(c,x,100,pg,(i==pos)?16:32);
		}
		DrawNiceString(",",50+80,100,pg,32);
		for(i=0;i<3;i++)
		{
			c[0]=val[i];			w=GetNiceStringLen(c);
			x=50+96+(i*16);
			if(i==pos-5)
			{
				ww=w; if(ww&1) ww++; ww+=4;
				Rect(x-2,100-10,ww,14,pg,16);
			}
			DrawNiceString(c,x,100,pg,(i==pos-5)?16:32);
		}

		*(uint16*)REG_LCD=LCD_MODE4 | LCD_BG2_EN | (pg?LCD_PAGEFLIP:0);
		pg^=1;

		if(lastKey==-1)
		{
			do
			{
				key=*((volatile uint16*)REG_P1) ^ 0xFFFF;
			} while(key & 0x3FF);
		}

		if(autoRept)	reptCt=REPT_SHORT;
		else		reptCt=REPT_LONG;

		do
		{
			i=intArgs->vbCount;
			while(intArgs->vbCount==i);

			key=*((volatile uint16*)REG_P1) ^ 0xFFFF;
			if(key!=lastKey)	autoRept=0;
			if(key && reptCt)
			{
				reptCt--;
				if(!reptCt)
				{
					autoRept=1;
					break;
				}
			}

			MusicPoll();
		} while(key==lastKey);
		lastKey=key;
		
		if(key & 1)	break;
		if(key & 2)	return(-1);
		if(key & 128)	{ if(pos<5 && ad[pos]>'0') ad[pos]--; if(pos>=5 && val[pos-5]>'0') val[pos-5]--; }
		if(key & 64)	{ if(pos<5 && ad[pos]<'9') ad[pos]++; if(pos>=5 && val[pos-5]<'9') val[pos-5]++; }
		if(key & 32)	{ if(pos>0) pos--; }
		if(key & 16)	{ if(pos<7) pos++; }
	}

	// extract value
	*pad=0;
	*pval=0;
	for(i=0,j=10000;i<5;i++,j/=10)	*pad += j*(ad[i]-'0');
	for(i=0,j=100;i<3;i++,j/=10)	*pval += j*(val[i]-'0');

	return(0);
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

int32 GetKey(int32 def)
{
	int32		i,j;
	uint32		*r,*w;
	uint16		*w2;
	int32		rr,gg,bb;
	int32		row,col,x,y;
	int32		pg;
	int32		lastKey,autoRept,key,reptCt;
	int32		port,val;
	int32		sel=-1;
	int32		frm;

	// find default key?
	if(def>=0)
	{
		if(keyDefs[def].k.type==KEY_KBD)
		{
			for(i=0;i<5;i++)	if(keyDefs[def].k.val==(1<<i))	break;
			lastCol=i;
			lastRow=keyDefs[def].k.port;
			if(lastRow>=4)
			{
				lastCol=9-lastCol;
				lastRow-=4;
			}
			else	lastRow=3-lastRow;
		}
		else
		{
			lastCol=0;
			for(i=0;i<6;i++)	if(keyDefs[def].k.val==(1<<i))	break;
			if(i<4)	i=3-i;
			lastCol=i;
			if(lastCol==6)	lastCol=0;
		}
	}

	// init
	col=lastCol;
	row=lastRow;
	lastKey=-1;
	autoRept=0;
	reptCt=20;
	pg=0;
	frm=0;

	// initialise palette
	r=(uint32*)(&keyboardPal[24]);
	w2=(uint16*)PALETTE;
	for(i=0;i<256;i++)
	{
		j=*(r++);
		gg=(j>>11) & 0x1f;
		bb=(j>>3)  & 0x1f;
		rr=(j>>19) & 0x1f;
		rr=(rr<<10) | (gg<<5) | (bb<<0);
		*(w2++)=(uint16)rr;
	}

	// main loop
	while(1)
	{
		// render bg image
		r=(uint32*)keyboardImg;
		w=(uint32*)(VRAM + (pg?0xA000:0x0000));
		for(i=240*160/4;i>0;i--)
		{
			*(w++)=*(r++);
		}

		// identify key
		if(row==-1)
		{
			port=0x1f;
			if(col<4)	val=1<<(3-col);
			else		val=1<<col;
		}
		else
		{
			if(col<5)	{	val=1<<col;	port=3-row;	}
			else		{	val=1<<(9-col);	port=row+4;	}
		}
		for(i=0;keyDefs[i].name;i++)
		{
			if(row!=-1 && keyDefs[i].k.type==KEY_KBD && keyDefs[i].k.val==val && keyDefs[i].k.port==port)	break;
			if(row==-1 && keyDefs[i].k.type==KEY_JOY && keyDefs[i].k.val==val)				break;
		}
		if(keyDefs[i].name)
		{
			sel=i;
			DrawCenteredString(specKeyStrings[i],25,pg,255);
		}
		DrawCenteredString("Select Key, A=OK, B=CANCEL",150,pg,255);

		*(uint16*)REG_LCD=LCD_MODE4 | LCD_BG2_EN | (pg?LCD_PAGEFLIP:0);
		pg^=1;


		// wait for keys
		if(lastKey==-1)
		{
			do
			{
				key=*((volatile uint16*)REG_P1) ^ 0xFFFF;
			} while(key & 0x3FF);
		}

		if(autoRept)	reptCt=REPT_SHORT;
		else		reptCt=REPT_LONG;
		do
		{
			i=intArgs->vbCount;
			while(intArgs->vbCount==i);

			frm++;
			if(row>=0)
			{
				x=kbdRowCoords[row*4+0] + (kbdRowCoords[row*4+2]-kbdRowCoords[row*4+0])*col/9;
				x&=~1;
				y=kbdRowCoords[row*4+1];
			}
			else
			{
				x=joyCoords[col*2+0] & ~1;
				y=joyCoords[col*2+1];
				x+=JOY_X;	y+=JOY_Y;
			}

			w2=(uint16*)(VRAM + y*240+x + (pg?0x0000:0xA000));
			w2-=(120*3+1);
			for(i=0;i<6;i++)
			{
				for(j=0;j<3;j++)	*(w2++)=((frm>>4)&1)?0xFFFF:0x0000;
				w2+=120-3;
			}

			key=*((volatile uint16*)REG_P1) ^ 0xFFFF;
			if(key!=lastKey)	autoRept=0;
			if(key && reptCt)
			{
				reptCt--;
				if(!reptCt)
				{
					autoRept=1;
					break;
				}
			}

			MusicPoll();
		} while(key==lastKey);
		lastKey=key;

		if(row>=0)
		{
			if(key&128)	{ row++; if(row>3) { row=-1; col=0; } }
			if(key&64)	{ row--; if(row==-1) col=4; }
			if(key&32)	{ col=(col+9)%10; }
			if(key&16)	{ col=(col+1)%10; }
		}
		else
		{
			i=col;
			if(key&64)	col=joyJumps[col*4+0];
			if(key&128)	col=joyJumps[col*4+1];
			if(key&32)	col=joyJumps[col*4+2];
			if(key&16)	col=joyJumps[col*4+3];
			if(col==-1)	col=i;
			if(col==-2)	{ row=0; col=8; }
			if(col==-3)	{ row=3; col=8; }
		}

		lastCol=col;
		lastRow=row;

		if(key&2)	{ SetShellPalette(); return(-1); }
		if(key&1)	{ SetShellPalette(); return(sel); }
	}

	

	extern void DoSomething(int q);
	while(1) DoSomething(0);
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

