/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

#ifndef MEM_H_INCLUDED
#define MEM_H_INCLUDED

/*
 * includes
 */

#include "std.h"

/*
 * defines
 */

#define HEAP_INTERNAL		0
#define HEAP_EXTERNAL		1

#define MemAlloc(h,l)	MemDoAlloc((h),(l),__FILE__,__LINE__)
#define MemFree(p)	MemDoFree((byte*)(p),__FILE__,__LINE__)
#define MemReserve(h,p)	MemDoReserve((h),(p),__FILE__,__LINE__)

/*
 * structures/classes
 */

/*
 * globals
 */

/*
 * prototypes
 */

extern void		StdMemInit(void);
extern void		MemInit(int32 heapId,byte* start,uint32 len);
extern byte*		MemDoAlloc(int32 heapId,uint32 len,char *file,int16 line);
extern byte*		MemDoReserve(int32 heapId,uint32 len,char *file,int16 line);
extern void		MemDoFree(byte *data,char *file,int16 len);
extern int32		MemGetFreeBytes(int32 heapId);

#endif
