/************************************************************************
 *
 * gba.h
 *
 ************************************************************************
 *
 * GBA standard definitions
 *
 ************************************************************************/

#ifndef GBA_H_INCLUDED
#define GBA_H_INCLUDED

/*
 * includes
 */

/*
 * defines
 */

#define REG_BASE	(0x04000000)
#define REG_LCD		(REG_BASE+0x00)
#define REG_STAT	(REG_BASE+0x04)
#define REG_LCY		(REG_BASE+0x06)
#define REG_BG0		(REG_BASE+0x08)
#define REG_BG1		(REG_BASE+0x0A)
#define REG_BG2		(REG_BASE+0x0C)
#define REG_BG3		(REG_BASE+0x0E)
#define REG_BG0_SCX	(REG_BASE+0x10)
#define REG_BG0_SCY	(REG_BASE+0x12)
#define REG_BG1_SCX	(REG_BASE+0x14)
#define REG_BG1_SCY	(REG_BASE+0x16)
#define REG_BG2_SCX	(REG_BASE+0x18)
#define REG_BG2_SCY	(REG_BASE+0x1A)
#define REG_BG3_SCX	(REG_BASE+0x1C)
#define REG_BG3_SCY	(REG_BASE+0x1E)
#define REG_KEY		(REG_BASE+0x98)
#define REG_DMASRC	(REG_BASE+0xD4)
#define REG_DMADEST	(REG_BASE+0xD8)
#define REG_DMACTRL	(REG_BASE+0xDC)

#define REG_P1		(REG_BASE+0x130)

#define LCD_MODE0	0x0000
#define LCD_MODE1	0x0001
#define LCD_MODE2	0x0002
#define LCD_MODE3	0x0003
#define LCD_MODE4	0x0004
#define LCD_MODE5	0x0005
#define LCD_PAGEFLIP	0x0010
#define LCD_HBLOBJ_DISABLE	0x0020
#define LCD_SPR_1D	0x0040
#define LCD_OFF		0x0080
#define LCD_BG0_EN	0x0100
#define LCD_BG1_EN	0x0200
#define LCD_BG2_EN	0x0400
#define LCD_BG3_EN	0x0800
#define LCD_SPR_EN	0x1000

#define BG_PAL16	0x0000
#define BG_PAL256	0x0080
#define BG_MOSAIC	0x0040

#define BG_SZ_32X32	0x0000
#define BG_SZ_64X32	0x4000
#define BG_SZ_32X64	0x8000
#define BG_SZ_64X64	0xC000

#define BG_TILEPAGE(x)	((x)<<8)
#define BG_DATA_0000	0x00
#define BG_DATA_4000	0x04
#define BG_DATA_8000	0x08
#define BG_DATA_C000	0x0C

#define VRAM		(0x06000000)
#define PALETTE		(0x05000000)

/*
 * typedefs
 */

/*
 * structures/classes
 */

/*
 * globals 
 */

/*
 * prototypes
 */

#endif