/************************************************************************
 *
 * std.h
 *
 ************************************************************************
 *
 * standard main include
 *
 ************************************************************************/

#ifndef STD_H_INCLUDED
#define STD_H_INCLUDED

/*
 * includes
 */

/*
 * defines
 */

#include <stdio.h>
#define DEBUG


#ifdef DEBUG
#define ASSERT(x) { if(!(x)) FatalError("ASSERTION FAILURE",__FILE__,__LINE__); }
#else
#define ASSERT(x)
#endif

#define MOD(x,y) (((int32)(x)<0)?  (((y)-1)+((int32)((x)+1)%(y))) : ((x) % (y)))

/*
 * typedefs
 */

typedef unsigned long	uint32;
typedef unsigned short	uint16;
typedef unsigned char	uint8;
typedef unsigned char	byte;

typedef signed long	int32;
typedef signed short	int16;
typedef signed char	int8;

typedef signed long	err32;

typedef signed char	bool8;

/*
 * structures/classes
 */

/*
 * globals
 */

/*
 * prototypes
 */

extern	void FatalError(char *err,char *file,int32 line);

#endif
