/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

/*
 * includes
 */

#include "std.h"
#include "emit.h"

/*
 * defines
 */

/*
 * typedefs
 */

/*
 * structs
 */

/*
 * globals
 */

FILE		*wr;
int32		instNum;


char		*reg8StrNormal[]={"B","C","D","E","H","L","***","A"};
char		*reg8StrIX[]={"B","C","D","E","IXH","IXL","***","A"};
char		*reg8StrIY[]={"B","C","D","E","IYH","IYL","***","A"};
char**		reg8Str[]={reg8StrNormal,reg8StrIX,reg8StrIY};
#define REG8STR(x) ((reg8Str[prefix])[x])

char		*reg16StrNormal[]={	"BC","DE","HL","SP"	};
char		*reg16StrIX[]={	"BC","DE","IX","SP"	};
char		*reg16StrIY[]={	"BC","DE","IY","SP"	};
char**		reg16Str[]={reg16StrNormal,reg16StrIX,reg16StrIY};
#define REG16STR(x) ((reg16Str[prefix])[x])

char		*reg16HiStrNormal[]={	"B","D","H","SPH"	};
char		*reg16HiStrIX[]={	"B","D","IXH","SPH"	};
char		*reg16HiStrIY[]={	"B","D","IYH","SPH"	};
char**		reg16HiStr[]={reg16HiStrNormal,reg16HiStrIX,reg16HiStrIY};
#define REG16HISTR(x) ((reg16HiStr[prefix])[x])

char		*reg16LoStrNormal[]={	"C","E","L","SPL"	};
char		*reg16LoStrIX[]={	"C","E","IXL","SPL"	};
char		*reg16LoStrIY[]={	"C","E","IYL","SPL"	};
char**		reg16LoStr[]={reg16LoStrNormal,reg16LoStrIX,reg16LoStrIY };
#define REG16LOSTR(x) ((reg16LoStr[prefix])[x])

char		*regQ16StrNormal[]={	"BC","DE","HL","AF"	};
char		*regQ16StrIX[]={	"BC","DE","IX","AF"	};
char		*regQ16StrIY[]={	"BC","DE","IY","AF"	};
char**		regQ16Str[]={regQ16StrNormal,regQ16StrIX,regQ16StrIY};
#define REGQ16STR(x) ((regQ16Str[prefix])[x])

char		*regQ16HiStrNormal[]={"B","D","H","A"};
char		*regQ16HiStrIX[]={"B","D","IXH","A"};
char		*regQ16HiStrIY[]={"B","D","IYH","A"};
char**		regQ16HiStr[]={regQ16HiStrNormal,regQ16HiStrIX,regQ16HiStrIY};
#define REGQ16HISTR(x) ((regQ16HiStr[prefix])[x])

char*		condExp[]=
{
	"if(!(core->F & FLAG_Z))",		// NZ
	"if((core->F & FLAG_Z))",		// Z
	"if(!(core->F & FLAG_C))",		// NC
	"if((core->F & FLAG_C))",		// C
	"if(!(core->F & FLAG_P))",		// PO	??? TODO: check ordering of these!
	"if((core->F & FLAG_P))",		// PE	???
	"if(!(core->F & FLAG_S))",		// P
	"if((core->F & FLAG_S))",		// M
};

char*		condName[]=
{
	"NZ","Z","NC","C","PO","PE","P","M"
};

char		hlString[128];

/*
 * function prototypes
 */

/*
 * code
 */

void EmitIHLPreamble(byte prefix)
{
	fprintf(wr,"uint16 ad;\n");

	if(prefix==PREFIX_NONE)	fprintf(wr,"ad=GET_REG16VAL(core->H);\n");
	else
	{
		fprintf(wr,"signed char disp;\n");
		fprintf(wr,"disp=READ_INST();\n");
		if(prefix==PREFIX_IX)	fprintf(wr,"ad=GET_REG16VAL(core->IXH) + disp;\n");
		else			fprintf(wr,"ad=GET_REG16VAL(core->IYH) + disp;\n");
	}
}

void PRINT_HL_STRING(byte prefix)
{
	if(!prefix)	fprintf(wr,"DISASM(\"(HL)\"); ");
	else if(prefix==PREFIX_IX)
	{
		fprintf(wr,"DISASM(\"(IX%%c#%%02x)\",(disp&0x80)?'-':'+',((disp&0x80)?-disp:disp)&0xFF); ");
	}
	else if(prefix==PREFIX_IY)
	{
		fprintf(wr,"DISASM(\"(IY%%c#%%02x)\",(disp&0x80)?'-':'+',((disp&0x80)?-disp:disp)&0xFF); ");
	}
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_LOAD_REG_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->%s = core->%s;\n",REG8STR(a1),REG8STR(a2));

	fprintf(wr,"DISASM(\"LD %s,%s\");\n",REG8STR(a1),REG8STR(a2));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_LOAD_REG_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	EmitIHLPreamble(prefix);
	fprintf(wr,"core->%s = READ_MEM(ad);\n",reg8StrNormal[a1]);	// 8bit-reg is normal

	fprintf(wr,"DISASM(\"LD %s,\"); ",reg8StrNormal[a1]);
	PRINT_HL_STRING(prefix);
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_LOAD_IHL_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	EmitIHLPreamble(prefix);
	fprintf(wr,"WRITE_MEM(ad,core->%s);\n",reg8StrNormal[a1]);	// 8bit-reg is normal!

	fprintf(wr,"DISASM(\"LD \"); ");
	PRINT_HL_STRING(prefix);
	fprintf(wr,"DISASM(\",%s\");\n",REG8STR(a1));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_LOAD_REG_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->%s=READ_INST();\n",REG8STR(a1));

	fprintf(wr,"DISASM(\"LD %s,#%%02x\",core->%s);\n",REG8STR(a1),REG8STR(a1));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_LOAD_IHL_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	EmitIHLPreamble(prefix);
	fprintf(wr,"byte v;\n");
	fprintf(wr,"v=READ_INST();\n");
	fprintf(wr,"WRITE_MEM(ad,v);\n");

	fprintf(wr,"DISASM(\"LD \"); ");
	PRINT_HL_STRING(prefix);
	fprintf(wr,"DISASM(\",#%%02x\",v);\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_READ_A_BC(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"core->A=READ_MEM(ad);\n");

	fprintf(wr,"DISASM(\"LD A,(BC)\");\n");
}
void Emit_READ_A_DE(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->D);\n");
	fprintf(wr,"core->A=READ_MEM(ad);\n");

	fprintf(wr,"DISASM(\"LD A,(DE)\");\n");
}
void Emit_READ_A_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad;\n");
	fprintf(wr,"ad=READ_INST16();\n");
	fprintf(wr,"core->A=READ_MEM(ad);\n");

	fprintf(wr,"DISASM(\"LD A,#%%02x\",ad);\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_WRITE_A_BC(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"WRITE_MEM(ad,core->A);\n");

	fprintf(wr,"DISASM(\"LD (BC),A\");\n");
}
void Emit_WRITE_A_DE(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->D);\n");
	fprintf(wr,"WRITE_MEM(ad,core->A);\n");

	fprintf(wr,"DISASM(\"LD (DE),A\");\n");
}
void Emit_WRITE_A_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad;\n");
	fprintf(wr,"ad=READ_INST16();\n");
	fprintf(wr,"WRITE_MEM(ad,core->A);\n");

	fprintf(wr,"DISASM(\"LD (#%%04x),A\",ad);\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_LOAD_DREG_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 v;\n");
	fprintf(wr,"v=READ_INST16();\n");
	fprintf(wr,"SET_REG16VAL(core->%s,v);\n",REG16HISTR(a1));

	fprintf(wr,"DISASM(\"LD %s,#%%04x\",v);\n",REG16STR(a1));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_READ_HL_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"ad=READ_INST16();\n");
	fprintf(wr,"v=READ_MEM16(ad);\n");
	fprintf(wr,"SET_REG16VAL(core->%s,v);\n",REG8STR(4));

	fprintf(wr,"DISASM(\"LD HL,(#%%04x)\",ad);\n");
}
void Emit_WRITE_HL_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"ad=READ_INST16();\n");
	fprintf(wr,"v=GET_REG16VAL(core->%s);\n",REG8STR(4));
	fprintf(wr,"WRITE_MEM16(ad,v);\n");

	fprintf(wr,"DISASM(\"LD (#%%04x),HL\",ad);\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_LOAD_SP_HL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 v;\n");
	fprintf(wr,"v=GET_REG16VAL(core->%s);\n",REG8STR(4));
	fprintf(wr,"SET_REG16VAL(core->SPH,v);\n");

	fprintf(wr,"DISASM(\"LD SP,%s\");\n",REG16STR(2));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_PUSH_QREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"v=GET_REG16VAL(core->%s);\n",REGQ16HISTR(a1));
	fprintf(wr,"ad=GET_REG16VAL(core->SPH);\n");
	fprintf(wr,"ad=(ad-2)&0xFFFF;\n");
	fprintf(wr,"WRITE_MEM16(ad,v);\n");
	fprintf(wr,"SET_REG16VAL(core->SPH,ad);\n");

	fprintf(wr,"DISASM(\"PUSH %s\");\n",REGQ16STR(a1));
}
void Emit_POP_QREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->SPH);\n");
	fprintf(wr,"v=READ_MEM16(ad);\n");
	fprintf(wr,"ad=(ad+2)&0xFFFF;\n");
	fprintf(wr,"SET_REG16VAL(core->%s,v);\n",REGQ16HISTR(a1));
	fprintf(wr,"SET_REG16VAL(core->SPH,ad);\n");

	fprintf(wr,"DISASM(\"POP %s\");\n",REGQ16STR(a1));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_EX_DE_HL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 a,b;\n");
	fprintf(wr,"a=GET_REG16VAL(core->D);\n");
	fprintf(wr,"b=GET_REG16VAL(core->%s);\n",REG8STR(4));
	fprintf(wr,"SET_REG16VAL(core->D,b);\n");
	fprintf(wr,"SET_REG16VAL(core->%s,a);\n",REG8STR(4));

	fprintf(wr,"DISASM(\"EX DE,%s\");\n",REG16STR(2));
}
void Emit_EX_AF_AFF(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 a,b;\n");
	fprintf(wr,"a=GET_REG16VAL(core->A);\n");
	fprintf(wr,"b=GET_REG16VAL(core->_A);\n");
	fprintf(wr,"SET_REG16VAL(core->A,b);\n");
	fprintf(wr,"SET_REG16VAL(core->_A,a);\n");

	fprintf(wr,"DISASM(\"EX AF,AF'\");\n");
}
void Emit_EXX(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 a,b;\n");
	fprintf(wr,"a=GET_REG16VAL(core->B);\n");
	fprintf(wr,"b=GET_REG16VAL(core->_B);\n");
	fprintf(wr,"SET_REG16VAL(core->B,b);\n");
	fprintf(wr,"SET_REG16VAL(core->_B,a);\n");
	fprintf(wr,"a=GET_REG16VAL(core->D);\n");
	fprintf(wr,"b=GET_REG16VAL(core->_D);\n");
	fprintf(wr,"SET_REG16VAL(core->D,b);\n");
	fprintf(wr,"SET_REG16VAL(core->_D,a);\n");
	fprintf(wr,"a=GET_REG16VAL(core->H);\n");
	fprintf(wr,"b=GET_REG16VAL(core->_H);\n");
	fprintf(wr,"SET_REG16VAL(core->H,b);\n");
	fprintf(wr,"SET_REG16VAL(core->_H,a);\n");

	fprintf(wr,"DISASM(\"EXX\");\n");
}
void Emit_EX_ISP_HL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 ad,v,h;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->SPH);\n");
	fprintf(wr,"h=GET_REG16VAL(core->%s);\n",REG8STR(4));
	fprintf(wr,"v=READ_MEM16(ad);\n");
	fprintf(wr,"WRITE_MEM16(ad,h);\n");
	fprintf(wr,"SET_REG16VAL(core->H,v);\n");

	fprintf(wr,"DISASM(\"EX (SP),%s\");\n",REG16STR(2));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_ADD_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab;\n");
	fprintf(wr,"tab=((int32)core->A<<8) | core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->A += core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->F = addFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"ADD A,%s\");\n",REG8STR(a1));
}
void Emit_ADC_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab;\n");
	fprintf(wr,"tab=((int32)core->A<<8) | core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->A += core->%s;\n",REG8STR(a1));
	fprintf(wr,"if(core->F & FLAG_C) { core->A++; tab|=65536; }\n");
	fprintf(wr,"core->F = addFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"ADC A,%s\");\n",REG8STR(a1));
}
void Emit_SUB_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab;\n");
	fprintf(wr,"tab=((int32)core->A<<8) | core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->A -= core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->F = subFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"SUB A,%s\");\n",REG8STR(a1));
}
void Emit_CP_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab;\n");
	fprintf(wr,"tab=((int32)core->A<<8) | core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->F = subFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"CP A,%s\");\n",REG8STR(a1));
}
void Emit_SBC_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab;\n");
	fprintf(wr,"tab=((int32)core->A<<8) | core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->A -= core->%s;\n",REG8STR(a1));
	fprintf(wr,"if(core->F & FLAG_C) { core->A--; tab|=65536; }\n");
	fprintf(wr,"core->F = subFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"SBC A,%s\");\n",REG8STR(a1));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_ADD_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab,v;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"tab=((int32)core->A<<8) | v;\n");
	fprintf(wr,"core->A += (byte)v;\n");
	fprintf(wr,"core->F = addFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"ADD A,\"); ");
	PRINT_HL_STRING(prefix);
}
void Emit_ADC_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab,v;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"tab=((int32)core->A<<8) | v;\n");
	fprintf(wr,"core->A += (byte)v;\n");
	fprintf(wr,"if(core->F & FLAG_C) { core->A++; tab|=65536; }\n");
	fprintf(wr,"core->F = addFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"ADC A,\"); ");
	PRINT_HL_STRING(prefix);
}
void Emit_SUB_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab,v;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"tab=((int32)core->A<<8) | v;\n");
	fprintf(wr,"core->A -= (byte)v;\n");
	fprintf(wr,"core->F = subFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"SUB A,\"); ");
	PRINT_HL_STRING(prefix);
}
void Emit_CP_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab,v;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"tab=((int32)core->A<<8) | v;\n");
	fprintf(wr,"core->F = subFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"CP A,\"); ");
	PRINT_HL_STRING(prefix);
}
void Emit_SBC_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab,v;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"tab=((int32)core->A<<8) | v;\n");
	fprintf(wr,"core->A -= (byte)v;\n");
	fprintf(wr,"if(core->F & FLAG_C) { core->A--; tab|=65536; }\n");
	fprintf(wr,"core->F = subFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"SBC A,\"); ");
	PRINT_HL_STRING(prefix);
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_ADD_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab,c;\n");
	fprintf(wr,"c=READ_INST();\n");
	fprintf(wr,"tab=((int32)core->A<<8) | c;\n");
	fprintf(wr,"core->A += (byte)c;\n");
	fprintf(wr,"core->F = addFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"ADD A,#%%02x\",c);\n");
}
void Emit_ADC_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab,c;\n");
	fprintf(wr,"c=READ_INST();\n");
	fprintf(wr,"tab=((int32)core->A<<8) | c;\n");
	fprintf(wr,"core->A += (byte)c;\n");
	fprintf(wr,"if(core->F & FLAG_C) { core->A++; tab|=65536; }\n");
	fprintf(wr,"core->F = addFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"ADC A,#%%02x\",c);\n");
}
void Emit_SUB_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab,c;\n");
	fprintf(wr,"c=READ_INST();\n");
	fprintf(wr,"tab=((int32)core->A<<8) | c;\n");
	fprintf(wr,"core->A -= (byte)c;\n");
	fprintf(wr,"core->F = subFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"SUB A,#%%02x\",c);\n");
}
void Emit_CP_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab,c;\n");
	fprintf(wr,"c=READ_INST();\n");
	fprintf(wr,"tab=((int32)core->A<<8) | c;\n");
	fprintf(wr,"core->F = subFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"CP A,#%%02x\",c);\n");
}
void Emit_SBC_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab,c;\n");
	fprintf(wr,"c=READ_INST();\n");
	fprintf(wr,"tab=((int32)core->A<<8) | c;\n");
	fprintf(wr,"core->A -= (byte)c;\n");
	fprintf(wr,"if(core->F & FLAG_C) { core->A--; tab|=65536; }\n");
	fprintf(wr,"core->F = subFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"SBC A,#%%02x\",c);\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_AND_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->A &= core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->F = orFlagTable[core->A] | FLAG_H;\n");

	fprintf(wr,"DISASM(\"AND A,%s\");\n",REG8STR(a1));
}
void Emit_OR_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->A |= core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->F = orFlagTable[core->A];\n");

	fprintf(wr,"DISASM(\"OR A,%s\");\n",REG8STR(a1));
}
void Emit_XOR_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->A ^= core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->F = orFlagTable[core->A];\n");

	fprintf(wr,"DISASM(\"XOR A,%s\");\n",REG8STR(a1));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_AND_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 v;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"core->A &= (byte)v;\n");
	fprintf(wr,"core->F = orFlagTable[core->A] | FLAG_H;\n");

	fprintf(wr,"DISASM(\"AND A,\"); ");
	PRINT_HL_STRING(prefix);
}
void Emit_OR_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 v;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"core->A |= (byte)v;\n");
	fprintf(wr,"core->F = orFlagTable[core->A];\n");

	fprintf(wr,"DISASM(\"OR A,\"); ");
	PRINT_HL_STRING(prefix);
}
void Emit_XOR_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 v;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"core->A ^= (byte)v;\n");
	fprintf(wr,"core->F = orFlagTable[core->A];\n");

	fprintf(wr,"DISASM(\"XOR A,\"); ");
	PRINT_HL_STRING(prefix);
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_AND_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 c;\n");
	fprintf(wr,"c=READ_INST();\n");
	fprintf(wr,"core->A &= c;\n");
	fprintf(wr,"core->F = orFlagTable[core->A] | FLAG_H;\n");

	fprintf(wr,"DISASM(\"AND A,#%%02x\",c);\n");
}
void Emit_OR_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 c;\n");
	fprintf(wr,"c=READ_INST();\n");
	fprintf(wr,"core->A |= c;\n");
	fprintf(wr,"core->F = orFlagTable[core->A];\n");

	fprintf(wr,"DISASM(\"OR A,#%%02x\",c);\n");
}
void Emit_XOR_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 c;\n");
	fprintf(wr,"c=READ_INST();\n");
	fprintf(wr,"core->A ^= c;\n");
	fprintf(wr,"core->F = orFlagTable[core->A];\n");

	fprintf(wr,"DISASM(\"XOR A,#%%02x\",c);\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_INC_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->%s++;\n",REG8STR(a1));
	fprintf(wr,"core->F=incFlagTable[ core->%s ] | (core->F&FLAG_C);\n",REG8STR(a1));

	fprintf(wr,"DISASM(\"INC %s\");\n",REG8STR(a1));
}
void Emit_DEC_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->%s--;\n",REG8STR(a1));
	fprintf(wr,"core->F=decFlagTable[ core->%s ] | (core->F&FLAG_C);\n",REG8STR(a1));

	fprintf(wr,"DISASM(\"DEC %s\");\n",REG8STR(a1));
}
void Emit_INC_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"byte v;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"v++;\n");
	fprintf(wr,"core->F=incFlagTable[ v ] | (core->F&FLAG_C);\n");
	fprintf(wr,"WRITE_MEM(ad,v);\n");

	fprintf(wr,"DISASM(\"INC \"); ");
	PRINT_HL_STRING(prefix);
}
void Emit_DEC_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"byte v;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"v--;\n");
	fprintf(wr,"core->F=decFlagTable[ v ] | (core->F&FLAG_C);\n");
	fprintf(wr,"WRITE_MEM(ad,v);\n");

	fprintf(wr,"DISASM(\"DEC \"); ");
	PRINT_HL_STRING(prefix);
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_DAA(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 q;\n");
	fprintf(wr,"q=core->A;\n");
	fprintf(wr,"if(core->F & FLAG_C) q|=256;\n");
	fprintf(wr,"if(core->F & FLAG_H) q|=512;\n");
	fprintf(wr,"if(core->F & FLAG_N) q|=1024;\n");
	fprintf(wr,"q<<=1;\n");
	fprintf(wr,"core->A=daaFlagTable[q++];\n");
	fprintf(wr,"core->F=daaFlagTable[q];\n");

	fprintf(wr,"DISASM(\"DAA\");\n");
}
void Emit_CPL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->A ^= 0xFF;\n");
	fprintf(wr,"core->F |= (FLAG_H | FLAG_N);\n");

	fprintf(wr,"DISASM(\"CPL\");\n");
}
void Emit_CCF(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->F&=~(FLAG_H|FLAG_N);\n");
	fprintf(wr,"core->F |= (core->F&FLAG_C)?FLAG_H:0;\n");
	fprintf(wr,"core->F ^= FLAG_C;\n");

	fprintf(wr,"DISASM(\"CCF\");\n");
}
void Emit_SCF(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->F |= FLAG_C;\n");
	fprintf(wr,"core->F &= ~(FLAG_H | FLAG_N);\n");

	fprintf(wr,"DISASM(\"SCF\");\n");
}
void Emit_NOP(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"DISASM(\"NOP\");\n");
}
void Emit_HALT(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->iff |= HALT;\n");
	fprintf(wr,"core->PC--;\n");

	fprintf(wr,"DISASM(\"HALT\");\n");
}
void Emit_DI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->iff=0;\n");

	fprintf(wr,"DISASM(\"DI\");\n");
}
void Emit_EI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->iff=IFF_1 | IFF_2;\n");
	fprintf(wr,"core->lastEI=true;\n");

	fprintf(wr,"DISASM(\"EI\");\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_ADD_HL_DREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab;\n");
	fprintf(wr,"int32 q;\n");

	fprintf(wr,"q=core->%s;\n",REG16LOSTR(2));
	fprintf(wr,"q+=core->%s;\n",REG16LOSTR(a1));
	fprintf(wr,"core->%s=(byte)q;\n",REG16LOSTR(2));
	
	fprintf(wr,"tab=((int32)core->%s<<8) | core->%s;\n",REG16HISTR(2),REG16HISTR(a1));
	fprintf(wr,"core->%s += core->%s;\n",REG16HISTR(2),REG16HISTR(a1));
	fprintf(wr,"if(q&256) { core->%s++; tab|=65536; }\n",REG16HISTR(2));

	// TODO: check flags! (does PDF not agree with manual?)
	fprintf(wr,"core->F = (core->F&(FLAG_S|FLAG_Z|FLAG_P)) |\n");
	fprintf(wr,"          (addFlagTable[tab]&(FLAG_H|FLAG_C));\n");
//	fprintf(wr,"core->F = addFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"ADD %s,%s\");\n",REG16STR(2),REG16STR(a1));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_INC_DREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 q;\n");
	fprintf(wr,"q=GET_REG16VAL(core->%s);\n",REG16HISTR(a1));
	fprintf(wr,"q++;\n");
	fprintf(wr,"SET_REG16VAL(core->%s,q);\n",REG16HISTR(a1));

	fprintf(wr,"DISASM(\"INC %s\");\n",REG16STR(a1));
}
void Emit_DEC_DREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 q;\n");
	fprintf(wr,"q=GET_REG16VAL(core->%s);\n",REG16HISTR(a1));
	fprintf(wr,"q--;\n");
	fprintf(wr,"SET_REG16VAL(core->%s,q);\n",REG16HISTR(a1));

	fprintf(wr,"DISASM(\"DEC %s\");\n",REG16STR(a1));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_JP(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 ad;\n");
	fprintf(wr,"ad=READ_INST16();\n");
	fprintf(wr,"core->PC=ad;\n");

	fprintf(wr,"DISASM(\"JP #%%04x\",core->PC);\n");
}
void Emit_JP_COND(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 ad;\n");
	fprintf(wr,"ad=READ_INST16();\n");
	fprintf(wr,"%s {\n",condExp[a1]);
	fprintf(wr,"    core->PC=ad;\n");
	fprintf(wr,"}\n");

	fprintf(wr,"DISASM(\"JP %s,#%%04x\",ad);\n",condName[a1]);
}
void Emit_JR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"signed char off;\n");
	fprintf(wr,"off=READ_INST();\n");
	fprintf(wr,"core->PC += off;\n");

	fprintf(wr,"DISASM(\"JR #%%04x\",core->PC);\n");
}
void Emit_JR_C_NC(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"signed char off;\n");
	fprintf(wr,"off=READ_INST();\n");

	if(a1)	fprintf(wr,"DISASM(\"JR C,#%%04x\",core->PC+off);\n");
	else	fprintf(wr,"DISASM(\"JR NC,#%%04x\",core->PC+off);\n");

	if(a1)	fprintf(wr,"if(core->F & FLAG_C) {\n");
	else	fprintf(wr,"if(!(core->F & FLAG_C)) {\n");
	fprintf(wr,"  core->PC += off;\n");
	fprintf(wr,"}\n");
}

void Emit_JR_Z_NZ(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"signed char off;\n");
	fprintf(wr,"off=READ_INST();\n");

	if(a1)	fprintf(wr,"DISASM(\"JR Z,#%%04x\",core->PC+off);\n");
	else	fprintf(wr,"DISASM(\"JR NZ,#%%04x\",core->PC+off);\n");

	if(a1)	fprintf(wr,"if(core->F & FLAG_Z) {\n");
	else	fprintf(wr,"if(!(core->F & FLAG_Z)) {\n");
	fprintf(wr,"  core->PC += off;\n");
	fprintf(wr,"}\n");
}
void Emit_JP_HL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 ad;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->%s);\n",REG8STR(4));
	fprintf(wr,"core->PC=ad;\n");

	fprintf(wr,"DISASM(\"JP (HL)\");\n");
}
void Emit_DJNZ(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"signed char off;\n");
	fprintf(wr,"off=READ_INST();\n");

	fprintf(wr,"DISASM(\"DJNZ #%%04x\",core->PC+off);\n");

	fprintf(wr,"core->B--;\n");
	fprintf(wr,"if(core->B) {\n");
	fprintf(wr,"  core->PC += off;\n");
	fprintf(wr,"  core->clocks += 5;\n");
	fprintf(wr,"}\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_CALL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 ad;\n");
	fprintf(wr,"ad=READ_INST16();\n");
	fprintf(wr,"int32 vv; vv=GET_REG16VAL(core->SPH); vv-=2; SET_REG16VAL(core->SPH,vv);\n");
	fprintf(wr,"WRITE_MEM16(vv,core->PC);\n");
	fprintf(wr,"core->PC=ad;\n");

	fprintf(wr,"DISASM(\"CALL #%%04x\",ad);\n");
}
void Emit_CALL_COND(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 ad;\n");
	fprintf(wr,"ad=READ_INST16();\n");
	fprintf(wr,"%s {\n",condExp[a1]);
	fprintf(wr,"  int32 vv; vv=GET_REG16VAL(core->SPH); vv-=2; SET_REG16VAL(core->SPH,vv);\n");
	fprintf(wr,"  WRITE_MEM16(vv,core->PC);\n");
	fprintf(wr,"  core->PC=ad;\n");
	fprintf(wr,"}\n");

	fprintf(wr,"DISASM(\"CALL %s,#%%04x\",ad);\n",condName[a1]);
}
void Emit_RET(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 ad;\n");
	fprintf(wr,"int32 vv; vv=GET_REG16VAL(core->SPH);\n");
	fprintf(wr,"ad=READ_MEM16(vv);\n");
	fprintf(wr,"vv+=2; SET_REG16VAL(core->SPH,vv);\n");
	fprintf(wr,"core->PC=ad;\n");

	fprintf(wr,"DISASM(\"RET\");\n");
}
void Emit_RET_COND(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 ad;\n");
	fprintf(wr,"%s {\n",condExp[a1]);
	fprintf(wr,"  int32 vv; vv=GET_REG16VAL(core->SPH);\n");
	fprintf(wr,"  ad=READ_MEM16(vv);\n");
	fprintf(wr,"  vv+=2; SET_REG16VAL(core->SPH,vv);\n");
	fprintf(wr,"  core->PC=ad;\n");
	fprintf(wr,"}\n");

	fprintf(wr,"DISASM(\"RET %s\");\n",condName[a1]);
}
void Emit_RST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 vv; vv=GET_REG16VAL(core->SPH); vv-=2; SET_REG16VAL(core->SPH,vv);\n");
	fprintf(wr,"WRITE_MEM16(vv,core->PC);\n");
	fprintf(wr,"core->PC=0x%02x;\n",a1*8);

	fprintf(wr,"DISASM(\"RST #%02x\");\n",a1*8);
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_RLCA(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 p;\n");
	fprintf(wr,"p=core->A;\n");
	fprintf(wr,"p=(p<<1) | ((p&128)?1:0);\n");
	fprintf(wr,"core->A=(byte)p;\n");
	fprintf(wr,"core->F &= ~(FLAG_H | FLAG_N | FLAG_C);\n");
	fprintf(wr,"if(p&256) core->F|=FLAG_C;\n");

	fprintf(wr,"DISASM(\"RLCA\");\n");
}
void Emit_RLA(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 p;\n");
	fprintf(wr,"p=core->A;\n");
	fprintf(wr,"p=(p<<1) | ((core->F&FLAG_C)?1:0);\n");
	fprintf(wr,"core->A=(byte)p;\n");
	fprintf(wr,"core->F &= ~(FLAG_H | FLAG_N | FLAG_C);\n");
	fprintf(wr,"if(p&256) core->F|=FLAG_C;\n");

	fprintf(wr,"DISASM(\"RLA\");\n");
}
void Emit_RRCA(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 p;\n");
	fprintf(wr,"p=core->A;\n");
	fprintf(wr,"core->A=(byte)((p>>1) | ((p&1)?128:0));\n");
	fprintf(wr,"core->F &= ~(FLAG_H | FLAG_N | FLAG_C);\n");
	fprintf(wr,"if(p&1) core->F|=FLAG_C;\n");

	fprintf(wr,"DISASM(\"RRCA\");\n");
}
void Emit_RRA(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 p;\n");
	fprintf(wr,"p=core->A;\n");
	fprintf(wr,"core->A=(byte)((p>>1) | ((core->F&FLAG_C)?128:0));\n");
	fprintf(wr,"core->F &= ~(FLAG_H | FLAG_N | FLAG_C);\n");
	fprintf(wr,"if(p&1) core->F|=FLAG_C;\n");

	fprintf(wr,"DISASM(\"RRA\");\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_IN_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad;\n");
	fprintf(wr,"ad=READ_INST();\n");
	fprintf(wr,"ad|=((int32)core->A)<<8;\n");
	fprintf(wr,"core->A=INP(ad);\n");

	fprintf(wr,"DISASM(\"IN A,(#%%02x)\",ad&0xFF);\n");
}
void Emit_OUT_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad;\n");
	fprintf(wr,"ad=READ_INST();\n");
	fprintf(wr,"ad|=((int32)core->A)<<8;\n");
	fprintf(wr,"OUTP(ad,core->A);\n");

	fprintf(wr,"DISASM(\"OUT (#%%02x),A\",ad&0xFF);\n");
}
 
/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_BIT_B_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"if(core->%s & (1<<%ld)) core->F &= ~FLAG_Z;\n",REG8STR(a2),a1);
	fprintf(wr,"else                    core->F |=  FLAG_Z;\n");
	fprintf(wr,"core->F |=  (FLAG_H);\n");
	fprintf(wr,"core->F &= ~(FLAG_N);\n");

	fprintf(wr,"DISASM(\"BIT #%x,%s\");\n",a1,REG8STR(a2));
}
void Emit_BIT_B_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"byte v;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"if(v & (1<<%ld)) core->F &= ~FLAG_Z;\n",a1);
	fprintf(wr,"else                    core->F |=  FLAG_Z;\n");
	fprintf(wr,"core->F |=  (FLAG_H);\n");
	fprintf(wr,"core->F &= ~(FLAG_N);\n");

	fprintf(wr,"DISASM(\"BIT #%x,\"); ",a1); PRINT_HL_STRING(prefix); fprintf(wr,"\n");
}
void Emit_SET_B_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->%s |= (1<<%ld);\n",REG8STR(a2),a1);

	fprintf(wr,"DISASM(\"SET #%x,%s\");\n",a1,REG8STR(a2));
}
void Emit_SET_B_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"byte nv;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"nv=READ_MEM(ad);\n");
	fprintf(wr,"nv |= (1<<%ld);\n",a1);
	fprintf(wr,"WRITE_MEM(ad,nv);\n");

	fprintf(wr,"DISASM(\"SET #%x,\"); ",a1); PRINT_HL_STRING(prefix); fprintf(wr,"\n");
}
void Emit_RES_B_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->%s &= ~(1<<%ld);\n",REG8STR(a2),a1);

	fprintf(wr,"DISASM(\"RES #%x,%s\");\n",a1,REG8STR(a2));
}
void Emit_RES_B_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"byte nv;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"nv=READ_MEM(ad);\n");
	fprintf(wr,"nv &= ~(1<<%ld);\n",a1);
	fprintf(wr,"WRITE_MEM(ad,nv);\n");

	fprintf(wr,"DISASM(\"RES #%x,\"); ",a1); PRINT_HL_STRING(prefix); fprintf(wr,"\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_RL_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v;\n");
	fprintf(wr,"v=core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->%s=(v<<1) | ((core->F & FLAG_C)?1:0);\n",REG8STR(a1));
	fprintf(wr,"core->F = rotateFlagTable[core->%s];\n",REG8STR(a1));
	fprintf(wr,"if(v&128) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"RL %s\");\n",REG8STR(a1));
}

void Emit_RR_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v;\n");
	fprintf(wr,"v=core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->%s=(v>>1) | ((core->F & FLAG_C)?128:0);\n",REG8STR(a1));
	fprintf(wr,"core->F = rotateFlagTable[core->%s];\n",REG8STR(a1));
	fprintf(wr,"if(v&1) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"RR %s\");\n",REG8STR(a1));
}
void Emit_RLC_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v;\n");
	fprintf(wr,"v=core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->%s=(v<<1) | ((v&128)?1:0);\n",REG8STR(a1));
	fprintf(wr,"core->F = rotateFlagTable[core->%s];\n",REG8STR(a1));
	fprintf(wr,"if(v&128) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"RLC %s\");\n",REG8STR(a1));
}
void Emit_RRC_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v;\n");
	fprintf(wr,"v=core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->%s=(v>>1) | ((v&1)?128:0);\n",REG8STR(a1));
	fprintf(wr,"core->F = rotateFlagTable[core->%s];\n",REG8STR(a1));
	fprintf(wr,"if(v&1) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"RRC %s\");\n",REG8STR(a1));
}
void Emit_SLL_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v;\n");
	fprintf(wr,"v=core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->%s=(v<<1)|1;\n",REG8STR(a1));
	fprintf(wr,"core->F = rotateFlagTable[core->%s];\n",REG8STR(a1));
	fprintf(wr,"if(v&128) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"SLL %s\");\n",REG8STR(a1));
}
void Emit_SLA_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v;\n");
	fprintf(wr,"v=core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->%s=(v<<1);\n",REG8STR(a1));
	fprintf(wr,"core->F = rotateFlagTable[core->%s];\n",REG8STR(a1));
	fprintf(wr,"if(v&128) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"SLA %s\");\n",REG8STR(a1));
}
void Emit_SRL_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v;\n");
	fprintf(wr,"v=core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->%s=(v>>1);\n",REG8STR(a1));
	fprintf(wr,"core->F = rotateFlagTable[core->%s];\n",REG8STR(a1));
	fprintf(wr,"if(v&1) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"SRL %s\");\n",REG8STR(a1));
}
void Emit_SRA_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v;\n");
	fprintf(wr,"v=core->%s;\n",REG8STR(a1));
	fprintf(wr,"core->%s=(v>>1) | (v&128);\n",REG8STR(a1));
	fprintf(wr,"core->F = rotateFlagTable[core->%s];\n",REG8STR(a1));
	fprintf(wr,"if(v&1) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"SRA %s\");\n",REG8STR(a1));
}

void Emit_RL_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v,nv;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"nv=(v<<1) | ((core->F & FLAG_C)?1:0);\n");
	fprintf(wr,"WRITE_MEM(ad,nv);\n");
	fprintf(wr,"core->F = rotateFlagTable[(byte)nv];\n");
	fprintf(wr,"if(v&128) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"RL \"); "); PRINT_HL_STRING(prefix); fprintf(wr,"\n");
}
void Emit_RR_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v,nv;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"nv=(v>>1) | ((core->F & FLAG_C)?128:0);\n");
	fprintf(wr,"WRITE_MEM(ad,nv);\n");
	fprintf(wr,"core->F = rotateFlagTable[(byte)nv];\n");
	fprintf(wr,"if(v&1) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"RR \"); "); PRINT_HL_STRING(prefix); fprintf(wr,"\n");
}
void Emit_RLC_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v,nv;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"nv=(v<<1) | ((v&128)?1:0);\n");
	fprintf(wr,"WRITE_MEM(ad,nv);\n");
	fprintf(wr,"core->F = rotateFlagTable[(byte)nv];\n");
	fprintf(wr,"if(v&128) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"RLC \"); "); PRINT_HL_STRING(prefix); fprintf(wr,"\n");
}
void Emit_RRC_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v,nv;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"nv=(v>>1) | ((v&1)?128:0);\n");
	fprintf(wr,"WRITE_MEM(ad,nv);\n");
	fprintf(wr,"core->F = rotateFlagTable[(byte)nv];\n");
	fprintf(wr,"if(v&1) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"RRC \"); "); PRINT_HL_STRING(prefix); fprintf(wr,"\n");
}
void Emit_SLL_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v,nv;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"nv=(v<<1)|1;\n");
	fprintf(wr,"WRITE_MEM(ad,nv);\n");
	fprintf(wr,"core->F = rotateFlagTable[(byte)nv];\n");
	fprintf(wr,"if(v&128) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"SLL \"); "); PRINT_HL_STRING(prefix); fprintf(wr,"\n");
}
void Emit_SLA_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v,nv;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"nv=(v<<1);\n");
	fprintf(wr,"WRITE_MEM(ad,nv);\n");
	fprintf(wr,"core->F = rotateFlagTable[(byte)nv];\n");
	fprintf(wr,"if(v&128) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"SLA \"); "); PRINT_HL_STRING(prefix); fprintf(wr,"\n");
}
void Emit_SRL_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v,nv;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"nv=(v>>1);\n");
	fprintf(wr,"WRITE_MEM(ad,nv);\n");
	fprintf(wr,"core->F = rotateFlagTable[(byte)nv];\n");
	fprintf(wr,"if(v&1) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"SRL \"); "); PRINT_HL_STRING(prefix); fprintf(wr,"\n");
}
void Emit_SRA_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 v,nv;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"nv=(v>>1)|(v&128);\n");
	fprintf(wr,"WRITE_MEM(ad,nv);\n");
	fprintf(wr,"core->F = rotateFlagTable[(byte)nv];\n");
	fprintf(wr,"if(v&1) core->F |= FLAG_C;\n");

	fprintf(wr,"DISASM(\"SRA \"); "); PRINT_HL_STRING(prefix); fprintf(wr,"\n");
}


void Emit_RLD(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"byte v,b;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"b=(v<<4) | (core->A&0xF);\n");
	fprintf(wr,"core->A = (core->A & 0xF0) | (v>>4);\n");
	fprintf(wr,"WRITE_MEM(ad,b);\n");
	fprintf(wr,"core->F = rotateFlagTable[(byte)core->A] | (core->F&FLAG_C);\n");

	fprintf(wr,"DISASM(\"RLD\");\n");
}
void Emit_RRD(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"byte v,b;\n");
	EmitIHLPreamble(prefix);
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"b=(v>>4) | ((core->A&0xF)<<4);\n");
	fprintf(wr,"core->A = (core->A & 0xF0) | (v&0xF);\n");
	fprintf(wr,"WRITE_MEM(ad,b);\n");
	fprintf(wr,"core->F = rotateFlagTable[(byte)core->A] | (core->F&FLAG_C);\n");

	fprintf(wr,"DISASM(\"RRD\");\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_IN_REG_C(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"v=INP(ad);\n");
	fprintf(wr,"core->%s=(byte)v;\n",REG8STR(a1));
	fprintf(wr,"core->F = rotateFlagTable[(byte)v] | (core->F&FLAG_C);\n");

	fprintf(wr,"DISASM(\"IN %s,(#%%02x)\",ad&0xFF);\n",REG8STR(a1));
}
void Emit_IN_C(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"v=INP(ad);\n");
	fprintf(wr,"core->F = rotateFlagTable[(byte)v] | (core->F&FLAG_C);\n");

	fprintf(wr,"DISASM(\"IN (#%%02x)\",ad&0xFF);\n");
}
void Emit_INI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"v=INP(ad);\n"); 
	fprintf(wr,"ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"WRITE_MEM(ad,v);\n");
	fprintf(wr,"ad++;\n");
	fprintf(wr,"SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"core->B--;\n");
	fprintf(wr,"core->F = FLAG_N | (core->F&FLAG_C);\n");
	fprintf(wr,"if(!core->B) core->F |= FLAG_Z;\n");

	fprintf(wr,"DISASM(\"INI\");\n");
}
void Emit_IND(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"v=INP(ad);\n"); 
	fprintf(wr,"ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"WRITE_MEM(ad,v);\n");
	fprintf(wr,"ad--;\n");
	fprintf(wr,"SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"core->B--;\n");
	fprintf(wr,"core->F = FLAG_N | (core->F&FLAG_C);\n");
	fprintf(wr,"if(!core->B) core->F |= FLAG_Z;\n");

	fprintf(wr,"DISASM(\"IND\");\n");
}
void Emit_INIR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"while(1) {\n");
	fprintf(wr,"  ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"  v=INP(ad);\n"); 
	fprintf(wr,"  ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"  WRITE_MEM(ad,v);\n");
	fprintf(wr,"  ad++;\n");
	fprintf(wr,"  SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"  core->B--;\n");
	fprintf(wr,"  if(!core->B) break;\n");
	fprintf(wr,"  core->clocks+=21;\n");
	fprintf(wr,"}\n");
	fprintf(wr,"core->F = FLAG_N | FLAG_Z | (core->F&FLAG_C);\n");

	fprintf(wr,"DISASM(\"INIR\");\n");
}
void Emit_INDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"while(1) {\n");
	fprintf(wr,"  ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"  v=INP(ad);\n"); 
	fprintf(wr,"  ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"  WRITE_MEM(ad,v);\n");
	fprintf(wr,"  ad--;\n");
	fprintf(wr,"  SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"  core->B--;\n");
	fprintf(wr,"  if(!core->B) break;\n");
	fprintf(wr,"  core->clocks+=21;\n");
	fprintf(wr,"}\n");
	fprintf(wr,"core->F = FLAG_N | FLAG_Z | (core->F&FLAG_C);\n");

	fprintf(wr,"DISASM(\"INDR\");\n");
}
void Emit_OUT_REG_C(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=6)
	{
		fprintf(wr,"int32 ad,v;\n");
		fprintf(wr,"ad=GET_REG16VAL(core->B);\n");
		fprintf(wr,"v=core->%s;\n",REG8STR(a1));
		fprintf(wr,"OUTP(ad,v);\n");

		fprintf(wr,"DISASM(\"OUT (#%%02x),%s\",ad&0xFF);\n",REG8STR(a1));
	}
	else
	{
		fprintf(wr,"  /* this opcode is invalid */\n");

		fprintf(wr,"DISASM(\"invalid!!!\");\n");
	}
}
void Emit_OUTI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"ad++;\n");
	fprintf(wr,"SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"core->B--;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"OUTP(ad,v);\n");
	fprintf(wr,"core->F = FLAG_N | (core->F&FLAG_C);\n");
	fprintf(wr,"if(!core->B) core->F |= FLAG_Z;\n");

	fprintf(wr,"DISASM(\"OUTI\");\n");
}
void Emit_OUTD(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"ad--;\n");
	fprintf(wr,"SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"core->B--;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"OUTP(ad,v);\n");
	fprintf(wr,"core->F = FLAG_N | (core->F&FLAG_C);\n");
	fprintf(wr,"if(!core->B) core->F |= FLAG_Z;\n");

	fprintf(wr,"DISASM(\"OUTD\");\n");
}
void Emit_OTIR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"while(1) {\n");
	fprintf(wr,"  ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"  v=READ_MEM(ad);\n");
	fprintf(wr,"  ad++;\n");
	fprintf(wr,"  SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"  core->B--;\n");
	fprintf(wr,"  ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"  OUTP(ad,v);\n");
	fprintf(wr,"  if(!core->B) break;\n");
	fprintf(wr,"  core->clocks+=21;\n");
	fprintf(wr,"}\n");
	fprintf(wr,"core->F = FLAG_N | FLAG_Z | (core->F&FLAG_C);\n");

	fprintf(wr,"DISASM(\"OTIR\");\n");
}
void Emit_OTDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"while(1) {\n");
	fprintf(wr,"  ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"  v=READ_MEM(ad);\n");
	fprintf(wr,"  ad--;\n");
	fprintf(wr,"  SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"  core->B--;\n");
	fprintf(wr,"  ad=GET_REG16VAL(core->B);\n");
	fprintf(wr,"  OUTP(ad,v);\n");
	fprintf(wr,"  if(!core->B) break;\n");
	fprintf(wr,"  core->clocks+=21;\n");
	fprintf(wr,"}\n");
	fprintf(wr,"core->F = FLAG_N | FLAG_Z | (core->F&FLAG_C);\n");

	fprintf(wr,"DISASM(\"OTDR\");\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_LD_A_I(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->A = core->I;\n");
	fprintf(wr,"core->F = rotateFlagTable[core->A] | (core->F&FLAG_C) | FLAG_P;\n");
	fprintf(wr,"if(!(core->iff & IFF_2)) core->F &= ~FLAG_P;\n");

	fprintf(wr,"DISASM(\"LD A,I\");\n");
}
void Emit_LD_A_R(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->A = core->R&0x7F;\n");
	fprintf(wr,"core->F = rotateFlagTable[core->A] | (core->F&FLAG_C) | FLAG_P;\n");
	fprintf(wr,"if(!(core->iff & IFF_2)) core->F &= ~FLAG_P;\n");

	fprintf(wr,"DISASM(\"LD A,R\");\n");
}
void Emit_LD_I_A(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->I = core->A;\n");

	fprintf(wr,"DISASM(\"LD I,A\");\n");
}
void Emit_LD_R_A(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->R = core->A;\n");

	fprintf(wr,"DISASM(\"LD R,A\");\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_LDI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad1,ad2,v;\n");
	fprintf(wr,"ad1=GET_REG16VAL(core->H);\n");
	fprintf(wr,"ad2=GET_REG16VAL(core->D);\n");
	fprintf(wr,"v=READ_MEM(ad1);\n");
	fprintf(wr,"WRITE_MEM(ad2,v);\n");
	fprintf(wr,"ad1++; ad2++;\n");
	fprintf(wr,"SET_REG16VAL(core->H,ad1);\n");
	fprintf(wr,"SET_REG16VAL(core->D,ad2);\n");

	fprintf(wr,"ad1=GET_REG16VAL(core->B);\n");
	fprintf(wr,"ad1--;\n");
	fprintf(wr,"SET_REG16VAL(core->B,ad1);\n");

	fprintf(wr,"core->F = (core->F & (FLAG_S|FLAG_Z|FLAG_C));\n");
	fprintf(wr,"if(ad1) core->F |= FLAG_P;\n");

	fprintf(wr,"DISASM(\"LDI\");\n");
}
void Emit_LDIR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad1,ad2,v;\n");
	fprintf(wr,"while(1) {\n");
	fprintf(wr,"  ad1=GET_REG16VAL(core->H);\n");
	fprintf(wr,"  ad2=GET_REG16VAL(core->D);\n");
	fprintf(wr,"  v=READ_MEM(ad1);\n");
	fprintf(wr,"  WRITE_MEM(ad2,v);\n");
	fprintf(wr,"  ad1++; ad2++;\n");
	fprintf(wr,"  SET_REG16VAL(core->H,ad1);\n");
	fprintf(wr,"  SET_REG16VAL(core->D,ad2);\n");

	fprintf(wr,"  ad1=GET_REG16VAL(core->B);\n");
	fprintf(wr,"  ad1--;\n");
	fprintf(wr,"  SET_REG16VAL(core->B,ad1);\n");

	fprintf(wr,"  if(!ad1) break;\n");
	fprintf(wr,"  core->clocks+=21;\n");
	fprintf(wr,"}\n");
	fprintf(wr,"core->F = (core->F & (FLAG_S|FLAG_Z|FLAG_C));\n");

	fprintf(wr,"DISASM(\"LDIR\");\n");
}

void Emit_LDD(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad1,ad2,v;\n");
	fprintf(wr,"ad1=GET_REG16VAL(core->H);\n");
	fprintf(wr,"ad2=GET_REG16VAL(core->D);\n");
	fprintf(wr,"v=READ_MEM(ad1);\n");
	fprintf(wr,"WRITE_MEM(ad2,v);\n");
	fprintf(wr,"ad1--; ad2--;\n");
	fprintf(wr,"SET_REG16VAL(core->H,ad1);\n");
	fprintf(wr,"SET_REG16VAL(core->D,ad2);\n");

	fprintf(wr,"ad1=GET_REG16VAL(core->B);\n");
	fprintf(wr,"ad1--;\n");
	fprintf(wr,"SET_REG16VAL(core->B,ad1);\n");

	fprintf(wr,"core->F = (core->F & (FLAG_S|FLAG_Z|FLAG_C));\n");
	fprintf(wr,"if(ad1) core->F |= FLAG_P;\n");

	fprintf(wr,"DISASM(\"LDD\");\n");
}
void Emit_LDDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad1,ad2,v;\n");
	fprintf(wr,"while(1) {\n");
	fprintf(wr,"  ad1=GET_REG16VAL(core->H);\n");
	fprintf(wr,"  ad2=GET_REG16VAL(core->D);\n");
	fprintf(wr,"  v=READ_MEM(ad1);\n");
	fprintf(wr,"  WRITE_MEM(ad2,v);\n");
	fprintf(wr,"  ad1--; ad2--;\n");
	fprintf(wr,"  SET_REG16VAL(core->H,ad1);\n");
	fprintf(wr,"  SET_REG16VAL(core->D,ad2);\n");

	fprintf(wr,"  ad1=GET_REG16VAL(core->B);\n");
	fprintf(wr,"  ad1--;\n");
	fprintf(wr,"  SET_REG16VAL(core->B,ad1);\n");

	fprintf(wr,"  if(!ad1) break;\n");
	fprintf(wr,"  core->clocks+=21;\n");
	fprintf(wr,"}\n");
	fprintf(wr,"core->F = (core->F & (FLAG_S|FLAG_Z|FLAG_C));\n");

	fprintf(wr,"DISASM(\"LDDR\");\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_CPI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,bc,tab,v;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"bc=GET_REG16VAL(core->B);\n");
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"tab=((int32)core->A<<8) | v;\n");
	fprintf(wr,"ad++; SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"bc--; SET_REG16VAL(core->B,bc);\n");
	fprintf(wr,"core->F = (subFlagTable[tab]&~(FLAG_C|FLAG_P)) | (core->F&FLAG_C);\n");
	fprintf(wr,"if(bc) core->F|=FLAG_P;\n");

	fprintf(wr,"DISASM(\"CPI\");\n");
}
void Emit_CPD(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,bc,tab,v;\n");
	fprintf(wr,"ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"bc=GET_REG16VAL(core->B);\n");
	fprintf(wr,"v=READ_MEM(ad);\n");
	fprintf(wr,"tab=((int32)core->A<<8) | v;\n");
	fprintf(wr,"ad--; SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"bc--; SET_REG16VAL(core->B,bc);\n");
	fprintf(wr,"core->F = (subFlagTable[tab]&~(FLAG_C|FLAG_P)) | (core->F&FLAG_C);\n");
	fprintf(wr,"if(bc) core->F|=FLAG_P;\n");

	fprintf(wr,"DISASM(\"CPD\");\n");
}
void Emit_CPIR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,bc,tab,v;\n");
	fprintf(wr,"while(1) {\n");
	fprintf(wr,"  ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"  bc=GET_REG16VAL(core->B);\n");
	fprintf(wr,"  v=READ_MEM(ad);\n");
	fprintf(wr,"  ad++; SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"  bc--; SET_REG16VAL(core->B,bc);\n");
	fprintf(wr,"  if(!bc) break;\n");
	fprintf(wr,"  if(v==core->A) break;\n");
	fprintf(wr,"  core->clocks += 21;\n");
	fprintf(wr,"}\n");
	fprintf(wr,"tab=((int32)core->A<<8) | v;\n");
	fprintf(wr,"core->F = (subFlagTable[tab]&~(FLAG_C|FLAG_P)) | (core->F&FLAG_C);\n");
	fprintf(wr,"if(bc) core->F|=FLAG_P;\n");

	fprintf(wr,"DISASM(\"CPIR\");\n");
}
void Emit_CPDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,bc,tab,v;\n");
	fprintf(wr,"while(1) {\n");
	fprintf(wr,"  ad=GET_REG16VAL(core->H);\n");
	fprintf(wr,"  bc=GET_REG16VAL(core->B);\n");
	fprintf(wr,"  v=READ_MEM(ad);\n");
	fprintf(wr,"  ad--; SET_REG16VAL(core->H,ad);\n");
	fprintf(wr,"  bc--; SET_REG16VAL(core->B,bc);\n");
	fprintf(wr,"  if(!bc) break;\n");
	fprintf(wr,"  if(v==core->A) break;\n");
	fprintf(wr,"  core->clocks += 21;\n");
	fprintf(wr,"}\n");
	fprintf(wr,"tab=((int32)core->A<<8) | v;\n");
	fprintf(wr,"core->F = (subFlagTable[tab]&~(FLAG_C|FLAG_P)) | (core->F&FLAG_C);\n");
	fprintf(wr,"if(bc) core->F|=FLAG_P;\n");

	fprintf(wr,"DISASM(\"CPDR\");\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_WRITE_DREG_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"ad=READ_INST16();\n");
	fprintf(wr,"v=GET_REG16VAL(core->%s);\n",REG16HISTR(a1));
	fprintf(wr,"WRITE_MEM16(ad,v);\n");

	fprintf(wr,"DISASM(\"LD (#%%04x),%s\",ad);\n",REG16STR(a1));
}
void Emit_READ_DREG_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 ad,v;\n");
	fprintf(wr,"ad=READ_INST16();\n");
	fprintf(wr,"v=READ_MEM16(ad);\n");
	fprintf(wr,"SET_REG16VAL(core->%s,v);\n",REG16HISTR(a1));

	fprintf(wr,"DISASM(\"LD %s,(#%%04x)\",ad);\n",REG16STR(a1));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_IM_0(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->im=0;\n");

	fprintf(wr,"DISASM(\"IM 0\");\n");
}
void Emit_IM_1(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->im=1;\n");

	fprintf(wr,"DISASM(\"IM 1\");\n");
}
void Emit_IM_2(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"core->im=2;\n");

	fprintf(wr,"DISASM(\"IM 2\");\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_RETI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 ad;\n");
	fprintf(wr,"int32 vv; vv=GET_REG16VAL(core->SPH);\n");
	fprintf(wr,"ad=READ_MEM16(vv);\n");
	fprintf(wr,"vv+=2; SET_REG16VAL(core->SPH,vv);\n");
	fprintf(wr,"core->PC=ad;\n");

	fprintf(wr,"DISASM(\"RETI\");\n");
}
void Emit_RETN(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"uint16 ad;\n");
	fprintf(wr,"int32 vv; vv=GET_REG16VAL(core->SPH);\n");
	fprintf(wr,"ad=READ_MEM16(vv);\n");
	fprintf(wr,"vv+=2; SET_REG16VAL(core->SPH,vv);\n");
	fprintf(wr,"core->PC=ad;\n");
	fprintf(wr,"if(core->iff & IFF_2) core->iff |=  IFF_1;\n");
	fprintf(wr,"else                  core->iff &= ~IFF_1;\n");

	fprintf(wr,"DISASM(\"RETN\");\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_NEG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab;\n");
	fprintf(wr,"tab=(0<<8) | core->A;\n");
	fprintf(wr,"core->A = -core->A;\n");
	fprintf(wr,"core->F = subFlagTable[tab];\n");

	fprintf(wr,"DISASM(\"NEG\");\n");
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_ADC_HL_DREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab;\n");
	fprintf(wr,"int32 q;\n");
	fprintf(wr,"q=core->%s;\n",REG16LOSTR(2));
	fprintf(wr,"q+=core->%s;\n",REG16LOSTR(a1));
	fprintf(wr,"if(core->F & FLAG_C) q++;\n");
	fprintf(wr,"core->%s=(byte)q;\n",REG16LOSTR(2));
	fprintf(wr,"tab=((int32)core->%s<<8) | core->%s;\n",REG16HISTR(2),REG16HISTR(a1));
	fprintf(wr,"core->%s += core->%s;\n",REG16HISTR(2),REG16HISTR(a1));
	fprintf(wr,"if(q&256) { core->%s++; tab|=65536; }\n",REG16HISTR(2));
	fprintf(wr,"core->F = addFlagTable[tab];\n");
	fprintf(wr,"if(q&0xFF) core->F &= ~FLAG_Z;\n");

	fprintf(wr,"DISASM(\"ADC %s,%s\");\n",REG16STR(2),REG16STR(a1));
}
void Emit_SBC_HL_DREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"int32 tab;\n");
	fprintf(wr,"int32 q;\n");
	fprintf(wr,"q=core->%s;\n",REG16LOSTR(2));
	fprintf(wr,"q-=core->%s;\n",REG16LOSTR(a1));
	fprintf(wr,"if(core->F & FLAG_C) q--;\n");
	fprintf(wr,"core->%s=(byte)q;\n",REG16LOSTR(2));
	fprintf(wr,"tab=((int32)core->%s<<8) | core->%s;\n",REG16HISTR(2),REG16HISTR(a1));
	fprintf(wr,"core->%s -= core->%s;\n",REG16HISTR(2),REG16HISTR(a1));
	fprintf(wr,"if(q<0) { core->%s--; tab|=65536; }\n",REG16HISTR(2));
	fprintf(wr,"core->F = subFlagTable[tab];\n");
	fprintf(wr,"if(q&0xFF) core->F &= ~FLAG_Z;\n");

	fprintf(wr,"DISASM(\"SBC %s,%s\");\n",REG16STR(2),REG16STR(a1));
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void Emit_(byte prefix,int32 a1,int32 a2,int32 a3)
{
	exit(1);
}

EmitDef emitDefs[]=
{
	{	"LOAD_REG_REG",		Emit_LOAD_REG_REG	},
	{	"LOAD_REG_IHL",		Emit_LOAD_REG_IHL	},
	{	"LOAD_IHL_REG",		Emit_LOAD_IHL_REG	},
	{	"LOAD_REG_CONST",	Emit_LOAD_REG_CONST	},
	{	"LOAD_IHL_CONST",	Emit_LOAD_IHL_CONST	},
	{	"READ_A_BC",		Emit_READ_A_BC		},
	{	"READ_A_DE",		Emit_READ_A_DE		},
	{	"READ_A_ADDR",		Emit_READ_A_ADDR	},
	{	"WRITE_A_BC",		Emit_WRITE_A_BC		},
	{	"WRITE_A_DE",		Emit_WRITE_A_DE		},
	{	"WRITE_A_ADDR",		Emit_WRITE_A_ADDR	},
	{	"LOAD_DREG_CONST",	Emit_LOAD_DREG_CONST	},
	{	"READ_HL_ADDR",		Emit_READ_HL_ADDR	},
	{	"WRITE_HL_ADDR",	Emit_WRITE_HL_ADDR	},
	{	"LOAD_SP_HL",		Emit_LOAD_SP_HL		},
	{	"PUSH_QREG",		Emit_PUSH_QREG		},
	{	"POP_QREG",		Emit_POP_QREG		},
	{	"EX_DE_HL",		Emit_EX_DE_HL		},
	{	"EX_AF_AFF",		Emit_EX_AF_AFF		},
	{	"EXX",			Emit_EXX		},
	{	"EX_ISP_HL",		Emit_EX_ISP_HL		},
	{	"ADD_A_REG",		Emit_ADD_A_REG		},
	{	"ADC_A_REG",		Emit_ADC_A_REG		},
	{	"SUB_A_REG",		Emit_SUB_A_REG		},
	{	"CP_A_REG",		Emit_CP_A_REG		},
	{	"SBC_A_REG",		Emit_SBC_A_REG		},
	{	"ADD_A_IHL",		Emit_ADD_A_IHL		},
	{	"ADC_A_IHL",		Emit_ADC_A_IHL		},
	{	"SUB_A_IHL",		Emit_SUB_A_IHL		},
	{	"CP_A_IHL",		Emit_CP_A_IHL		},
	{	"SBC_A_IHL",		Emit_SBC_A_IHL		},
	{	"ADD_A_CONST",		Emit_ADD_A_CONST	},
	{	"ADC_A_CONST",		Emit_ADC_A_CONST	},
	{	"SUB_A_CONST",		Emit_SUB_A_CONST	},
	{	"CP_A_CONST",		Emit_CP_A_CONST		},
	{	"SBC_A_CONST",		Emit_SBC_A_CONST	},
	{	"AND_A_REG",		Emit_AND_A_REG		},
	{	"AND_A_IHL",		Emit_AND_A_IHL		},
	{	"AND_A_CONST",		Emit_AND_A_CONST	},
	{	"OR_A_REG",		Emit_OR_A_REG		},
	{	"OR_A_IHL",		Emit_OR_A_IHL		},
	{	"OR_A_CONST",		Emit_OR_A_CONST	},
	{	"XOR_A_REG",		Emit_XOR_A_REG		},
	{	"XOR_A_IHL",		Emit_XOR_A_IHL		},
	{	"XOR_A_CONST",		Emit_XOR_A_CONST	},
	{	"INC_REG",		Emit_INC_REG		},
	{	"DEC_REG",		Emit_DEC_REG		},
	{	"INC_IHL",		Emit_INC_IHL		},
	{	"DEC_IHL",		Emit_DEC_IHL		},
	{	"DAA",			Emit_DAA		},
	{	"CPL",			Emit_CPL		},
	{	"CCF",			Emit_CCF		},
	{	"SCF",			Emit_SCF		},
	{	"NOP",			Emit_NOP		},
	{	"HALT",			Emit_HALT		},
	{	"DI",			Emit_DI			},
	{	"EI",			Emit_EI			},
	{	"ADD_HL_DREG",		Emit_ADD_HL_DREG	},
	{	"INC_DREG",		Emit_INC_DREG		},
	{	"DEC_DREG",		Emit_DEC_DREG		},
	{	"JP",			Emit_JP			},
	{	"JP_COND",		Emit_JP_COND		},
	{	"JR",			Emit_JR			},
	{	"JR_C_NC",		Emit_JR_C_NC		},
	{	"JR_Z_NZ",		Emit_JR_Z_NZ		},
	{	"JP_HL",		Emit_JP_HL		},
	{	"DJNZ",			Emit_DJNZ		},
	{	"CALL",			Emit_CALL		},
	{	"CALL_COND",		Emit_CALL_COND		},
	{	"RET",			Emit_RET		},
	{	"RET_COND",		Emit_RET_COND		},
	{	"RST",			Emit_RST		},
	{	"RLCA",			Emit_RLCA		},
	{	"RLA",			Emit_RLA		},
	{	"RRCA",			Emit_RRCA		},
	{	"RRA",			Emit_RRA		},
	{	"IN_A_CONST",		Emit_IN_A_CONST		},
	{	"OUT_A_CONST",		Emit_OUT_A_CONST	},


	{	"BIT_B_REG",		Emit_BIT_B_REG		},
	{	"BIT_B_IHL",		Emit_BIT_B_IHL		},
	{	"SET_B_REG",		Emit_SET_B_REG		},
	{	"SET_B_IHL",		Emit_SET_B_IHL		},
	{	"RES_B_REG",		Emit_RES_B_REG		},
	{	"RES_B_IHL",		Emit_RES_B_IHL		},
	{	"RL_REG",		Emit_RL_REG		},
	{	"RR_REG",		Emit_RR_REG		},
	{	"RLC_REG",		Emit_RLC_REG		},
	{	"RRC_REG",		Emit_RRC_REG		},
	{	"SLL_REG",		Emit_SLL_REG		},
	{	"SLA_REG",		Emit_SLA_REG		},
	{	"SRL_REG",		Emit_SRL_REG		},
	{	"SRA_REG",		Emit_SRA_REG		},
	{	"RL_IHL",		Emit_RL_IHL		},
	{	"RR_IHL",		Emit_RR_IHL		},
	{	"RLC_IHL",		Emit_RLC_IHL		},
	{	"RRC_IHL",		Emit_RRC_IHL		},
	{	"SLL_IHL",		Emit_SLL_IHL		},
	{	"SLA_IHL",		Emit_SLA_IHL		},
	{	"SRL_IHL",		Emit_SRL_IHL		},
	{	"SRA_IHL",		Emit_SRA_IHL		},
	{	"RLD",			Emit_RLD		},
	{	"RRD",			Emit_RRD		},

	{	"IN_REG_C",		Emit_IN_REG_C		},
	{	"IN_C",			Emit_IN_C		},
	{	"INI",			Emit_INI		},
	{	"IND",			Emit_IND		},
	{	"INIR",			Emit_INIR		},
	{	"INDR",			Emit_INDR		},
	{	"OUT_REG_C",		Emit_OUT_REG_C		},
	{	"OUTI",			Emit_OUTI		},
	{	"OUTD",			Emit_OUTD		},
	{	"OTIR",			Emit_OTIR		},
	{	"OTDR",			Emit_OTDR		},
	{	"LDI",			Emit_LDI		},
	{	"LDD",			Emit_LDD		},
	{	"LDIR",			Emit_LDIR		},
	{	"LDDR",			Emit_LDDR		},
	{	"CPI",			Emit_CPI		},
	{	"CPD",			Emit_CPD		},
	{	"CPIR",			Emit_CPIR		},
	{	"CPDR",			Emit_CPDR		},

	{	"LD_A_I",		Emit_LD_A_I		},
	{	"LD_A_R",		Emit_LD_A_R		},
	{	"LD_I_A",		Emit_LD_I_A		},
	{	"LD_R_A",		Emit_LD_R_A		},
	{	"WRITE_DREG_ADDR",	Emit_WRITE_DREG_ADDR	},
	{	"READ_DREG_ADDR",	Emit_READ_DREG_ADDR	},

	{	"IM_0",			Emit_IM_0		},
	{	"IM_1",			Emit_IM_1		},
	{	"IM_2",			Emit_IM_2		},
	{	"RETI",			Emit_RETI		},
	{	"RETN",			Emit_RETN		},
	{	"NEG",			Emit_NEG		},

	{	"ADC_HL_DREG",		Emit_ADC_HL_DREG	},
	{	"SBC_HL_DREG",		Emit_SBC_HL_DREG	},

	{	"",		Emit_	},
	{	"",		Emit_	},
	{	"",		Emit_	},
	{	"",		Emit_	},
	{	NULL,			NULL			},
};
