/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

/*
 * includes
 */

#include "std.h"
#include "emit.h"

#include <conio.h>

/*
 * defines
 */

#define STRICT_MEMCHECK

/*
 * typedefs
 */

/*
 * structs
 */

/*
 * globals
 */

char		*ireg8StrNormal[]={"B","C","D","E","H","L","***","A"};
char		*ireg8StrIX[]={"B","C","D","E","IXH","IXL","***","A"};
char		*ireg8StrIY[]={"B","C","D","E","IYH","IYL","***","A"};
char**		ireg8Str[]={ireg8StrNormal,ireg8StrIX,ireg8StrIY};
#define REG8STR(x) ((ireg8Str[prefix])[x])

char		*ireg16StrNormal[]={	"BC","DE","HL","SP"	};
char		*ireg16StrIX[]={	"BC","DE","IX","SP"	};
char		*ireg16StrIY[]={	"BC","DE","IY","SP"	};
char**		ireg16Str[]={ireg16StrNormal,ireg16StrIX,ireg16StrIY};
#define REG16STR(x) ((ireg16Str[prefix])[x])

char		*ireg16HiStrNormal[]={	"B","D","H","SPH"	};
char		*ireg16HiStrIX[]={	"B","D","IXH","SPH"	};
char		*ireg16HiStrIY[]={	"B","D","IYH","SPH"	};
char**		ireg16HiStr[]={ireg16HiStrNormal,ireg16HiStrIX,ireg16HiStrIY};
#define REG16HISTR(x) ((ireg16HiStr[prefix])[x])

char		*ireg16LoStrNormal[]={	"C","E","L","SPL"	};
char		*ireg16LoStrIX[]={	"C","E","IXL","SPL"	};
char		*ireg16LoStrIY[]={	"C","E","IYL","SPL"	};
char**		ireg16LoStr[]={ireg16LoStrNormal,ireg16LoStrIX,ireg16LoStrIY };
#define REG16LOSTR(x) ((ireg16LoStr[prefix])[x])

char		*iregQ16StrNormal[]={	"BC","DE","HL","AF"	};
char		*iregQ16StrIX[]={	"BC","DE","IX","AF"	};
char		*iregQ16StrIY[]={	"BC","DE","IY","AF"	};
char**		iregQ16Str[]={iregQ16StrNormal,iregQ16StrIX,iregQ16StrIY};
#define REGQ16STR(x) ((iregQ16Str[prefix])[x])

char		*iregQ16HiStrNormal[]={"B","D","H","A"};
char		*iregQ16HiStrIX[]={"B","D","IXH","A"};
char		*iregQ16HiStrIY[]={"B","D","IYH","A"};
char**		iregQ16HiStr[]={iregQ16HiStrNormal,iregQ16HiStrIX,iregQ16HiStrIY};
#define REGQ16HISTR(x) ((iregQ16HiStr[prefix])[x])

char*		asmCondExp[]=
{
	"tsts   r6,#FLAG_Z",
	"tsts   r6,#FLAG_Z",
	"tsts   r6,#FLAG_C",
	"tsts   r6,#FLAG_C",
	"tsts   r6,#FLAG_P",
	"tsts   r6,#FLAG_P",
	"tsts   r6,#FLAG_S",
	"tsts   r6,#FLAG_S",
};

char*		asmCondExp2[]=
{
	"eq","ne",
	"eq","ne",
	"eq","ne",
	"eq","ne",
};

char*		asmCondName[]=
{
	"NZ","Z","NC","C","PO","PE","P","M"
};

char		currentLabel[32]="label";

#define STORE_F()	fprintf(wr,"    strb   r6,[r13,#OFFSET_F]  @ writeback F\n");
#define FETCH_F()	fprintf(wr,"    ldrb   r6,[r13,#OFFSET_F]  @ update F\n");
#define STORE_A()	fprintf(wr,"    strb   r5,[r13,#OFFSET_A]  @ writeback A\n");
#define FETCH_A()	fprintf(wr,"    ldrb   r5,[r13,#OFFSET_A]  @ update A\n");
#define CLAMP_A()	fprintf(wr,"    and    r5,r5,#0xFF         @ mask A\n");

int32		extraClocks;

/*
 * function prototypes
 */

/*
 * code
 */

// r14 = fast jump
// r13 = core
// r12 = PC
// r11 = TABLES
// r10 = ram
// r9  = clocks_left
// r8  = mainTable
// r7  = 0xFFFF
// r6  = flags
// r5  = A

// r1  = inst
// r2  = HL / IX+d / IY+d

void AsmEmitFetch8(int32 dest,int32 addr,bool sign)
{
	if(!sign)	fprintf(wr,"    ldrb   r%ld,[r10,r%ld]\n",dest,addr);
	else		fprintf(wr,"    ldrsb  r%ld,[r10,r%ld]\n",dest,addr);
}
void AsmEmitFetch16(int32 reg,int32 idx,int32 tmp)
{
	AsmEmitFetch8(reg,idx,false);	//fprintf(wr,"    ldrb   r%d,[r10,r%d]\n",reg,idx);
	fprintf(wr,"    add    r%d,r%d,#1\n",tmp,idx);
	AsmEmitFetch8(tmp,tmp,false);	//fprintf(wr,"    ldrb   r%d,[r10,r%d]\n",tmp,tmp);
	fprintf(wr,"    mov    r%d,r%d,lsl#8\n",tmp,tmp);
	fprintf(wr,"    orr    r%d,r%d,r%d\n",reg,reg,tmp);
}

void AsmEmitIHLPreamble(byte prefix)
{
	if(prefix==PREFIX_NONE)
	{
		fprintf(wr,"    ldrh   r2,[r13,#OFFSET_HL]  @ get HL\n");
	}
	else
	{
		AsmEmitFetch8(3,12,true);		//fprintf(wr,"    ldrsb  r3,[r10,r12]\n");
		fprintf(wr,"    add    r12,r12,#1          @ inc PC (don't wrap yet)\n");
		if(prefix==PREFIX_IX)	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_IX]  @ get IX\n");
		else			fprintf(wr,"    ldrh   r2,[r13,#OFFSET_IY]  @ get IY\n");
		fprintf(wr,"    add    r2,r2,r3            @ add displacement\n");
		fprintf(wr,"    and    r2,r2,r7            @ mask\n");
		extraClocks+=9;
	}
}

void EmitWrite8(int32 src)
{
#ifdef STRICT_MEMCHECK
	fprintf(wr,"    cmps   r2,#16384\n");
	fprintf(wr,"    strgeb r%ld,[r10,r2]\n",src);
#else
	fprintf(wr,"    strb   r%ld,[r10,r2]\n",src);
#endif
}
void EmitWrite16(void)
{
#ifdef STRICT_MEMCHECK
	fprintf(wr,"    cmps   r2,#16384\n");
	fprintf(wr,"    strgeb r1,[r10,r2]\n");
	fprintf(wr,"    add    r2,r2,#1\n");
	fprintf(wr,"    and    r2,r2,r7\n");
	fprintf(wr,"    mov    r1,r1,lsr#8\n");
	fprintf(wr,"    cmps   r2,#16384\n");
	fprintf(wr,"    strgeb r1,[r10,r2]\n");
#else
	fprintf(wr,"    strb   r1,[r10,r2]\n");
	fprintf(wr,"    add    r2,r2,#1\n");
	fprintf(wr,"    mov    r1,r1,lsr#8\n");
	fprintf(wr,"    strb   r1,[r10,r2]\n");
#endif
}

/***********************************************************************
 *
 *
 *
 ***********************************************************************
 *
 *
 *
 ***********************************************************************/

void AsmEmit_LOAD_REG_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=a2)
	{
		if(a2==7)	fprintf(wr,"    strb   r5,[r13,#OFFSET_%s]   @ store A in other register\n",REG8STR(a1));
		else if(a1==7)	fprintf(wr,"    ldrb   r5,[r13,#OFFSET_%s]   @ fetch other reg into A\n",REG8STR(a2));
		else
		{
			fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]   @ read src register\n",REG8STR(a2));
			fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]   @ write dest\n",REG8STR(a1));
		}
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_LOAD_REG_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	if(a1==7)	AsmEmitFetch8(5,2,false);	//fprintf(wr,"    ldrb   r5,[r10,r2]\n");
	else
	{
		AsmEmitFetch8(1,2,false);	//fprintf(wr,"    ldrb   r1,[r10,r2]\n");
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]   @ write dest\n",ireg8StrNormal[a1]);
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_LOAD_IHL_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	if(a1==7)	EmitWrite8(5);
	else
	{
		fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]   @ read src\n",ireg8StrNormal[a1]);
		EmitWrite8(1);
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_LOAD_REG_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1==7)
	{
		AsmEmitFetch8(5,12,false);	//fprintf(wr,"    ldrb   r5,[r10,r12]\n");
		fprintf(wr,"    add    r12,r12,#1          @ inc PC (don't wrap yet)\n");
	}
	else
	{
		AsmEmitFetch8(3,12,false);	//fprintf(wr,"    ldrb   r3,[r10,r12]\n");
		fprintf(wr,"    add    r12,r12,#1          @ inc PC (don't wrap yet)\n");
		fprintf(wr,"    strb   r3,[r13,#OFFSET_%s]   @ write to register\n",REG8STR(a1));
	}
}
void AsmEmit_LOAD_IHL_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(3,12,false);	//fprintf(wr,"    ldrb   r3,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1          @ inc PC (don't wrap yet)\n");
	EmitWrite8(3);	//	fprintf(wr,"    strb   r3,[r10,r2]         @ write to RAM\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_READ_A_BC(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_BC]  @ get BC\n");
	AsmEmitFetch8(5,2,false);	//fprintf(wr,"    ldrb   r5,[r10,r2]\n");
}
void AsmEmit_READ_A_DE(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_DE]  @ get DE\n");
	AsmEmitFetch8(5,2,false);	//fprintf(wr,"    ldrb   r5,[r10,r2]\n");
}
void AsmEmit_READ_A_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch16(2,12,3);
	fprintf(wr,"    add    r12,r12,#2          @ advance PC\n");
	AsmEmitFetch8(5,2,false);	//fprintf(wr,"    ldrb   r5,[r10,r2]\n");
}
void AsmEmit_WRITE_A_BC(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_BC]  @ get BC\n");
	EmitWrite8(5);
}
void AsmEmit_WRITE_A_DE(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_DE]  @ get BC\n");
	EmitWrite8(5);
}
void AsmEmit_WRITE_A_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch16(2,12,3);
	fprintf(wr,"    add    r12,r12,#2          @ advance PC\n");
	EmitWrite8(5);
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_LOAD_DREG_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch16(2,12,3);
	fprintf(wr,"    add    r12,r12,#2          @ advance PC\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_%s]  @ update 16-bit reg\n",REG16STR(a1));
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_READ_HL_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch16(2,12,3);
	fprintf(wr,"    add    r12,r12,#2          @ advance PC\n");
	AsmEmitFetch16(1,2,3);
	fprintf(wr,"    strh   r1,[r13,#OFFSET_%s]  @ store it\n",REG16STR(2));
}
void AsmEmit_WRITE_HL_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch16(2,12,3);
	fprintf(wr,"    add    r12,r12,#2          @ advance PC\n");
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_%s]  @ get value\n",REG16STR(2));
	EmitWrite16();
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_LOAD_SP_HL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_%s]  @ get value\n",REG16STR(2));
	fprintf(wr,"    strh   r2,[r13,#OFFSET_SP]  @ store value\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_PUSH_QREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1==3)
	{
		STORE_F();
		STORE_A();
	}
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_%s]  @ get value\n",REGQ16STR(a1));
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_SP]  @ get SP\n");
	fprintf(wr,"    sub    r2,r2,#2            @ dec SP\n");
	fprintf(wr,"    and    r2,r2,r7            @ mask it\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_SP]  @ store new SP\n");
	EmitWrite16();
}
void AsmEmit_POP_QREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_SP]  @ get SP\n");
	AsmEmitFetch16(1,2,3);
	fprintf(wr,"    strh   r1,[r13,#OFFSET_%s]  @ save it\n",REGQ16STR(a1));
	fprintf(wr,"    add    r2,r2,#2            @ inc SP\n");
	fprintf(wr,"    and    r2,r2,r7            @ mask it\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_SP]  @ store new SP\n");

	if(a1==3)
	{
		FETCH_F();
		FETCH_A();
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_EX_DE_HL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_%s]  @ get %s\n",REG16STR(2),REG16STR(2));
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_DE]  @ get DE\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_%s]  @ store %s\n",REG16STR(2),REG16STR(2));
	fprintf(wr,"    strh   r1,[r13,#OFFSET_DE]  @ store DE\n");
}
void AsmEmit_EX_AF_AFF(byte prefix,int32 a1,int32 a2,int32 a3)
{
	STORE_F();
	STORE_A();
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_AF]  @ get AF\n");
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_AF_] @ get AF1\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_AF]  @ set AF\n");
	fprintf(wr,"    strh   r1,[r13,#OFFSET_AF_] @ set AF1\n");
	FETCH_F();
	FETCH_A();
}
void AsmEmit_EXX(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_BC]\n");
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_BC_]\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_BC]\n");
	fprintf(wr,"    strh   r1,[r13,#OFFSET_BC_]\n");
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_DE]\n");
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_DE_]\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_DE]\n");
	fprintf(wr,"    strh   r1,[r13,#OFFSET_DE_]\n");
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_HL_]\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    strh   r1,[r13,#OFFSET_HL_]\n");
}
void AsmEmit_EX_ISP_HL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_SP] @ get SP\n");
	AsmEmitFetch16(3,2,4);
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_%s] @ get reg\n",REG16STR(2));
	fprintf(wr,"    strh   r3,[r13,#OFFSET_%s] @ update reg\n",REG16STR(2));
	EmitWrite16();
}


/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_ADD_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	if(a1==7)
	{
		fprintf(wr,"    orr    r1,r1,r5\n");
		fprintf(wr,"    add    r5,r5,r5\n");
	}
	else
	{
		fprintf(wr,"    ldrb   r2,[r13,#OFFSET_%s]\n",REG8STR(a1));
		fprintf(wr,"    orr    r1,r1,r2\n");
		fprintf(wr,"    add    r5,r5,r2\n");
	}
	CLAMP_A();
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_ADD\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
}
void AsmEmit_ADC_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	if(a1==7)
	{
		fprintf(wr,"    orr    r1,r1,r5\n");
		fprintf(wr,"    add    r5,r5,r5\n");
	}
	else
	{
		fprintf(wr,"    ldrb   r2,[r13,#OFFSET_%s]\n",REG8STR(a1));
		fprintf(wr,"    orr    r1,r1,r2\n");
		fprintf(wr,"    add    r5,r5,r2\n");
	}
	fprintf(wr,"    tsts   r6,#FLAG_C\n");
	fprintf(wr,"    addne  r5,r5,#1\n");
	fprintf(wr,"    orrne  r1,r1,#0x10000\n");
	CLAMP_A();
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_ADD\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
}
void AsmEmit_SUB_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	if(a1==7)
	{
		fprintf(wr,"    orr    r1,r1,r5\n");
		fprintf(wr,"    sub    r5,r5,r5\n");
	}
	else
	{
		fprintf(wr,"    ldrb   r2,[r13,#OFFSET_%s]\n",REG8STR(a1));
		fprintf(wr,"    orr    r1,r1,r2\n");
		fprintf(wr,"    sub    r5,r5,r2\n");
	}
	CLAMP_A();
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
}
void AsmEmit_SBC_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	if(a1==7)
	{
		fprintf(wr,"    orr    r1,r1,r5\n");
		fprintf(wr,"    sub    r5,r5,r5\n");
	}
	else
	{
		fprintf(wr,"    ldrb   r2,[r13,#OFFSET_%s]\n",REG8STR(a1));
		fprintf(wr,"    orr    r1,r1,r2\n");
		fprintf(wr,"    sub    r5,r5,r2\n");
	}
	fprintf(wr,"    tsts   r6,#FLAG_C\n");
	fprintf(wr,"    subne  r5,r5,#1\n");
	fprintf(wr,"    orrne  r1,r1,#0x10000\n");
	CLAMP_A();
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
}
void AsmEmit_CP_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	if(a1==7)
	{
		fprintf(wr,"    orr    r1,r1,r5\n");
	}
	else
	{
		fprintf(wr,"    ldrb   r2,[r13,#OFFSET_%s]\n",REG8STR(a1));
		fprintf(wr,"    orr    r1,r1,r2\n");
	}
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_ADD_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(3,2,false);	//fprintf(wr,"    ldrb   r2,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	fprintf(wr,"    orr    r1,r1,r3\n");
	fprintf(wr,"    add    r5,r5,r3\n");
	CLAMP_A();
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_ADD\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
}
void AsmEmit_ADC_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(3,2,false);	//fprintf(wr,"    ldrb   r2,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	fprintf(wr,"    orr    r1,r1,r3\n");
	fprintf(wr,"    add    r5,r5,r3\n");
	fprintf(wr,"    tsts   r6,#FLAG_C\n");
	fprintf(wr,"    addne  r5,r5,#1\n");
	fprintf(wr,"    orrne  r1,r1,#0x10000\n");
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_ADD\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
	CLAMP_A();
}
void AsmEmit_SUB_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(3,2,false);	//fprintf(wr,"    ldrb   r2,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	fprintf(wr,"    orr    r1,r1,r3\n");
	fprintf(wr,"    sub    r5,r5,r3\n");
	CLAMP_A();
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
}
void AsmEmit_SBC_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(3,2,false);	//fprintf(wr,"    ldrb   r2,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	fprintf(wr,"    orr    r1,r1,r3\n");
	fprintf(wr,"    sub    r5,r5,r3\n");
	fprintf(wr,"    tsts   r6,#FLAG_C\n");
	fprintf(wr,"    subne  r5,r5,#1\n");
	fprintf(wr,"    orrne  r1,r1,#0x10000\n");
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
	CLAMP_A();
}
void AsmEmit_CP_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(3,2,false);	//fprintf(wr,"    ldrb   r2,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	fprintf(wr,"    orr    r1,r1,r3\n");
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_ADD_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(2,12,false);	//fprintf(wr,"    ldrb   r2,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1         @ inc PC (don't wrap yet)\n");
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	fprintf(wr,"    orr    r1,r1,r2\n");
	fprintf(wr,"    add    r5,r5,r2\n");
	CLAMP_A();
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_ADD\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
}
void AsmEmit_ADC_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(2,12,false);	//fprintf(wr,"    ldrb   r2,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1          @ inc PC (don't wrap yet)\n");
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	fprintf(wr,"    orr    r1,r1,r2\n");
	fprintf(wr,"    add    r5,r5,r2\n");
	fprintf(wr,"    tsts   r6,#FLAG_C\n");
	fprintf(wr,"    addne  r5,r5,#1\n");
	fprintf(wr,"    orrne  r1,r1,#0x10000\n");
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_ADD\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
	CLAMP_A();
}
void AsmEmit_SUB_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(2,12,false);	//fprintf(wr,"    ldrb   r2,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1          @ inc PC (don't wrap yet)\n");
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	fprintf(wr,"    orr    r1,r1,r2\n");
	fprintf(wr,"    sub    r5,r5,r2\n");
	CLAMP_A();
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
}
void AsmEmit_SBC_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(2,12,false);	//fprintf(wr,"    ldrb   r2,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1          @ inc PC (don't wrap yet)\n");
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	fprintf(wr,"    orr    r1,r1,r2\n");
	fprintf(wr,"    sub    r5,r5,r2\n");
	fprintf(wr,"    tsts   r6,#FLAG_C\n");
	fprintf(wr,"    subne  r5,r5,#1\n");
	fprintf(wr,"    orrne  r1,r1,#0x10000\n");
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
	CLAMP_A();
}
void AsmEmit_CP_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(2,12,false);	//fprintf(wr,"    ldrb   r2,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1          @ inc PC (don't wrap yet)\n");
	fprintf(wr,"    mov    r1,r5,lsl#8\n");
	fprintf(wr,"    orr    r1,r1,r2\n");
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]        @ fetch flags\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_AND_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(1,2,false);	//fprintf(wr,"    ldrb   r1,[r10,r2]\n");
	fprintf(wr,"    and    r5,r5,r1            @ perform op\n");
	fprintf(wr,"    add    r3,r5,#TABLE_OFFSET_OR  @ add OR table offset\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]         @ read flags\n");
	fprintf(wr,"    orr    r6,r6,#FLAG_H\n");
}
void AsmEmit_OR_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(1,2,false);	//fprintf(wr,"    ldrb   r1,[r10,r2]\n");
	fprintf(wr,"    orr    r5,r5,r1            @ perform op\n");
	fprintf(wr,"    add    r3,r5,#TABLE_OFFSET_OR  @ add OR table offset\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]         @ read flags\n");
}
void AsmEmit_XOR_A_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(1,2,false);	//fprintf(wr,"    ldrb   r1,[r10,r2]\n");
	fprintf(wr,"    eor    r5,r5,r1            @ perform op\n");
	fprintf(wr,"    add    r3,r5,#TABLE_OFFSET_OR  @ add OR table offset\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]         @ read flags\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_AND_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]  @ get register\n",REG8STR(a1));
		fprintf(wr,"    and    r5,r5,r1            @ perform op\n");
	}
	fprintf(wr,"    add    r3,r5,#TABLE_OFFSET_OR  @ add OR table offset\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]         @ read flags\n");
	fprintf(wr,"    orr    r6,r6,#FLAG_H\n");
}
void AsmEmit_OR_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]  @ get register\n",REG8STR(a1));
		fprintf(wr,"    orr    r5,r5,r1            @ perform op\n");
	}
	fprintf(wr,"    add    r3,r5,#TABLE_OFFSET_OR  @ add OR table offset\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]         @ read flags\n");
}
void AsmEmit_XOR_A_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]  @ get register\n",REG8STR(a1));
		fprintf(wr,"    eor    r5,r5,r1            @ perform op\n");
		fprintf(wr,"    add    r3,r5,#TABLE_OFFSET_OR  @ add OR table offset\n");
		fprintf(wr,"    ldrb   r6,[r11,r3]         @ read flags\n");
	}
	else
	{
		fprintf(wr,"    mov    r5,#0\n");
		fprintf(wr,"    mov    r3,#TABLE_OFFSET_OR  @ add OR table offset\n");
		fprintf(wr,"    ldrb   r6,[r11,r3]          @ read flags\n");
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_AND_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(1,12,false);	//fprintf(wr,"    ldrb   r1,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1           @ inc PC (don't wrap yet)\n");
	fprintf(wr,"    and    r5,r5,r1            @ perform op\n");
	fprintf(wr,"    add    r3,r5,#TABLE_OFFSET_OR  @ add OR table offset\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]         @ read flags\n");
	fprintf(wr,"    orr    r6,r6,#FLAG_H\n");
}
void AsmEmit_OR_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(1,12,false);	//fprintf(wr,"    ldrb   r1,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1           @ inc PC (don't wrap yet)\n");
	fprintf(wr,"    orr    r5,r5,r1            @ perform op\n");
	fprintf(wr,"    add    r3,r5,#TABLE_OFFSET_OR  @ add OR table offset\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]         @ read flags\n");
}
void AsmEmit_XOR_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(1,12,false);	//fprintf(wr,"    ldrb   r1,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1           @ inc PC (don't wrap yet)\n");
	fprintf(wr,"    eor    r5,r5,r1            @ perform op\n");
	fprintf(wr,"    add    r3,r5,#TABLE_OFFSET_OR  @ add OR table offset\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]         @ read flags\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_INC_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]    @ get reg\n",REG8STR(a1));
		fprintf(wr,"    add    r1,r1,#1              @ increment\n");
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]    @ store\n",REG8STR(a1));
		fprintf(wr,"    and    r1,r1,#0xFF\n");
		fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_INC\n");
	}
	else
	{
		fprintf(wr,"    add    r5,r5,#1              @ increment\n");
		CLAMP_A();
		fprintf(wr,"    add    r1,r5,#TABLE_OFFSET_INC\n");
	}
	fprintf(wr,"    and    r6,r6,#FLAG_C         @ mask off carry\n");
	fprintf(wr,"    ldrb   r1,[r11,r1]           @ get flags\n");
	fprintf(wr,"    orr    r6,r6,r1              @ preserve carry\n");
}
void AsmEmit_DEC_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]    @ get reg\n",REG8STR(a1));
		fprintf(wr,"    sub    r1,r1,#1              @ decrement\n");
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]    @ store\n",REG8STR(a1));
		fprintf(wr,"    and    r1,r1,#0xFF\n");
		fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_DEC\n");
	}
	else
	{
		fprintf(wr,"    sub    r5,r5,#1              @ decrement\n");
		CLAMP_A();
		fprintf(wr,"    add    r1,r5,#TABLE_OFFSET_DEC\n");
	}
	fprintf(wr,"    and    r6,r6,#FLAG_C         @ mask off carry\n");
	fprintf(wr,"    ldrb   r1,[r11,r1]           @ get flags\n");
	fprintf(wr,"    orr    r6,r6,r1              @ preserve carry\n");
}
void AsmEmit_INC_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(1,2,false);	//fprintf(wr,"    ldrb   r1,[r10,r2]\n");
	fprintf(wr,"    add    r1,r1,#1              @ increment\n");
	fprintf(wr,"    and    r1,r1,#0xFF\n");
	fprintf(wr,"    and    r6,r6,#FLAG_C         @ mask off carry\n");
	fprintf(wr,"    add    r4,r1,#TABLE_OFFSET_INC\n");
	fprintf(wr,"    ldrb   r4,[r11,r4]           @ get flags\n");
	fprintf(wr,"    orr    r6,r6,r4              @ preserve carry\n");
	EmitWrite8(1);
}
void AsmEmit_DEC_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(1,2,false);	//fprintf(wr,"    ldrb   r1,[r10,r2]\n");
	fprintf(wr,"    sub    r1,r1,#1              @ decrement\n");
	fprintf(wr,"    and    r1,r1,#0xFF\n");
	fprintf(wr,"    and    r6,r6,#FLAG_C         @ mask off carry\n");
	fprintf(wr,"    add    r4,r1,#TABLE_OFFSET_DEC\n");
	fprintf(wr,"    ldrb   r4,[r11,r4]           @ get flags\n");
	fprintf(wr,"    orr    r6,r6,r4              @ preserve carry\n");
	EmitWrite8(1);
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_DAA(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov    r1,r5,lsl#1\n");
	fprintf(wr,"    tsts   r6,#FLAG_C             @ test carry\n");
	fprintf(wr,"    orrne  r1,r1,#512\n");
	fprintf(wr,"    tsts   r6,#FLAG_H             @ test half-carry\n");
	fprintf(wr,"    orrne  r1,r1,#1024\n");
	fprintf(wr,"    tsts   r6,#FLAG_N             @ test sub-flag\n");
	fprintf(wr,"    orrne  r1,r1,#2048\n");
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_DAA\n");
	fprintf(wr,"    ldrb   r5,[r11,r1]           @ read new A\n");
	fprintf(wr,"    add    r1,r1,#1\n");
	fprintf(wr,"    ldrb   r6,[r11,r1]           @ read new F\n");
}

void AsmEmit_CPL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    eor    r5,r5,#0xFF\n");
	fprintf(wr,"    orr    r6,r6,#(FLAG_H | FLAG_N)\n");
}
void AsmEmit_CCF(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    and    r6,r6,#~(FLAG_H|FLAG_N)\n");
	fprintf(wr,"    tsts   r6,#FLAG_C\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_H\n");
	fprintf(wr,"    eor    r6,r6,#FLAG_C\n");
}
void AsmEmit_SCF(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    and    r6,r6,#(~(FLAG_H|FLAG_N))\n");
	fprintf(wr,"    orr    r6,r6,#FLAG_C\n");
}
void AsmEmit_NOP(byte prefix,int32 a1,int32 a2,int32 a3)
{
}
void AsmEmit_HALT(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    sub    r12,r12,#1\n");
	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_IFF]\n");
	fprintf(wr,"    orr    r1,r1,#IFF_HALTED\n");
	fprintf(wr,"    strb   r1,[r13,#OFFSET_IFF]\n");
}
void AsmEmit_DI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    eor    r1,r1,r1\n");
	fprintf(wr,"    strb   r1,[r13,#OFFSET_IFF]\n");
}
void AsmEmit_EI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov    r1,#(IFF_1|IFF_2)\n");
	fprintf(wr,"    strb   r1,[r13,#OFFSET_IFF]\n");
	fprintf(wr,"    mov    r1,#1\n");
	fprintf(wr,"    strb   r1,[r13,#OFFSET_LASTEI]\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_ADD_HL_DREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]     @ get dreg\n",REG16LOSTR(a1));
	fprintf(wr,"    ldrb   r3,[r13,#OFFSET_%s]     @ get HL\n",REG16LOSTR(2));
	fprintf(wr,"    add    r4,r1,r3              @ add them\n");
	fprintf(wr,"    strb   r4,[r13,#OFFSET_%s]     @ store result\n",REG16LOSTR(2));
	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]     @ get hi\n",REG16HISTR(a1));
	fprintf(wr,"    ldrb   r3,[r13,#OFFSET_%s]     @ get hi\n",REG16HISTR(2));
	fprintf(wr,"    add    r2,r1,r3              @ add them\n");
	fprintf(wr,"    mov    r1,r1,lsl#8           @ build table offset\n");
	fprintf(wr,"    and    r3,r3,#0xFF\n");
	fprintf(wr,"    orr    r1,r1,r3\n");
	fprintf(wr,"    tsts   r4,#0x100          @ was there a carry?\n");
	fprintf(wr,"    addne  r1,r1,#0x10000        @ shift table offset if yes\n");
	fprintf(wr,"    addne  r2,r2,#1              @ inc hi part if yes\n");
	fprintf(wr,"    strb   r2,[r13,#OFFSET_%s]     @ store result\n",REG16HISTR(2));
	fprintf(wr,"    add    r1,r1,#TABLE_OFFSET_ADD\n");
	fprintf(wr,"    ldrb   r1,[r11,r1]           @ read new flags\n");
	fprintf(wr,"    and    r1,r1,#(FLAG_H|FLAG_C)   @ mask off H/C\n");
	fprintf(wr,"    and    r6,r6,#(FLAG_S|FLAG_Z|FLAG_P)\n");
	fprintf(wr,"    orr    r6,r6,r1\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_INC_DREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_%s]\n",REG16STR(a1));
	fprintf(wr,"    add    r1,r1,#1\n");
	fprintf(wr,"    strh   r1,[r13,#OFFSET_%s]\n",REG16STR(a1));
}
void AsmEmit_DEC_DREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_%s]\n",REG16STR(a1));
	fprintf(wr,"    sub    r1,r1,#1\n");
	fprintf(wr,"    strh   r1,[r13,#OFFSET_%s]\n",REG16STR(a1));
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_JP(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch16(2,12,3);
	fprintf(wr,"    mov    r12,r2\n");
}
void AsmEmit_JP_COND(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch16(1,12,3);
	fprintf(wr,"    add    r12,r12,#2           @ inc PC (in case we don't jump)\n");
	fprintf(wr,"    %s\n",asmCondExp[a1]);
	fprintf(wr,"    mov%s  r12,r1               @ update PC if condition true\n",asmCondExp2[a1]);
}
void AsmEmit_JR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(1,12,true);	//fprintf(wr,"    ldrsb  r1,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1           @ inc PC\n");
	fprintf(wr,"    add    r12,r12,r1           @ add disp\n");
}
void AsmEmit_JR_C_NC(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(1,12,true);	//fprintf(wr,"    ldrsb  r1,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1           @ inc PC\n");
	fprintf(wr,"    add    r1,r1,r12            @ add PC\n");
	fprintf(wr,"    tsts   r6,#FLAG_C         @ C set?\n");
	if(!a1)
		fprintf(wr,"    moveq  r12,r1               @ if not, update PC\n");
	else
		fprintf(wr,"    movne  r12,r1               @ if so, update PC\n");
}
void AsmEmit_JR_Z_NZ(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(1,12,true);	//fprintf(wr,"    ldrsb  r1,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1           @ inc PC\n");
	fprintf(wr,"    add    r1,r1,r12            @ add PC\n");
	fprintf(wr,"    tsts   r6,#FLAG_Z         @ Z set?\n");
	if(!a1)
		fprintf(wr,"    moveq  r12,r1               @ if not, update PC\n");
	else
		fprintf(wr,"    movne  r12,r1               @ if so, update PC\n");
}
void AsmEmit_JP_HL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r12,[r13,#OFFSET_%s]      @ jump to register\n",REG16STR(2));
}
void AsmEmit_DJNZ(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(3,12,true);	//fprintf(wr,"    ldrsb  r3,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1               @ inc PC\n");
	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_B]        @ get B\n");
	fprintf(wr,"    subs    r1,r1,#1                @ decrement\n");
	fprintf(wr,"    strb   r1,[r13,#OFFSET_B]        @ store new B\n");
	fprintf(wr,"    addne  r12,r12,r3               @ if not zero, update PC\n");
	fprintf(wr,"    subne  r9,r9,#5                 @ and use 5 extra clocks!\n");
}
void AsmEmit_CALL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch16(3,12,4);
	fprintf(wr,"    add    r1,r12,#2           @ inc PC\n");
	fprintf(wr,"    mov    r12,r3              @ update PC\n");
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_SP]  @ get SP\n");
	fprintf(wr,"    sub    r2,r2,#2            @ dec SP\n");
	fprintf(wr,"    and    r2,r2,r7            @ mask it\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_SP]  @ store new SP\n");
	EmitWrite16();
}
void AsmEmit_CALL_COND(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch16(4,12,3);
	fprintf(wr,"    add    r12,r12,#2          @ inc PC\n");

	fprintf(wr,"    %s\n",asmCondExp[a1]);
	fprintf(wr,"    b%s    0f\n",asmCondExp2[a1^1]);

	fprintf(wr,"    mov    r1,r12              @ get PC\n");
	fprintf(wr,"    mov    r12,r4              @ update PC\n");
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_SP]  @ get SP\n");
	fprintf(wr,"    sub    r2,r2,#2            @ dec SP\n");
	fprintf(wr,"    and    r2,r2,r7            @ mask it\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_SP]  @ store new SP\n");
	EmitWrite16();

	fprintf(wr,"0:\n");
}
void AsmEmit_RET(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_SP]  @ get SP\n");
	AsmEmitFetch16(12,2,3);
	fprintf(wr,"    add    r2,r2,#2            @ inc SP\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_SP]  @ write back\n");
}
void AsmEmit_RET_COND(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    %s\n",asmCondExp[a1]);
	fprintf(wr,"    b%s    0f\n",asmCondExp2[a1^1]);

	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_SP]  @ get SP\n");
	AsmEmitFetch16(12,2,3);
	fprintf(wr,"    add    r2,r2,#2            @ inc SP\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_SP]  @ write back\n");
	
	fprintf(wr,"0:\n");
}
void AsmEmit_RST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov    r1,r12\n");
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_SP]  @ get SP\n");
	fprintf(wr,"    sub    r2,r2,#2            @ dec SP\n");
	fprintf(wr,"    and    r2,r2,r7            @ mask it\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_SP]  @ store new SP\n");
	EmitWrite16();
	fprintf(wr,"    mov    r12,#0x%02x\n",a1*8);
}
/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_RLCA(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    and    r6,r6,#~(FLAG_H|FLAG_N|FLAG_C)\n");
	fprintf(wr,"    tsts   r5,#128\n");
	fprintf(wr,"    mov    r5,r5,lsl#1\n");
	fprintf(wr,"    orrne  r5,r5,#1\n");
	CLAMP_A();
	fprintf(wr,"    orrne  r6,r6,#FLAG_C\n");
}
void AsmEmit_RRCA(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    and    r6,r6,#~(FLAG_H|FLAG_N|FLAG_C)\n");
	fprintf(wr,"    tsts   r5,#1\n");
	fprintf(wr,"    mov    r5,r5,lsr#1\n");
	fprintf(wr,"    orrne  r5,r5,#128\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_C\n");
}
void AsmEmit_RLA(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    tsts   r6,#FLAG_C\n");
	fprintf(wr,"    and    r6,r6,#~(FLAG_H|FLAG_N|FLAG_C)\n");
	fprintf(wr,"    mov    r5,r5,lsl#1\n");
	fprintf(wr,"    orrne  r5,r5,#1\n");
	fprintf(wr,"    tsts   r5,#256\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_C\n");
	CLAMP_A();
}
void AsmEmit_RRA(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    tsts   r6,#FLAG_C\n");
	fprintf(wr,"    and    r6,r6,#~(FLAG_H|FLAG_N|FLAG_C)\n");
	fprintf(wr,"    orrne  r5,r5,#256\n");
	fprintf(wr,"    tsts   r5,#1\n");
	fprintf(wr,"    mov    r5,r5,lsr#1\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_C\n");
}


/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_BIT_B_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
#if 0
	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]        @ get reg\n",REG8STR(a2));
	fprintf(wr,"    tsts   r1,#%ld               @ test bit\n",(1<<a1));
	fprintf(wr,"    and    r6,r6,#~(FLAG_Z|FLAG_N)   @ clear Z and N\n");
	fprintf(wr,"    orreq  r6,r6,#FLAG_Z             @ set Z if zero\n");
	fprintf(wr,"    orr    r6,r6,#FLAG_H             @ set H!\n");
#else
	fprintf(wr,"    mov    r4,r4,lsr#3               @ 4=opcode - get BIT#\n");
	fprintf(wr,"    and    r4,r4,#7                  @ mask off bit#\n");
	fprintf(wr,"    mov    r3,#1\n");
	fprintf(wr,"    mov    r3,r3,lsl r4\n");
	if(a2!=7)
	{
		fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]        @ get reg\n",REG8STR(a2));
		fprintf(wr,"    tsts   r1,r3                     @ test bit\n",(1<<a1));
	}
	else
	{
		fprintf(wr,"    tsts   r5,r3\n");
	}
	fprintf(wr,"    and    r6,r6,#~(FLAG_Z|FLAG_N|FLAG_S)   @ clear Z and N (and s-undoc!)\n");
	fprintf(wr,"    orreq  r6,r6,#FLAG_Z             @ set Z if zero\n");
	fprintf(wr,"    orr    r6,r6,#FLAG_H             @ set H!\n");
	if(a1==7)
	{
		// bit 7 behaviour is different! (undocumented sign bit!)
		fprintf(wr,"    orrne  r6,r6,#FLAG_S   @ undocumented sign bit!\n");
	}
#endif
}
void AsmEmit_BIT_B_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(1,2,false);	//fprintf(wr,"    ldrb   r1,[r10,r2]\n");
	fprintf(wr,"    tsts   r1,#%ld               @ test bit\n",(1<<a1));
	fprintf(wr,"    and    r6,r6,#~(FLAG_Z|FLAG_N|FLAG_S)   @ clear Z and N (and s-undoc!)\n");
	fprintf(wr,"    orreq  r6,r6,#FLAG_Z             @ set Z if zero\n");
	fprintf(wr,"    orr    r6,r6,#FLAG_H             @ set H!\n");
	if(a1==7)
	{
		// bit 7 behaviour is different! (undocumented sign bit!)
		fprintf(wr,"    orrne  r6,r6,#FLAG_S   @ undocumented sign bit!\n");
	}
}
void AsmEmit_SET_B_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
#if 0
	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]        @ get reg\n",REG8STR(a2));
	fprintf(wr,"    orr    r1,r1,#%ld                @ set bit\n",(1<<a1));
	fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]        @ get reg\n",REG8STR(a2));
#else
	fprintf(wr,"    mov    r4,r4,lsr#3               @ 4=opcode - get BIT#\n");
	fprintf(wr,"    and    r4,r4,#7                  @ mask off bit#\n");
	fprintf(wr,"    mov    r3,#1\n");
	fprintf(wr,"    mov    r3,r3,lsl r4\n");

	if(a2!=7)
	{
		fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]        @ get reg\n",REG8STR(a2));
		fprintf(wr,"    orr    r1,r1,r3                   @ set bit\n",(1<<a1));
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]        @ get reg\n",REG8STR(a2));
	}
	else
	{
		fprintf(wr,"    orr    r5,r5,r3\n");
	}
#endif
}
void AsmEmit_SET_B_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(1,2,false);	//fprintf(wr,"    ldrb   r1,[r10,r2]\n");
	fprintf(wr,"    orr    r1,r1,#%ld                @ set bit\n",(1<<a1));
	EmitWrite8(1);
}
void AsmEmit_RES_B_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
#if 0
	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]        @ get reg\n",REG8STR(a2));
	fprintf(wr,"    and    r1,r1,#%ld                @ reset bit\n",255-(1<<a1));
	fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]        @ get reg\n",REG8STR(a2));
#else
	fprintf(wr,"    mov    r4,r4,lsr#3               @ 4=opcode - get BIT#\n");
	fprintf(wr,"    and    r4,r4,#7                  @ mask off bit#\n");
	fprintf(wr,"    mov    r3,#1\n");
	fprintf(wr,"    mov    r3,r3,lsl r4\n");
	fprintf(wr,"    eor    r3,r3,#0xFF\n");
	if(a2!=7)
	{
		fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]        @ get reg\n",REG8STR(a2));
		fprintf(wr,"    and    r1,r1,r3                   @ set bit\n",(1<<a1));
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]        @ get reg\n",REG8STR(a2));
	}
	else
	{
		fprintf(wr,"    and    r5,r5,r3\n");
	}
#endif
}
void AsmEmit_RES_B_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(1,2,false);	//fprintf(wr,"    ldrb   r1,[r10,r2]\n");
	fprintf(wr,"    and    r1,r1,#%ld                @ reset bit\n",255-(1<<a1));
	EmitWrite8(1);
}


/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_RL_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r4,[r13,#OFFSET_%s]       @ get reg\n",REG8STR(a1));
		fprintf(wr,"    mov    r1,r4,lsl#1              @ shift\n");
		fprintf(wr,"    tsts   r6,#FLAG_C             @ was carry set?\n");
		fprintf(wr,"    orrne  r1,r1,#1                 @ if so, set bit zero\n");
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]       @ save reg\n",REG8STR(a1));
		fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
		fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
		fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
	else
	{
		fprintf(wr,"    mov    r5,r5,lsl#1              @ shift\n");
		fprintf(wr,"    tsts   r6,#FLAG_C             @ was carry set?\n");
		fprintf(wr,"    orrne  r5,r5,#1                 @ if so, set bit zero\n");
		fprintf(wr,"    tsts   r5,#256               @ was top bit set?\n");
		CLAMP_A();
		fprintf(wr,"    ldrb   r6,[r11,r5]              @ get flags\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
}
void AsmEmit_RR_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r4,[r13,#OFFSET_%s]       @ get reg\n",REG8STR(a1));
		fprintf(wr,"    mov    r1,r4,lsr#1              @ shift\n");
		fprintf(wr,"    tsts   r6,#FLAG_C             @ was carry set?\n");
		fprintf(wr,"    orrne  r1,r1,#128               @ if so, set bit 7\n");
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]       @ save reg\n",REG8STR(a1));
		fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
		fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
		fprintf(wr,"    tsts   r4,#1                 @ was bottom bit set?\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
	else
	{
		fprintf(wr,"    tsts   r6,#FLAG_C             @ was carry set?\n");
		fprintf(wr,"    orrne  r5,r5,#256               @ if so, set bit 7\n");
		fprintf(wr,"    tsts   r5,#1                 @ was bottom bit set?\n");
		fprintf(wr,"    mov    r5,r5,lsr#1              @ shift\n");
		fprintf(wr,"    ldrb   r6,[r11,r5]              @ get flags\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
}
void AsmEmit_RLC_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r4,[r13,#OFFSET_%s]       @ get reg\n",REG8STR(a1));
		fprintf(wr,"    mov    r1,r4,lsl#1              @ shift\n");
		fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
		fprintf(wr,"    orrne  r1,r1,#1                 @ if so, set bit zero\n");
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]       @ save reg\n",REG8STR(a1));
		fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
		fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
		fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
	else
	{
		fprintf(wr,"    mov    r5,r5,lsl#1              @ shift\n");
		fprintf(wr,"    tsts   r5,#256               @ was top bit set?\n");
		fprintf(wr,"    orrne  r5,r5,#1                 @ if so, set bit zero\n");
		CLAMP_A();
		fprintf(wr,"    ldrb   r6,[r11,r5]              @ get flags\n");
		fprintf(wr,"    tsts   r5,#1               @ was top bit set?\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
}
void AsmEmit_RRC_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r4,[r13,#OFFSET_%s]       @ get reg\n",REG8STR(a1));
		fprintf(wr,"    mov    r1,r4,lsr#1              @ shift\n");
		fprintf(wr,"    tsts   r4,#1                 @ was bottom bit set?\n");
		fprintf(wr,"    orrne  r1,r1,#128               @ if so, set bit 7\n");
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]       @ save reg\n",REG8STR(a1));
		fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
		fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
		fprintf(wr,"    tsts   r4,#1                 @ was bottom bit set?\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
	else
	{
		fprintf(wr,"    tsts   r5,#1\n");
		fprintf(wr,"    mov    r5,r5,lsr#1\n");
		fprintf(wr,"    orrne  r5,r5,#128\n");
		fprintf(wr,"    ldrb   r6,[r11,r5]\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C\n");
	}
}
void AsmEmit_SLL_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r4,[r13,#OFFSET_%s]       @ get reg\n",REG8STR(a1));
		fprintf(wr,"    mov    r1,r4,lsl#1              @ shift\n");
		fprintf(wr,"    orr    r1,r1,#1                 @ set bit zero\n");
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]       @ save reg\n",REG8STR(a1));
		fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
		fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
		fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
	else
	{
		fprintf(wr,"    mov    r5,r5,lsl#1              @ shift\n");
		fprintf(wr,"    orr    r5,r5,#1                 @ set bit zero\n");
		fprintf(wr,"    tsts   r5,#256               @ was top bit set?\n");
		CLAMP_A();
		fprintf(wr,"    ldrb   r6,[r11,r5]              @ get flags\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
}
void AsmEmit_SLA_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r4,[r13,#OFFSET_%s]       @ get reg\n",REG8STR(a1));
		fprintf(wr,"    mov    r1,r4,lsl#1              @ shift\n");
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]       @ save reg\n",REG8STR(a1));
		fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
		fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
		fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
	else
	{
		fprintf(wr,"    mov    r5,r5,lsl#1              @ shift\n");
		fprintf(wr,"    tsts   r5,#256               @ was top bit set?\n");
		CLAMP_A();
		fprintf(wr,"    ldrb   r6,[r11,r5]              @ get flags\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
}
void AsmEmit_SRL_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r4,[r13,#OFFSET_%s]       @ get reg\n",REG8STR(a1));
		fprintf(wr,"    mov    r1,r4,lsr#1              @ shift\n");
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]       @ save reg\n",REG8STR(a1));
		fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
		fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
		fprintf(wr,"    tsts   r4,#1                 @ was bottom bit set?\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
	else
	{
		fprintf(wr,"    tsts   r5,#1                 @ was bottom bit set?\n");
		fprintf(wr,"    mov    r5,r5,lsr#1              @ shift\n");
		fprintf(wr,"    ldrb   r6,[r11,r5]              @ get flags\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
}
void AsmEmit_SRA_REG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=7)
	{
		fprintf(wr,"    ldrb   r4,[r13,#OFFSET_%s]       @ get reg\n",REG8STR(a1));
		fprintf(wr,"    mov    r1,r4,lsr#1              @ shift\n");
		fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
		fprintf(wr,"    orrne  r1,r1,#128               @ preserve sign!\n");
		fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]       @ save reg\n",REG8STR(a1));
		fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
		fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
		fprintf(wr,"    tsts   r4,#1                 @ was bottom bit set?\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
	else
	{
		fprintf(wr,"    tsts   r5,#128\n");
		fprintf(wr,"    orrne  r5,r5,#256\n");
		fprintf(wr,"    tsts   r5,#1                 @ was bottom bit set?\n");
		fprintf(wr,"    mov    r5,r5,lsr#1              @ shift\n");
		fprintf(wr,"    ldrb   r6,[r11,r5]              @ get flags\n");
		fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_RL_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(4,2,false);	//fprintf(wr,"    ldrb   r4,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r4,lsl#1              @ shift\n");
	fprintf(wr,"    tsts   r6,#FLAG_C             @ was carry set?\n");
	fprintf(wr,"    orrne  r1,r1,#1                 @ if so, set bit zero\n");
	fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
//	fprintf(wr,"    add    r3,r3,#TABLE_OFFSET_ROTATE\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
	fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	EmitWrite8(1);
}
void AsmEmit_RR_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(4,2,false);	//fprintf(wr,"    ldrb   r4,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r4,lsr#1              @ shift\n");
	fprintf(wr,"    tsts   r6,#FLAG_C             @ was carry set?\n");
	fprintf(wr,"    orrne  r1,r1,#128               @ if so, set bit 7\n");
	fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
//	fprintf(wr,"    add    r3,r3,#TABLE_OFFSET_ROTATE\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
	fprintf(wr,"    tsts   r4,#1                 @ was bottom bit set?\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	EmitWrite8(1);
}
void AsmEmit_RLC_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(4,2,false);	//fprintf(wr,"    ldrb   r4,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r4,lsl#1              @ shift\n");
	fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
	fprintf(wr,"    orrne  r1,r1,#1                 @ if so, set bit zero\n");
	fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
//	fprintf(wr,"    add    r3,r3,#TABLE_OFFSET_ROTATE\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
	fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	EmitWrite8(1);
}
void AsmEmit_RRC_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(4,2,false);	//fprintf(wr,"    ldrb   r4,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r4,lsr#1              @ shift\n");
	fprintf(wr,"    tsts   r4,#1                 @ was bottom bit set?\n");
	fprintf(wr,"    orrne  r1,r1,#128               @ if so, set bit 7\n");
	fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
//	fprintf(wr,"    add    r3,r3,#TABLE_OFFSET_ROTATE\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
	fprintf(wr,"    tsts   r4,#1                 @ was bottom bit set?\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	EmitWrite8(1);
}
void AsmEmit_SLL_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(4,2,false);	//fprintf(wr,"    ldrb   r4,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r4,lsl#1              @ shift\n");
	fprintf(wr,"    orr    r1,r1,#1                 @ set bit zero\n");
	fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
//	fprintf(wr,"    add    r3,r3,#TABLE_OFFSET_ROTATE\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
	fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	EmitWrite8(1);
}
void AsmEmit_SLA_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(4,2,false);	//fprintf(wr,"    ldrb   r4,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r4,lsl#1              @ shift\n");
	fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
//	fprintf(wr,"    add    r3,r3,#TABLE_OFFSET_ROTATE\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
	fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	EmitWrite8(1);
}
void AsmEmit_SRL_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(4,2,false);	//fprintf(wr,"    ldrb   r4,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r4,lsr#1              @ shift\n");
	fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
//	fprintf(wr,"    add    r3,r3,#TABLE_OFFSET_ROTATE\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
	fprintf(wr,"    tsts   r4,#1                 @ was bottom bit set?\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	EmitWrite8(1);
}
void AsmEmit_SRA_IHL(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(4,2,false);	//fprintf(wr,"    ldrb   r4,[r10,r2]\n");
	fprintf(wr,"    mov    r1,r4,lsr#1              @ shift\n");
	fprintf(wr,"    tsts   r4,#128               @ was top bit set?\n");
	fprintf(wr,"    orrne  r1,r1,#128               @ preserve sign!\n");
	fprintf(wr,"    and    r3,r1,#0xFF              @ get table offset\n");
//	fprintf(wr,"    add    r3,r3,#TABLE_OFFSET_ROTATE\n");
	fprintf(wr,"    ldrb   r6,[r11,r3]              @ get flags\n");
	fprintf(wr,"    tsts   r4,#1                 @ was bottom bit set?\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_C             @ if so, set carry\n");
	EmitWrite8(1);
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_RLD(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(4,2,false);	//fprintf(wr,"    ldrb   r4,[r10,r2]\n");
	fprintf(wr,"    mov    r3,r5  @   A:B\n");
	fprintf(wr,"    mov    r4,r4,lsl#4        @ C:D:0\n");
	fprintf(wr,"    and    r5,r3,#0x0F        @   0:B\n");
	fprintf(wr,"    orr    r1,r4,r5           @ C:D:B\n");
	fprintf(wr,"    and    r3,r3,#0xF0        @   A:0\n");
	fprintf(wr,"    mov    r4,r4,lsr#8        @   0:C\n");
	fprintf(wr,"    orr    r3,r3,r4           @   A:C\n");
	fprintf(wr,"    mov    r5,r3\n");
	EmitWrite8(1);

	fprintf(wr,"    and    r6,r6,#FLAG_C\n");
	fprintf(wr,"    ldrb   r1,[r11,r3]              @ get flags\n");
	fprintf(wr,"    orr    r6,r6,r1\n");
}
void AsmEmit_RRD(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitIHLPreamble(prefix);
	AsmEmitFetch8(4,2,false);	//fprintf(wr,"    ldrb   r4,[r10,r2]\n");
	fprintf(wr,"    mov    r3,r5  @   A:B\n");
	fprintf(wr,"    mov    r3,r3,lsl#4        @ A:B:0\n");
	fprintf(wr,"    mov    r5,r4,lsr#4        @   0:C\n");
	fprintf(wr,"    orr    r1,r3,r5           @ A:B:C\n");
	fprintf(wr,"    and    r4,r4,#0x0F        @   0:D\n");
	fprintf(wr,"    mov    r3,r3,lsr#4        @   A:B\n");
	fprintf(wr,"    and    r3,r3,#0xF0        @   A:0\n");
	fprintf(wr,"    orr    r3,r3,r4           @   A:D\n");
	fprintf(wr,"    mov    r5,r3\n");
	EmitWrite8(1);

	fprintf(wr,"    and    r6,r6,#FLAG_C\n");
	fprintf(wr,"    ldrb   r1,[r11,r3]              @ get flags\n");
	fprintf(wr,"    orr    r6,r6,r1\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_LD_A_I(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrb   r5,[r13,#OFFSET_I]\n");
	fprintf(wr,"iff_check:\n");
	fprintf(wr,"    ldrb   r2,[r11,r1]\n");
	fprintf(wr,"    and    r2,r2,#(FLAG_S|FLAG_Z)\n");
	fprintf(wr,"    ldrb   r3,[r13,#OFFSET_IFF]\n");
	fprintf(wr,"    tsts   r3,#2\n");
	fprintf(wr,"    orrne  r2,r2,#FLAG_P\n");
	fprintf(wr,"    and    r6,r6,#FLAG_C\n");
	fprintf(wr,"    orr    r6,r6,r2\n");

}
void AsmEmit_LD_A_R(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrb   r5,[r13,#OFFSET_R]\n");
	fprintf(wr,"    orr    r5,r5,#0x80\n");
	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_RINC]\n");
	fprintf(wr,"    cmps   r1,#8\n");
	fprintf(wr,"    addne  r1,r5,r1\n");
	fprintf(wr,"    mvneq  r1,r9\n");
	fprintf(wr,"    moveq  r1,r1,lsr#2\n");
	fprintf(wr,"    strb   r1,[r13,#OFFSET_R]\n");
	fprintf(wr,"    b      iff_check\n");
}
void AsmEmit_LD_I_A(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    strb   r5,[r13,#OFFSET_I]\n");
}
void AsmEmit_LD_R_A(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    strb   r5,[r13,#OFFSET_R]\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_WRITE_DREG_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch16(2,12,3);
	fprintf(wr,"    add    r12,r12,#2          @ inc PC\n");
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_%s]  @ get reg\n",REG16STR(a1));
	EmitWrite16();
}
void AsmEmit_READ_DREG_ADDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch16(2,12,3);
	fprintf(wr,"    add    r12,r12,#2          @ inc PC\n");
	AsmEmitFetch16(1,2,3);
	fprintf(wr,"    strh   r1,[r13,#OFFSET_%s]  @ get reg\n",REG16STR(a1));
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_IM_0(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov   r1,#0               @ set mode\n");
	fprintf(wr,"    strb  r1,[r13,#OFFSET_IM]\n");
}
void AsmEmit_IM_1(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov   r1,#1               @ set mode\n");
	fprintf(wr,"    strb  r1,[r13,#OFFSET_IM]\n");
}
void AsmEmit_IM_2(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov   r1,#2               @ set mode\n");
	fprintf(wr,"    strb  r1,[r13,#OFFSET_IM]\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_RETI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_SP]  @ get SP\n");
	AsmEmitFetch16(3,2,4);
	fprintf(wr,"    mov    r12,r3\n");
	fprintf(wr,"    add    r2,r2,#2            @ inc SP\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_SP]  @ write back\n");
}
void AsmEmit_RETN(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_SP]  @ get SP\n");
	AsmEmitFetch16(3,2,4);
	fprintf(wr,"    mov    r12,r3\n");
	fprintf(wr,"    add    r2,r2,#2            @ inc SP\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_SP]  @ write back\n");
	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_IFF] @ get IFF bits\n");
	fprintf(wr,"    tsts   r1,#IFF_2            @ IFF2 set?\n");
	fprintf(wr,"    orrne  r1,r1,#IFF_1         @ if so, set IFF1\n");
	fprintf(wr,"    andeq  r1,r1,#~IFF_1        @ if not, reset IFF1\n");
	fprintf(wr,"    strb   r1,[r13,#OFFSET_IFF] @ save IFF bits\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_NEG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    add    r2,r5,#TABLE_OFFSET_SUB  @ get table offset\n");
	fprintf(wr,"    ldrb   r6,[r11,r2]             @ get flags\n");
	fprintf(wr,"    eor    r2,r2,r2                @ r2=0\n");
	fprintf(wr,"    sub    r5,r2,r5                @ r2=0-A\n");
	CLAMP_A();
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_ADC_HL_DREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrb   r4,[r13,#OFFSET_%s]         @ get lo2\n",REG16LOSTR(2));
	fprintf(wr,"    ldrb   r2,[r13,#OFFSET_%s]         @ get lo1\n",REG16LOSTR(a1));
	fprintf(wr,"    add    r4,r4,r2                  @ add them\n");
	fprintf(wr,"    tsts   r6,#FLAG_C                 @ test carry flag\n");
	fprintf(wr,"    addne  r4,r4,#1                  @ increment if applicable\n");
	fprintf(wr,"    strb   r4,[r13,#OFFSET_%s]         @ store\n",REG16LOSTR(2));
	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]         @ get lo2\n",REG16HISTR(2));
	fprintf(wr,"    ldrb   r2,[r13,#OFFSET_%s]         @ get lo1\n",REG16HISTR(a1));
	fprintf(wr,"    mov    r3,r1,lsl#8               @ build table entry\n");
	fprintf(wr,"    add    r3,r3,r2\n");
	fprintf(wr,"    add    r3,r3,#TABLE_OFFSET_ADD\n");
	fprintf(wr,"    add    r1,r1,r2                  @ do the add\n");
	fprintf(wr,"    tsts   r4,#256                   @ was there a carry from the low half?\n");
	fprintf(wr,"    addne  r1,r1,#1                  @ if so, increment result\n");
	fprintf(wr,"    addne  r3,r3,#65536              @ and mess with table ptr\n");
	fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]         @ save hi part\n",REG16HISTR(2));
	fprintf(wr,"    ldrb   r6,[r11,r3]               @ fetch flags\n");
	fprintf(wr,"    tsts   r4,#0xFF                @ lo part non-zero?\n");
	fprintf(wr,"    andne  r6,r6,#~FLAG_Z             @ reset zero flag\n");
}
void AsmEmit_SBC_HL_DREG(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrb   r4,[r13,#OFFSET_%s]         @ get lo2\n",REG16LOSTR(2));
	fprintf(wr,"    ldrb   r2,[r13,#OFFSET_%s]         @ get lo1\n",REG16LOSTR(a1));
	fprintf(wr,"    sub    r4,r4,r2                  @ sub them\n");
	fprintf(wr,"    tsts   r6,#FLAG_C                 @ test carry flag\n");
	fprintf(wr,"    subne  r4,r4,#1                  @ decrement if applicable\n");
	fprintf(wr,"    strb   r4,[r13,#OFFSET_%s]         @ store\n",REG16LOSTR(2));

	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]         @ get lo2\n",REG16HISTR(2));
	fprintf(wr,"    ldrb   r2,[r13,#OFFSET_%s]         @ get lo1\n",REG16HISTR(a1));
	fprintf(wr,"    mov    r3,r1,lsl#8               @ build table entry\n");
	fprintf(wr,"    add    r3,r3,r2\n");
	fprintf(wr,"    add    r3,r3,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    sub    r1,r1,r2                  @ do the sub\n");
	fprintf(wr,"    tsts   r4,#0x80000000         @ was there a borrow from the low half?\n");
	fprintf(wr,"    subne  r1,r1,#1                  @ if so, increment result\n");
	fprintf(wr,"    addne  r3,r3,#65536              @ and mess with table ptr\n");
	fprintf(wr,"    strb   r1,[r13,#OFFSET_%s]         @ save hi part\n",REG16HISTR(2));
	fprintf(wr,"    ldrb   r6,[r11,r3]               @ fetch flags\n");
	fprintf(wr,"    tsts   r4,#0xFF                @ lo part non-zero?\n");
	fprintf(wr,"    andne  r6,r6,#~FLAG_Z             @ reset zero flag\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_LDI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_DE]\n");
	fprintf(wr,"    ldrh   r3,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    ldrh   r4,[r13,#OFFSET_BC]\n");

	AsmEmitFetch8(1,3,false);	//fprintf(wr,"    ldrb   r1,[r10,r3]\n");
	EmitWrite8(1);
	fprintf(wr,"    add    r2,r2,#1\n");
	fprintf(wr,"    add    r3,r3,#1\n");
	fprintf(wr,"    subs   r4,r4,#1\n");

	fprintf(wr,"    strh   r2,[r13,#OFFSET_DE]\n");
	fprintf(wr,"    strh   r3,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    strh   r4,[r13,#OFFSET_BC]\n");

	fprintf(wr,"    and    r6,r6,#(FLAG_S | FLAG_Z | FLAG_C)\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_P\n");
}
void AsmEmit_LDIR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_DE]\n");
	fprintf(wr,"    ldrh   r3,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    ldrh   r4,[r13,#OFFSET_BC]\n");

	fprintf(wr,"0:\n");
	fprintf(wr,"    sub    r9,r9,#21\n");

	fprintf(wr,"    and    r2,r2,r7\n");
	fprintf(wr,"    and    r3,r3,r7\n");
	fprintf(wr,"    and    r4,r4,r7\n");

	AsmEmitFetch8(1,3,false);	//fprintf(wr,"    ldrb   r1,[r10,r3]\n");
	EmitWrite8(1);
	fprintf(wr,"    add    r2,r2,#1\n");
	fprintf(wr,"    add    r3,r3,#1\n");
	fprintf(wr,"    subs   r4,r4,#1\n");

	fprintf(wr,"    bne    0b\n");

	fprintf(wr,"    strh   r2,[r13,#OFFSET_DE]\n");
	fprintf(wr,"    strh   r3,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    strh   r4,[r13,#OFFSET_BC]\n");

	fprintf(wr,"    and    r6,r6,#(FLAG_S | FLAG_Z | FLAG_C)\n");
}
void AsmEmit_LDD(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_DE]\n");
	fprintf(wr,"    ldrh   r3,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    ldrh   r4,[r13,#OFFSET_BC]\n");

	AsmEmitFetch8(1,3,false);	//fprintf(wr,"    ldrb   r1,[r10,r3]\n");
	EmitWrite8(1);
	fprintf(wr,"    sub    r2,r2,#1\n");
	fprintf(wr,"    sub    r3,r3,#1\n");
	fprintf(wr,"    subs   r4,r4,#1\n");

	fprintf(wr,"    strh   r2,[r13,#OFFSET_DE]\n");
	fprintf(wr,"    strh   r3,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    strh   r4,[r13,#OFFSET_BC]\n");

	fprintf(wr,"    and    r6,r6,#(FLAG_S | FLAG_Z | FLAG_C)\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_P\n");
}
void AsmEmit_LDDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_DE]\n");
	fprintf(wr,"    ldrh   r3,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    ldrh   r4,[r13,#OFFSET_BC]\n");

	fprintf(wr,"0:\n");
	fprintf(wr,"    sub    r9,r9,#21\n");

	fprintf(wr,"    and    r2,r2,r7\n");
	fprintf(wr,"    and    r3,r3,r7\n");
	fprintf(wr,"    and    r4,r4,r7\n");

	AsmEmitFetch8(1,3,false);	//fprintf(wr,"    ldrb   r1,[r10,r3]\n");
	EmitWrite8(1);
	fprintf(wr,"    sub    r2,r2,#1\n");
	fprintf(wr,"    sub    r3,r3,#1\n");
	fprintf(wr,"    subs   r4,r4,#1\n");

	fprintf(wr,"    bne    0b\n");

	fprintf(wr,"    strh   r2,[r13,#OFFSET_DE]\n");
	fprintf(wr,"    strh   r3,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    strh   r4,[r13,#OFFSET_BC]\n");

	fprintf(wr,"    and    r6,r6,#(FLAG_S | FLAG_Z | FLAG_C)\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_CPI(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_BC]\n");
	fprintf(wr,"    mov    r3,r5,lsl#8\n");
	AsmEmitFetch8(4,1,false);	//fprintf(wr,"    ldrb   r4,[r10,r1]\n");
	fprintf(wr,"    orr    r4,r4,r3\n");
	fprintf(wr,"    add    r4,r4,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r4,[r11,r4]\n");
	fprintf(wr,"    and    r4,r4,#~(FLAG_C|FLAG_P)\n");
	fprintf(wr,"    and    r6,r6,#FLAG_C\n");
	fprintf(wr,"    orr    r6,r6,r4\n");
	fprintf(wr,"    add    r1,r1,#1\n");
	fprintf(wr,"    subs   r2,r2,#1\n");
	fprintf(wr,"    strh   r1,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_BC]\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_P\n");
}
void AsmEmit_CPIR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_BC]\n");
	fprintf(wr,"    mov    r3,r5\n");
	fprintf(wr,"0:\n");
	fprintf(wr,"    and    r1,r1,r7\n");
	fprintf(wr,"    and    r2,r2,r7\n");
	AsmEmitFetch8(4,1,false);	//fprintf(wr,"    ldrb   r4,[r10,r1]\n");
	fprintf(wr,"    add    r1,r1,#1\n");
	fprintf(wr,"    sub    r2,r2,#1\n");
	fprintf(wr,"    cmps   r4,r3\n");
	fprintf(wr,"    beq    1f\n");
	fprintf(wr,"    orrs   r2,r2,r2\n");
	fprintf(wr,"    bne    0b\n");
	fprintf(wr,"1:\n");
	fprintf(wr,"    strh   r1,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_BC]\n");
	fprintf(wr,"    mov    r3,r3,lsl#8\n");
	fprintf(wr,"    orr    r4,r4,r3\n");
	fprintf(wr,"    add    r4,r4,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r4,[r11,r4]\n");
	fprintf(wr,"    and    r4,r4,#~(FLAG_C|FLAG_P)\n");
	fprintf(wr,"    and    r6,r6,#FLAG_C\n");
	fprintf(wr,"    orr    r6,r6,r4\n");
	fprintf(wr,"    orrs    r2,r2,r2\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_P\n");
}
void AsmEmit_CPD(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_BC]\n");
	fprintf(wr,"    mov    r3,r5,lsl#8\n");
	AsmEmitFetch8(4,1,false);	//fprintf(wr,"    ldrb   r4,[r10,r1]\n");
	fprintf(wr,"    orr    r4,r4,r3\n");
	fprintf(wr,"    add    r4,r4,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r4,[r11,r4]\n");
	fprintf(wr,"    and    r4,r4,#~(FLAG_C|FLAG_P)\n");
	fprintf(wr,"    and    r6,r6,#FLAG_C\n");
	fprintf(wr,"    orr    r6,r6,r4\n");
	fprintf(wr,"    sub    r1,r1,#1\n");
	fprintf(wr,"    subs   r2,r2,#1\n");
	fprintf(wr,"    strh   r1,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_BC]\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_P\n");
}
void AsmEmit_CPDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrh   r1,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    ldrh   r2,[r13,#OFFSET_BC]\n");
	fprintf(wr,"    mov    r3,r5\n");
	fprintf(wr,"0:\n");
	fprintf(wr,"    and    r1,r1,r7\n");
	fprintf(wr,"    and    r2,r2,r7\n");
	AsmEmitFetch8(4,1,false);	//fprintf(wr,"    ldrb   r4,[r10,r1]\n");
	fprintf(wr,"    sub    r1,r1,#1\n");
	fprintf(wr,"    sub    r2,r2,#1\n");
	fprintf(wr,"    cmps   r4,r3\n");
	fprintf(wr,"    beq    1f\n");
	fprintf(wr,"    orrs   r2,r2,r2\n");
	fprintf(wr,"    bne    0b\n");
	fprintf(wr,"1:\n");
	fprintf(wr,"    strh   r1,[r13,#OFFSET_HL]\n");
	fprintf(wr,"    strh   r2,[r13,#OFFSET_BC]\n");
	fprintf(wr,"    mov    r3,r3,lsl#8\n");
	fprintf(wr,"    orr    r4,r4,r3\n");
	fprintf(wr,"    add    r4,r4,#TABLE_OFFSET_SUB\n");
	fprintf(wr,"    ldrb   r4,[r11,r4]\n");
	fprintf(wr,"    and    r4,r4,#~(FLAG_C|FLAG_P)\n");
	fprintf(wr,"    and    r6,r6,#FLAG_C\n");
	fprintf(wr,"    orr    r6,r6,r4\n");
	fprintf(wr,"    orrs   r2,r2,r2\n");
	fprintf(wr,"    orrne  r6,r6,#FLAG_P\n");
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_OUT_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    mov    r1,r5\n");
	AsmEmitFetch8(2,12,false);	//fprintf(wr,"    ldrb   r2,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1\n");
	fprintf(wr,"    bl     DoOutput\n");
}
void AsmEmit_IN_A_CONST(byte prefix,int32 a1,int32 a2,int32 a3)
{
	AsmEmitFetch8(2,12,false);	//fprintf(wr,"    ldrb   r2,[r10,r12]\n");
	fprintf(wr,"    add    r12,r12,#1\n");
	fprintf(wr,"    mov    r1,r5\n");
	fprintf(wr,"    add    r3,r13,#OFFSET_A\n");\
	fprintf(wr,"    mov    r5,r6\n");
	fprintf(wr,"    bl     DoInput\n");
	fprintf(wr,"    mov    r6,r5             @ preserve flags\n");
	FETCH_A();
}
void AsmEmit_IN_REG_C(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrb   r2,[r13,#OFFSET_C]\n");
	fprintf(wr,"    ldrb   r1,[r13,#OFFSET_B]\n");
	fprintf(wr,"    add    r3,r13,#OFFSET_%s\n",REG8STR(a1));
	fprintf(wr,"    bl     DoInput\n");
	if(a1==7) FETCH_A();
}
void AsmEmit_IN_C(byte prefix,int32 a1,int32 a2,int32 a3)
{
	fprintf(wr,"    ldrb   r6,[r11,r7]\n");
}
void AsmEmit_OUT_REG_C(byte prefix,int32 a1,int32 a2,int32 a3)
{
	if(a1!=6)
	{
		if(a1==7)	fprintf(wr,"    mov    r1,r5\n");
		else		fprintf(wr,"    ldrb   r1,[r13,#OFFSET_%s]\n",REG8STR(a1));
		fprintf(wr,"    ldrb   r2,[r13,#OFFSET_C]\n");
		fprintf(wr,"    bl     DoOutput\n");
	}
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

void AsmEmit_INI(byte prefix,int32 a1,int32 a2,int32 a3)
{
}
void AsmEmit_OUTI(byte prefix,int32 a1,int32 a2,int32 a3)
{
}
void AsmEmit_IND(byte prefix,int32 a1,int32 a2,int32 a3)
{
}
void AsmEmit_OUTD(byte prefix,int32 a1,int32 a2,int32 a3)
{
}
void AsmEmit_INIR(byte prefix,int32 a1,int32 a2,int32 a3)
{
}
void AsmEmit_OTIR(byte prefix,int32 a1,int32 a2,int32 a3)
{
}
void AsmEmit_INDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
}
void AsmEmit_OTDR(byte prefix,int32 a1,int32 a2,int32 a3)
{
}

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

/************************************************************************
 *
 *
 *
 ************************************************************************
 *
 *
 *
 ************************************************************************/

EmitDef asmEmitDefs[]=
{
	{	"LOAD_REG_REG",		AsmEmit_LOAD_REG_REG	},
	{	"LOAD_REG_IHL",		AsmEmit_LOAD_REG_IHL	},
	{	"LOAD_IHL_REG",		AsmEmit_LOAD_IHL_REG	},
	{	"LOAD_REG_CONST",	AsmEmit_LOAD_REG_CONST	},
	{	"LOAD_IHL_CONST",	AsmEmit_LOAD_IHL_CONST	},
	{	"READ_A_BC",		AsmEmit_READ_A_BC	},
	{	"READ_A_DE",		AsmEmit_READ_A_DE	},
	{	"READ_A_ADDR",		AsmEmit_READ_A_ADDR	},
	{	"WRITE_A_BC",		AsmEmit_WRITE_A_BC	},
	{	"WRITE_A_DE",		AsmEmit_WRITE_A_DE	},
	{	"WRITE_A_ADDR",		AsmEmit_WRITE_A_ADDR	},
	{	"LOAD_DREG_CONST",	AsmEmit_LOAD_DREG_CONST	},
	{	"READ_HL_ADDR",		AsmEmit_READ_HL_ADDR	},
	{	"WRITE_HL_ADDR",	AsmEmit_WRITE_HL_ADDR	},
	{	"LOAD_SP_HL",		AsmEmit_LOAD_SP_HL	},
	{	"PUSH_QREG",		AsmEmit_PUSH_QREG	},
	{	"POP_QREG",		AsmEmit_POP_QREG	},
	{	"EX_DE_HL",		AsmEmit_EX_DE_HL	},
	{	"EX_AF_AFF",		AsmEmit_EX_AF_AFF	},
	{	"EXX",			AsmEmit_EXX		},
	{	"EX_ISP_HL",		AsmEmit_EX_ISP_HL	},
	{	"ADD_A_REG",		AsmEmit_ADD_A_REG	},
	{	"ADC_A_REG",		AsmEmit_ADC_A_REG	},
	{	"SUB_A_REG",		AsmEmit_SUB_A_REG	},
	{	"SBC_A_REG",		AsmEmit_SBC_A_REG	},
	{	"CP_A_REG",		AsmEmit_CP_A_REG	},
	{	"ADD_A_IHL",		AsmEmit_ADD_A_IHL	},
	{	"ADC_A_IHL",		AsmEmit_ADC_A_IHL	},
	{	"SUB_A_IHL",		AsmEmit_SUB_A_IHL	},
	{	"SBC_A_IHL",		AsmEmit_SBC_A_IHL	},
	{	"CP_A_IHL",		AsmEmit_CP_A_IHL	},
	{	"ADD_A_CONST",		AsmEmit_ADD_A_CONST	},
	{	"ADC_A_CONST",		AsmEmit_ADC_A_CONST	},
	{	"SUB_A_CONST",		AsmEmit_SUB_A_CONST	},
	{	"SBC_A_CONST",		AsmEmit_SBC_A_CONST	},
	{	"CP_A_CONST",		AsmEmit_CP_A_CONST	},
	{	"AND_A_REG",		AsmEmit_AND_A_REG	},
	{	"OR_A_REG",		AsmEmit_OR_A_REG	},
	{	"XOR_A_REG",		AsmEmit_XOR_A_REG	},
	{	"AND_A_IHL",		AsmEmit_AND_A_IHL	},
	{	"OR_A_IHL",		AsmEmit_OR_A_IHL	},
	{	"XOR_A_IHL",		AsmEmit_XOR_A_IHL	},
	{	"AND_A_CONST",		AsmEmit_AND_A_CONST	},
	{	"OR_A_CONST",		AsmEmit_OR_A_CONST	},
	{	"XOR_A_CONST",		AsmEmit_XOR_A_CONST	},
	{	"INC_REG",		AsmEmit_INC_REG		},
	{	"DEC_REG",		AsmEmit_DEC_REG		},
	{	"INC_IHL",		AsmEmit_INC_IHL		},
	{	"DEC_IHL",		AsmEmit_DEC_IHL		},
	{	"DAA",			AsmEmit_DAA		},
	{	"CPL",			AsmEmit_CPL		},
	{	"CCF",			AsmEmit_CCF		},
	{	"SCF",			AsmEmit_SCF		},
	{	"NOP",			AsmEmit_NOP		},
	{	"HALT",			AsmEmit_HALT		},
	{	"DI",			AsmEmit_DI		},
	{	"EI",			AsmEmit_EI		},
	{	"ADD_HL_DREG",		AsmEmit_ADD_HL_DREG	},
	{	"JP",			AsmEmit_JP		},
	{	"JP_COND",		AsmEmit_JP_COND		},
	{	"JR",			AsmEmit_JR		},
	{	"JR_C_NC",		AsmEmit_JR_C_NC		},
	{	"JR_Z_NZ",		AsmEmit_JR_Z_NZ		},
	{	"JP_HL",		AsmEmit_JP_HL		},
	{	"DJNZ",			AsmEmit_DJNZ		},
	{	"CALL",			AsmEmit_CALL		},
	{	"CALL_COND",		AsmEmit_CALL_COND	},
	{	"RET",			AsmEmit_RET		},
	{	"RET_COND",		AsmEmit_RET_COND	},
	{	"RST",			AsmEmit_RST		},
	{	"RLCA",			AsmEmit_RLCA		},
	{	"RLA",			AsmEmit_RLA		},
	{	"RRCA",			AsmEmit_RRCA		},
	{	"RRA",			AsmEmit_RRA		},
	{	"BIT_B_REG",		AsmEmit_BIT_B_REG	},
	{	"BIT_B_IHL",		AsmEmit_BIT_B_IHL	},
	{	"SET_B_REG",		AsmEmit_SET_B_REG	},
	{	"SET_B_IHL",		AsmEmit_SET_B_IHL	},
	{	"RES_B_REG",		AsmEmit_RES_B_REG	},
	{	"RES_B_IHL",		AsmEmit_RES_B_IHL	},
	{	"RL_REG",		AsmEmit_RL_REG		},
	{	"RR_REG",		AsmEmit_RR_REG		},
	{	"RLC_REG",		AsmEmit_RLC_REG		},
	{	"RRC_REG",		AsmEmit_RRC_REG		},
	{	"SLL_REG",		AsmEmit_SLL_REG		},
	{	"SLA_REG",		AsmEmit_SLA_REG		},
	{	"SRL_REG",		AsmEmit_SRL_REG		},
	{	"SRA_REG",		AsmEmit_SRA_REG		},
	{	"RL_IHL",		AsmEmit_RL_IHL		},
	{	"RR_IHL",		AsmEmit_RR_IHL		},
	{	"RLC_IHL",		AsmEmit_RLC_IHL		},
	{	"RRC_IHL",		AsmEmit_RRC_IHL		},
	{	"SLL_IHL",		AsmEmit_SLL_IHL		},
	{	"SLA_IHL",		AsmEmit_SLA_IHL		},
	{	"SRL_IHL",		AsmEmit_SRL_IHL		},
	{	"SRA_IHL",		AsmEmit_SRA_IHL		},

	{	"LD_A_I",		AsmEmit_LD_A_I		},
	{	"LD_A_R",		AsmEmit_LD_A_R		},
	{	"LD_I_A",		AsmEmit_LD_I_A		},
	{	"LD_R_A",		AsmEmit_LD_R_A		},
	{	"WRITE_DREG_ADDR",	AsmEmit_WRITE_DREG_ADDR	},
	{	"READ_DREG_ADDR",	AsmEmit_READ_DREG_ADDR	},
	{	"IM_0",			AsmEmit_IM_0		},
	{	"IM_1",			AsmEmit_IM_1		},
	{	"IM_2",			AsmEmit_IM_2		},
	{	"RETI",			AsmEmit_RETI		},
	{	"RETN",			AsmEmit_RETN		},
	{	"NEG",			AsmEmit_NEG		},

	{	"LDI",			AsmEmit_LDI		},
	{	"LDIR",			AsmEmit_LDIR		},
	{	"LDD",			AsmEmit_LDD		},
	{	"LDDR",			AsmEmit_LDDR		},
	{	"CPI",			AsmEmit_CPI		},
	{	"CPIR",			AsmEmit_CPIR		},
	{	"CPD",			AsmEmit_CPD		},
	{	"CPDR",			AsmEmit_CPDR		},

	{	"RRD",			AsmEmit_RRD		},
	{	"RLD",			AsmEmit_RLD		},

	{	"INC_DREG",		AsmEmit_INC_DREG	},
	{	"DEC_DREG",		AsmEmit_DEC_DREG	},
	{	"ADC_HL_DREG",		AsmEmit_ADC_HL_DREG	},
	{	"SBC_HL_DREG",		AsmEmit_SBC_HL_DREG	},

	{	"IN_A_CONST",		AsmEmit_IN_A_CONST	},
	{	"OUT_A_CONST",		AsmEmit_OUT_A_CONST	},
	{	"IN_REG_C",		AsmEmit_IN_REG_C	},
	{	"OUT_REG_C",		AsmEmit_OUT_REG_C	},
	{	"IN_C",			AsmEmit_IN_C		},

	{	"OUTI",			AsmEmit_OUTI		},
	{	"OTIR",			AsmEmit_OTIR		},
	{	"OUTD",			AsmEmit_OUTD		},
	{	"OTDR",			AsmEmit_OTDR		},
	{	"INI",			AsmEmit_INI		},
	{	"INIR",			AsmEmit_INIR		},
	{	"IND",			AsmEmit_IND		},
	{	"INDR",			AsmEmit_INDR		},

};

